Package: desc
Title: Manipulate DESCRIPTION Files
Version: 1.4.3
Authors@R: c(
    person("Gábor", "Csárdi", , "csardi.gabor@gmail.com", role = c("aut", "cre")),
    person("Kirill", "Müller", role = "aut"),
    person("Jim", "Hester", , "james.f.hester@gmail.com", role = "aut"),
    person("Maëlle", "Salmon", role = "ctb",
           comment = c(ORCID = "0000-0002-2815-0399")),
    person("Posit Software, PBC", role = c("cph", "fnd"))
  )
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Description: Tools to read, write, create, and manipulate DESCRIPTION
    files.  It is intended for packages that create or manipulate other
    packages.
License: MIT + file LICENSE
URL: https://desc.r-lib.org/, https://github.com/r-lib/desc
BugReports: https://github.com/r-lib/desc/issues
Depends: R (>= 3.4)
Imports: cli, R6, utils
Suggests: callr, covr, gh, spelling, testthat, whoami, withr
Config/Needs/website: tidyverse/tidytemplate
Config/testthat/edition: 3
Encoding: UTF-8
Language: en-US
RoxygenNote: 7.2.3
Collate: 'assertions.R' 'authors-at-r.R' 'built.R' 'classes.R'
        'collate.R' 'constants.R' 'deps.R' 'desc-package.R'
        'description.R' 'encoding.R' 'find-package-root.R' 'latex.R'
        'non-oo-api.R' 'package-archives.R' 'read.R' 'remotes.R'
        'str.R' 'syntax_checks.R' 'urls.R' 'utils.R' 'validate.R'
        'version.R'
NeedsCompilation: no
Packaged: 2023-12-10 11:07:50 UTC; gaborcsardi
Author: Gábor Csárdi [aut, cre],
  Kirill Müller [aut],
  Jim Hester [aut],
  Maëlle Salmon [ctb] (<https://orcid.org/0000-0002-2815-0399>),
  Posit Software, PBC [cph, fnd]
Repository: CRAN
Date/Publication: 2023-12-10 11:40:08 UTC
Built: R 4.4.0; ; 2026-07-17 18:01:37 UTC; unix

Package: desc
Title: Manipulate DESCRIPTION Files
Version: 1.4.3
Authors@R: c(
    person("Gábor", "Csárdi", , "csardi.gabor@gmail.com", role = c("aut", "cre")),
    person("Kirill", "Müller", role = "aut"),
    person("Jim", "Hester", , "james.f.hester@gmail.com", role = "aut"),
    person("Maëlle", "Salmon", role = "ctb",
           comment = c(ORCID = "0000-0002-2815-0399")),
    person("Posit Software, PBC", role = c("cph", "fnd"))
  )
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Description: Tools to read, write, create, and manipulate DESCRIPTION
    files.  It is intended for packages that create or manipulate other
    packages.
License: MIT + file LICENSE
URL: https://desc.r-lib.org/, https://github.com/r-lib/desc
BugReports: https://github.com/r-lib/desc/issues
Depends: R (>= 3.4)
Imports: cli, R6, utils
Suggests: callr, covr, gh, spelling, testthat, whoami, withr
Config/Needs/website: tidyverse/tidytemplate
Config/testthat/edition: 3
Encoding: UTF-8
Language: en-US
RoxygenNote: 7.2.3
Collate: 'assertions.R' 'authors-at-r.R' 'built.R' 'classes.R'
        'collate.R' 'constants.R' 'deps.R' 'desc-package.R'
        'description.R' 'encoding.R' 'find-package-root.R' 'latex.R'
        'non-oo-api.R' 'package-archives.R' 'read.R' 'remotes.R'
        'str.R' 'syntax_checks.R' 'urls.R' 'utils.R' 'validate.R'
        'version.R'
NeedsCompilation: no
Packaged: 2023-12-10 11:07:50 UTC; gaborcsardi
Author: Gábor Csárdi [aut, cre],
  Kirill Müller [aut],
  Jim Hester [aut],
  Maëlle Salmon [ctb] (<https://orcid.org/0000-0002-2815-0399>),
  Posit Software, PBC [cph, fnd]
Repository: CRAN
Date/Publication: 2023-12-10 11:40:08 UTC

Package: desc
Title: Manipulate DESCRIPTION Files
Version: 1.0.0
Author: Gábor Csárdi
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Description: Tools to read, write, create, and manipulate DESCRIPTION
    files. It is intented for packages that create or manipulate other
    packages.
License: MIT + file LICENSE
Imports:
    httrmock,
    lintr
Remotes:
    jimhester/lintr
Encoding: UTF-8
Remotes:
    gaborcsardi/httrmock

Package: roxygen2
Title: In-Source Documentation for R
Description: A 'Doxygen'-like in-source documentation system
    for Rd, collation, and 'NAMESPACE' files.
URL: https://github.com/klutometis/roxygen
Version: 4.1.1.9000
License: GPL (>= 2)
Authors@R: c(
    person("Hadley", "Wickham",, "h.wickham@gmail.com", c("aut", "cre", "cph"), comment = c(ORCID = "0000-0003-4757-117X")),
    person("Peter", "Danenberg",, "pcd@roxygen.org", c("aut", "cph")),
    person("Peter", "Doe",, "pcd@roxygen.org", c("aut", "cph")),
    person("Manuel", "Eugster", role = c("aut", "cph")),
    person("RStudio", role = "cph")
    )
Depends:
    R (>= 3.0.2)
Imports:
    stringr (>= 0.5),
    brew,
    digest,
    methods,
    Rcpp (>= 0.11.0)
Suggests:
    testthat (>= 0.8.0),
    knitr
VignetteBuilder: knitr
LinkingTo: Rcpp
Collate:
    'RcppExports.R'
    'alias.R'
    'description.R'
    'family.R'
    'inherit-params.R'
    'minidesc.R'
    'object-defaults.R'
    'object-from-call.R'
    'object.R'
    'order-params.R'
    'parse-preref.R'
    'parse-registry.R'
    'parse.R'
    'rc.R'
    'rd-escape.R'
    'rd-file-api.R'
    'rd-parse.R'
    'rd-tag-api.R'
    'roclet-collate.R'
    'roclet-namespace.R'
    'roclet-rd.R'
    'roclet-vignette.R'
    'roclet.R'
    'roxygen.R'
    'roxygenize.R'
    's3.R'
    'safety.R'
    'source.R'
    'template.R'
    'topic-name.R'
    'topo-sort.R'
    'usage.R'
    'util-locale.R'
    'utils.R'
RoxygenNote: 4.1.1.9000
Encoding: UTF-8
Remotes: foo/digest, svn::https://github.com/hadley/stringr,
    local::/pkgs/testthat

Package: pkgname
Version: 0.5-1
Date: 2015-01-01
Title: My First Collection of Functions
Author: Joe Developer [aut, cre],
  Pat Developer [aut],
  A. User [ctb]
Maintainer: Joe Developer <Joe.Developer@some.domain.net>
Depends: R (>= 3.1.0), nlme
Suggests: MASS
Description: A (one paragraph) description of what
  the package does and why it may be useful.
License: GPL (>= 2)
URL: https://cran.r-project.org/doc/manuals/R-exts.html#The-DESCRIPTION-file
BugReports: https://pkgname.bugtracker.url

Package: desc
Title: Manipulate DESCRIPTION Files
Version: 1.0.0
Author: Gábor Csárdi
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Description: Tools to read, write, create, and manipulate DESCRIPTION
    files. It is intented for packages that create or manipulate other
    packages.
License: MIT + file LICENSE
Depends:
Encoding: UTF-8
Built: R 3.4.1; x86_64-apple-darwin15.6.0; 2017-09-14 20:30:19 UTC; unix

Package: doBy
Version: 4.5-15
Title: Groupwise Statistics, LSmeans, Linear Contrasts, Utilities
Author: Søren Højsgaard <sorenh@math.aau.dk> and Ulrich Halekoh <uhalekoh@health.sdu.dk> 
Maintainer: Søren Højsgaard <sorenh@math.aau.dk>
Description: The facilities can roughly be grouped as: 
 .
   1) Facilities for groupwise computations of summary statistics and
 other facilities for working with grouped data: 'do' something to data 
 stratified 'by' some variables.  
 .
   2) LSmeans (least-squares means), general linear contrasts.
 .
   3) Miscellaneous other utilities.
Encoding: latin1
URL: http://people.math.aau.dk/~sorenh/software/doBy/
ZipData: no
License: GPL (>= 2)
Depends: R (>= 3.2.0), methods
Imports: MASS, Matrix
Suggests: pbkrtest (>= 0.4-6), ggplot2, multcomp, geepack, lme4
        (>= 1.0.0), survival (>=
        1.0.1)
NeedsCompilation: no
Packaged: 2016-03-31 03:26:07 UTC; sorenh
Repository: CRAN
Date/Publication: 2016-03-31 17:38:50

Package: desc
Title: Manipulate DESCRIPTION Files
Version: 1.0.0
Author: Gábor Csárdi
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Description: Tools to read, write, create, and manipulate DESCRIPTION
    files. It is intented for packages that create or manipulate other
    packages.
License: MIT + file LICENSE

URL: https://github.com/r-pkgs/desc
BugReports: https://github.com/r-pkgs/desc/issues
Imports:
    R6
Suggests:
    testthat
VignetteBuilder: knitr
Encoding: UTF-8

Package: SAPP
Title: Statistical Analysis of Point Processes
Version: 1.0.8
Authors@R (parsed):
    * Masami Saga <msaga@mtb.biglobe.ne.jp> [cre]
    * The Institute of Statistical Mathematics [aut]
Author: The Institute of Statistical Mathematics
Maintainer: Masami Saga <msaga@mtb.biglobe.ne.jp>
Description: Functions for statistical analysis of point
    processes.
License: GPL (>= 2)
Depends:
    R (>= 3.5.0)
Imports:
    graphics,
    grDevices
Date/Publication: 2020-06-02 23:30:09 UTC
MailingList: Please send bug reports to ismrp@jasp.ism.ac.jp
NeedsCompilation: yes
Packaged: 2020-05-31 07:35:42 UTC; msaga
Repository: CRAN

Package: hunspell
Type: Package
Title: High-Performance Stemmer, Tokenizer, and Spell Checker
Version: 2.9
Depends: R (>= 3.0.2)
Encoding: UTF-8
Authors@R: c(
    person("Jeroen", "Ooms", ,"jeroen@berkeley.edu", role = c("aut", "cre")),
    person("Authors of libhunspell", role = "cph", comment = "see AUTHORS file"))
Description: Low level spell checker and morphological analyzer based on the
    famous 'hunspell' library <https://hunspell.github.io>. The package can analyze
    or check individual words as well as parse text, latex, html or xml documents.
    For a more user-friendly interface use the 'spelling' package which builds on
    this package to automate checking of files, documentation and vignettes in all
    common formats.
License: GPL-2 | LGPL-2.1 | MPL-1.1
URL:
    https://github.com/ropensci/hunspell#readme (devel)
    https://hunspell.github.io (upstream)
BugReports: https://github.com/ropensci/hunspell/issues
Imports: Rcpp, digest
LinkingTo: Rcpp (>= 0.12.12)
Suggests: spelling,
    testthat,
    pdftools,
    janeaustenr,
    wordcloud2,
    knitr,
    rmarkdown
VignetteBuilder: knitr
RoxygenNote: 6.0.1.9000

Type: Package
Package: codemetar
Title: Generate 'CodeMeta' Metadata for R Packages
Version: 0.1.9
Authors@R: 
    c(person(given = "Carl",
             family = "Boettiger",
             role = c("aut", "cre", "cph"),
             email = "cboettig@gmail.com",
             comment = c(ORCID = "0000-0002-1642-628X")),
      person(given = "Anna",
             family = "Krystalli",
             role = c("rev", "ctb"),
             comment = c(ORCID = "0000-0002-2378-4915")),
      person(given = "Toph",
             family = "Allen",
             role = "rev",
             comment = c(ORCID = "0000-0003-4580-091X")),
      person(given = "Maëlle",
             family = "Salmon",
             role = c("ctb", "aut"),
             comment = c(ORCID = "0000-0002-2815-0399")),
      person(given = "rOpenSci",
             role = "fnd",
             comment = "https://ropensci.org/"),
      person(given = "Katrin",
             family = "Leinweber",
             role = "ctb",
             comment = c(ORCID = "0000-0001-5135-5758")),
      person(given = "Noam",
             family = "Ross",
             role = "ctb",
             comment = c(ORCID = "0000-0002-2136-0000")),
      person(given = "Arfon",
             family = "Smith",
             role = "ctb"),
      person(given = "Jeroen",
             family = "Ooms",
             role = "ctb",
             comment = c(ORCID = "0000-0002-4035-0289")),
      person(given = "Sebastian",
             family = "Meyer",
             role = "ctb",
             comment = c(ORCID = "0000-0002-1791-9449")),
      person(given = "Michael",
             family = "Rustler",
             role = "ctb",
             comment = c(ORCID = "0000-0003-0647-7726")),
      person(given = "Hauke",
             family = "Sonnenberg",
             role = "ctb",
             comment = c(ORCID = "0000-0001-9134-2871")),
      person(given = "Sebastian",
             family = "Kreutzer",
             role = "ctb",
             comment = c(ORCID = "0000-0002-0734-2199"))
      )
Description: The 'Codemeta' Project defines a 'JSON-LD' format
    for describing software metadata, as detailed at
    <https://codemeta.github.io>. This package provides utilities to
    generate, parse, and modify 'codemeta.json' files automatically for R
    packages, as well as tools and examples for working with
    'codemeta.json' 'JSON-LD' more generally.
License: GPL-3
URL: https://github.com/ropensci/codemetar, https://docs.ropensci.org/codemetar
BugReports: https://github.com/ropensci/codemetar/issues
Depends: 
    R (>= 3.2.0)
Imports: 
    commonmark,
    crul,
    desc,
    gert,
    gh,
    jsonlite (>= 1.6),
    magrittr,
    memoise,
    methods,
    pingr,
    pkgbuild,
    purrr,
    remotes,
    sessioninfo,
    stats,
    urltools,
    xml2,
    cli
Suggests: 
    covr,
    details,
    dplyr (>= 0.7.0),
    jsonld,
    jsonvalidate,
    knitr,
    printr,
    rmarkdown,
    testthat (>= 2.1.0)
VignetteBuilder: 
    knitr
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.1
X-schema.org-isPartOf: https://ropensci.org
X-schema.org-keywords: metadata, codemeta, ropensci, citation,
    credit, linked-data
Roxygen: list(markdown = TRUE)

Package: igraph
Version: 1.2.6
Title: Network Analysis and Visualization
Author: See AUTHORS file.
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Description: Routines for simple graphs and network analysis. It can
  handle large graphs very well and provides functions for generating random
  and regular graphs, graph visualization, centrality methods and much more.
Depends: methods
Imports: graphics, grDevices, magrittr, Matrix, pkgconfig (>= 2.0.0),
        stats, utils
Suggests: ape, digest, graph, igraphdata, rgl, scales, stats4, tcltk,
        testthat, withr
License: GPL (>= 2)
URL: https://igraph.org
SystemRequirements: gmp (optional), libxml2 (optional), glpk (optional)
BugReports: https://github.com/igraph/igraph/issues
Encoding: UTF-8
RoxygenNote: 7.1.1
Collate: 'adjacency.R' 'auto.R' 'assortativity.R' 'attributes.R'
        'basic.R' 'bipartite.R' 'centrality.R' 'centralization.R'
        'cliques.R' 'cocitation.R' 'cohesive.blocks.R' 'community.R'
        'components.R' 'console.R' 'conversion.R' 'data_frame.R'
        'decomposition.R' 'degseq.R' 'demo.R' 'embedding.R' 'epi.R'
        'fit.R' 'flow.R' 'foreign.R' 'games.R' 'glet.R' 'hrg.R'
        'igraph-package.R' 'incidence.R' 'indexing.R' 'interface.R'
        'iterators.R' 'layout.R' 'layout_drl.R' 'lazyeval.R' 'make.R'
        'minimum.spanning.tree.R' 'motifs.R' 'nexus.R' 'operators.R'
        'other.R' 'package.R' 'palette.R' 'par.R' 'paths.R' 'plot.R'
        'plot.common.R' 'plot.shapes.R' 'pp.R' 'print.R' 'printr.R'
        'random_walk.R' 'rewire.R' 'scan.R' 'scg.R' 'sgm.R'
        'similarity.R' 'simple.R' 'sir.R' 'socnet.R' 'sparsedf.R'
        'structural.properties.R' 'structure.info.R' 'test.R'
        'tkplot.R' 'topology.R' 'triangles.R' 'utils.R' 'uuid.R'
        'versions.R' 'weakref.R' 'zzz-deprecate.R'
NeedsCompilation: yes
Packaged: 2020-10-06 10:36:22 UTC; gaborcsardi
Repository: CRAN
Date/Publication: 2020-10-06 12:40:05 UTC

Package: desc
Title: Manipulate DESCRIPTION Files
Version: 1.0.0
Author: Gábor Csárdi
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Description: Tools to read, write, create, and manipulate DESCRIPTION
    files. It is intented for packages that create or manipulate other
    packages.
License: MIT + file LICENSE
URL: https://github.com/r-pkgs/desc
BugReports: https://github.com/r-pkgs/desc/issues
Imports:
    R6
Suggests:
    testthat
VignetteBuilder: knitr
Encoding: UTF-8

## Deep Embedding for Single-cell Clustering (DESC)

DESC is an unsupervised deep learning algorithm for clustering scRNA-seq data. The algorithm constructs a non-linear mapping function from the original scRNA-seq data space to a low-dimensional feature space by iteratively learning cluster-specific gene expression representation and cluster assignment based on a deep neural network. This iterative procedure moves each cell to its nearest cluster, balances biological and technical differences between clusters, and reduces the influence of the batch effect. DESC also enables soft clustering by assigning a cluster-specific probability to each cell, which facilitates the identification of cells clustered with high-confidence and interpretation of results. 

![DESC workflow](docs/assets/images/desc_workflow.png)

For thorough details, see the preprint: [Bioxiv](https://www.biorxiv.org)
<br>

## Usage

The [**desc**](https://github.com/eleozzr/desc) package is an implementation of deep embedding for single-cell clustering. With desc, you can:

- Preprocess single cell gene expression data from various formats.
- Build a low-dimensional representation of the single-cell gene expression data.
- Obtain soft-clustering assignments of cells.
- Visualize the cell clustering results and gene expression patterns.
<br>

# Installation
To install  `desc` package you must make sure that your python version is one of `python3.5.x`, `python3.6.x`. If you don’t know the version of python you can check it by 

```python
>>>import platform
>>>platform.python_version()
#3.5.3
```
Now you can install the current release of `desc` by the following three ways.

* PyPI  
Directly install the package from PyPI:

```bash
$ pip install desc
```
Note: you need make sure that the `pip` is for python3，or we should install desc by:
```bash 
python3 -m pip install desc 
#or
pip3 install desc
```

If you do not have sudo rights (when you get a permission denied error): 

```bash
$ pip install --user desc
```

* Github  
Download the package from [Github](https://github.com/eleozzr/desc) and install it locally:

```bash
git clone https://github.com/eleozzr/desc
cd desc
pip install .
```

* Anaconda

If you do not have Python3.5 or Python3.6 installed, consider installing Anaconda (see [Installing Anaconda](https://docs.anaconda.com/anaconda/install/)). After installing Anaconda, you can create a new environment, for example, `DESC` (*you can change to any name you like*):

```bash
conda create -n DESC python=3.5.3
# activate your environment 
source activate DESC 
git clone https://github.com/eleozzr/desc
cd desc
python setup.py build
python setup.py install
# now you can check whether `desc` installed successfully!
```

Please check desc [Tutorial](https://eleozzr.github.io/desc/tutorial.html) for more details.

<br>

## Contributing

Souce code: [Github](https://github.com/eleozzr/desc)  

We are continuing adding new features. Bug reports or feature requests are welcome ([mingyao.lab@gmail.com](mailto:mingyao.lab@gmail.com)).

<br>

## References

Please consider citing the following reference:

- Xiangjie Li, Yafei Lyu, Jihwan Park, Jingxiao Zhang, Dwight Stambolian, Katalin Susztak, Gang Hu, Mingyao Li. Deep learning enables accurate clustering and batch effect removal in single-cell RNA-seq analysis (2019) [https://www.biorxiv.org](https://www.biorxiv.org)
<br>

## Licence

Copyright (C) 2019 Mingyao's Lab

# desc

> Parse DESCRIPTION files

<!-- badges: start -->

[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-green.svg)](https://lifecycle.r-lib.org/articles/stages.html)
[![R-CMD-check](https://github.com/r-lib/desc/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/r-lib/desc/actions/workflows/R-CMD-check.yaml)
[![Codecov test
coverage](https://codecov.io/gh/r-lib/desc/branch/main/graph/badge.svg)](https://app.codecov.io/gh/r-lib/desc?branch=main)
[![](https://www.r-pkg.org/badges/version/desc)](https://www.r-pkg.org/pkg/desc)
[![CRAN RStudio mirror
downloads](https://cranlogs.r-pkg.org/badges/desc)](https://www.r-pkg.org/pkg/desc)
<!-- badges: end -->

Parse, manipulate and reformat DESCRIPTION files. The package provides
two APIs, one is object oriented, the other one is procedural and
manipulates the files *in place*.

------------------------------------------------------------------------

- [Installation](#installation)
- [The object oriented API](#the-oo-api)
  - [Introduction](#introduction)
  - [Loading or creating new `DESCRIPTION`
    files](#loading-or-creating-new-description-files)
  - [Normalizing `DESCRIPTION` files](#normalizing-description-files)
  - [Querying, changing and removing
    fields](#querying-changing-and-removing-fields)
  - [Dependencies](#dependencies)
  - [Collate fields](#collate-fields)
  - [Authors](#authors)
- [The procedural API](#the-procedural-api)
- [License](#license)

## Installation

``` r
# Install the released version from CRAN
install.packages("desc")

# Or the development version from GitHub:
# install.packages("pak")
pak::pak("r-lib/desc")
```

## The object oriented API

``` r
library(desc)
```

### Introduction

The object oriented API uses [R6](https://github.com/r-lib/R6) classes.

### Loading or creating new `DESCRIPTION` files

A new `description` object can be created by reading a `DESCRIPTION`
file form the disk. By default the `DESCRIPTION` file in the current
directory is read:

``` r
desc <- description$new()
```

``` r
desc
```

    #> Package: desc
    #> Title: Manipulate DESCRIPTION Files
    #> Version: 1.0.0
    #> Author: Gábor Csárdi
    #> Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
    #> Description: Tools to read, write, create, and manipulate DESCRIPTION
    #>     files.  It is intented for packages that create or manipulate other
    #>     packages.
    #> License: MIT + file LICENSE
    #> URL: https://github.com/r-lib/desc
    #> BugReports: https://github.com/r-lib/desc/issues
    #> Imports:
    #>     R6
    #> Suggests:
    #>     newpackage,
    #>     testthat,
    #>     whoami
    #> Encoding: UTF-8
    #> LazyData: true
    #> RoxygenNote: 5.0.0

A new object can also be created from scratch:

``` r
desc2 <- description$new("!new")
desc2
```

    #> Package: {{ Package }}
    #> Title: {{ Title }}
    #> Version: 1.0.0
    #> Authors@R (parsed):
    #>     * Jo Doe <jodoe@dom.ain> [aut, cre]
    #> Maintainer: {{ Maintainer }}
    #> Description: {{ Description }}
    #> License: {{ License }}
    #> URL: {{ URL }}
    #> BugReports: {{ BugReports }}
    #> Encoding: UTF-8

### Normalizing `DESCRIPTION` files

Most `DESCRIPTION` fields may be formatted in multiple equivalent ways.
`desc` does not reformat fields, unless they are updated or reformatting
is explicitly requested via a call to the `normalize()` method or using
the `normalize` argument of the `write()` method.

### Querying, changing and removing fields

`get()` and `set()` queries or updates a field:

``` r
desc$set("Package", "foo")
desc$get("Package")
```

    #> Package 
    #>   "foo"

They work with multiple fields as well:

``` r
desc$set(Package = "bar", Title = "Bar Package")
desc$get(c("Package", "Title"))
```

    #>       Package         Title 
    #>         "bar" "Bar Package"

### Dependencies

Package dependencies can be set and updated via an easier API:

``` r
desc$get_deps()
```

    #>       type    package version
    #> 1 Suggests   testthat       *
    #> 2 Suggests     whoami       *
    #> 3 Suggests newpackage       *
    #> 4  Imports         R6       *

``` r
desc$set_dep("mvtnorm")
desc$set_dep("Rcpp", "LinkingTo")
desc$get_deps()
```

    #>        type    package version
    #> 1  Suggests   testthat       *
    #> 2  Suggests     whoami       *
    #> 3  Suggests newpackage       *
    #> 4   Imports    mvtnorm       *
    #> 5   Imports         R6       *
    #> 6 LinkingTo       Rcpp       *

``` r
desc
```

    #> Package: bar
    #> Title: Bar Package
    #> Version: 1.0.0
    #> Author: Gábor Csárdi
    #> Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
    #> Description: Tools to read, write, create, and manipulate DESCRIPTION
    #>     files.  It is intented for packages that create or manipulate other
    #>     packages.
    #> License: MIT + file LICENSE
    #> URL: https://github.com/r-lib/desc
    #> BugReports: https://github.com/r-lib/desc/issues
    #> Imports:
    #>     mvtnorm,
    #>     R6
    #> Suggests:
    #>     newpackage,
    #>     testthat,
    #>     whoami
    #> LinkingTo:
    #>     Rcpp
    #> Encoding: UTF-8
    #> LazyData: true
    #> RoxygenNote: 5.0.0

### Collate fields

Collate fields can be queried and set using simple character vectors of
file names:

``` r
desc$set_collate(list.files("../R"))
```

    #> Warning in idesc_set_collate(self, private, files, match.arg(which)): No files
    #> in 'Collate' field

``` r
desc$get_collate()
```

    #> character(0)

### Authors

Authors information, when specified via the `Authors@R` field, also has
a simplified API:

``` r
desc <- description$new("tools/pkg2")
desc$get_authors()
```

    #> [1] "Hadley Wickham <h.wickham@gmail.com> [aut, cre, cph]"
    #> [2] "Peter Danenberg <pcd@roxygen.org> [aut, cph]"        
    #> [3] "Manuel Eugster [aut, cph]"                           
    #> [4] "RStudio [cph]"

``` r
desc$add_author("Bugs", "Bunny", email = "bb@acme.com")
desc$add_me()
desc$add_author_gh("jeroen")
desc$get_authors()
```

    #> [1] "Hadley Wickham <h.wickham@gmail.com> [aut, cre, cph]"
    #> [2] "Peter Danenberg <pcd@roxygen.org> [aut, cph]"        
    #> [3] "Manuel Eugster [aut, cph]"                           
    #> [4] "RStudio [cph]"                                       
    #> [5] "Bugs Bunny <bb@acme.com>"                            
    #> [6] "First Last <first.last@dom.com> [ctb]"               
    #> [7] "Jeroen Ooms <jeroen@berkeley.edu> [ctb]"

If the `Author` field is specified, it can be changed to a `Authors@R`
field using `coerce_authors_at_r()`, incorporating the `Maintainer`
information if necessary:

``` r
desc <- description$new("!new")
desc$del("Authors@R")
desc$del("Maintainer")
desc$set(Author = "Gábor Csárdi <csardi.gabor@gmail.com>")
desc$get_authors()
```

    #> Error in ensure_authors_at_r(self): No 'Authors@R' field!
    #> You can create one with $add_author.
    #> You can also use $coerce_authors_at_r() to change Author fields

``` r
desc$coerce_authors_at_r()
desc$get_authors()
```

    #> [1] "Gábor Csárdi <csardi.gabor@gmail.com> [aut]"

## The procedural API

The procedural API is simpler to use for one-off `DESCRIPTION`
manipulation, since it does not require dealing with `description`
objects. Each object oriented method has a procedural counterpart that
works on a file, and potentially writes its result back to the same
file.

For example, adding a new dependency to `DESCRIPTION` in the current
working directory can be done with

``` r
desc_set_dep("newpackage", "Suggests")
```

    #> Package: desc
    #> Title: Manipulate DESCRIPTION Files
    #> Version: 1.4.2.9000
    #> Authors@R (parsed):
    #>     * Gábor Csárdi <csardi.gabor@gmail.com> [aut, cre]
    #>     * Kirill Müller [aut]
    #>     * Jim Hester <james.f.hester@gmail.com> [aut]
    #>     * Maëlle Salmon [ctb] (<https://orcid.org/0000-0002-2815-0399>)
    #>     * Posit Software, PBC [cph, fnd]
    #> Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
    #> Description: Tools to read, write, create, and manipulate DESCRIPTION
    #>     files.  It is intended for packages that create or manipulate other
    #>     packages.
    #> License: MIT + file LICENSE
    #> URL: https://desc.r-lib.org/, https://github.com/r-lib/desc
    #> BugReports: https://github.com/r-lib/desc/issues
    #> Depends:
    #>     R (>= 3.4)
    #> Imports:
    #>     cli,
    #>     R6,
    #>     utils
    #> Suggests:
    #>     callr,
    #>     covr,
    #>     gh,
    #>     newpackage,
    #>     spelling,
    #>     testthat,
    #>     whoami,
    #>     withr
    #> Config/Needs/website: tidyverse/tidytemplate
    #> Config/testthat/edition: 3
    #> Encoding: UTF-8
    #> Language: en-US
    #> Roxygen: list(r6 = FALSE, load = "installed", markdown = TRUE)
    #> RoxygenNote: 7.2.3
    #> Collate:
    #>     'assertions.R'
    #>     'authors-at-r.R'
    #>     'built.R'
    #>     'classes.R'
    #>     'collate.R'
    #>     'constants.R'
    #>     'deps.R'
    #>     'desc-package.R'
    #>     'description.R'
    #>     'encoding.R'
    #>     'find-package-root.R'
    #>     'latex.R'
    #>     'non-oo-api.R'
    #>     'package-archives.R'
    #>     'read.R'
    #>     'remotes.R'
    #>     'str.R'
    #>     'syntax_checks.R'
    #>     'urls.R'
    #>     'utils.R'
    #>     'validate.R'
    #>     'version.R'

This added `newpackage` to the `Suggests` field:

``` r
desc_get("Suggests")
```

    #>                                                                                                  Suggests 
    #> "\n    callr,\n    covr,\n    gh,\n    newpackage,\n    spelling,\n    testthat,\n    whoami,\n    withr"

So the full list of dependencies are now

``` r
desc_get_deps()
```

    #>        type    package version
    #> 1   Depends          R  >= 3.4
    #> 2   Imports        cli       *
    #> 3   Imports         R6       *
    #> 4   Imports      utils       *
    #> 5  Suggests      callr       *
    #> 6  Suggests       covr       *
    #> 7  Suggests         gh       *
    #> 8  Suggests newpackage       *
    #> 9  Suggests   spelling       *
    #> 10 Suggests   testthat       *
    #> 11 Suggests     whoami       *
    #> 12 Suggests      withr       *

## Code of Conduct

Please note that the desc project is released with a [Contributor Code
of Conduct](https://desc.r-lib.org/CODE_OF_CONDUCT.html). By
contributing to this project, you agree to abide by its terms.

read_dcf <- function(file) {
  lines <- readLines(file)

  con <- textConnection(lines, local = TRUE)
  fields <- colnames(read.dcf(con))
  close(con)

  if (!length(fields)) {
    return(list(
      dcf = create_fields(character(), character()),
      notws = character()
    ))
  }

  con <- textConnection(lines, local = TRUE)
  res <- read.dcf(con, keep.white = fields)
  close(con)

  if (nrow(res) > 1) {
    stop("Empty lines found in DESCRIPTION file", call. = FALSE)
  }

  con <- textConnection(lines, local = TRUE)
  res2 <- read.dcf(con, keep.white = fields, all = TRUE)
  close(con)

  if (any(mismatch <- res != res2)) {
    stop("Duplicate DESCRIPTION fields: ",
         paste(sQuote(colnames(res)[mismatch]), collapse = ", "))
  }

  if ("Encoding" %in% colnames(res)) {
    encoding <- res[, "Encoding"]
    Encoding(res) <- encoding
    res[] <- enc2utf8(res)
    Encoding(lines) <- encoding
    lines <- enc2utf8(lines)
  }

  no_tws_fields <- sub(
    ":$",
    "",
    grep("^[^\\s]+:$", lines, perl = TRUE, value = TRUE)
  )

  notws <- res[1, match(no_tws_fields, fields)]

  list(
    dcf = create_fields(fields, res[1, ]),
    notws = notws
  )
}

parse_urls <- function(urls) {
  out <- str_trim(strsplit(str_trim(urls), "[,\\s]+", perl = TRUE)[[1]])
  grep("^http", out, value = TRUE)
}

deparse_urls <- function(urls) {
  paste(urls, collapse = ",\n    ")
}

idesc_get_urls <- function(self, private) {
  urls <- self$get("URL")
  if (is.na(urls)) {
    character()
  } else {
    parse_urls(urls)
  }
}

idesc_set_urls <- function(self, private, urls) {
  stopifnot(is.character(urls))
  self$set(URL = deparse_urls(urls))
  invisible(self)
}

idesc_add_urls <- function(self, private, urls) {
  stopifnot(is.character(urls))
  urls <- unique(c(self$get_urls(), urls))
  self$set(URL = deparse_urls(urls))
  invisible(self)
}

idesc_del_urls <- function(self, private, pattern) {
  stopifnot(is_string(pattern))
  urls <- self$get_urls()
  filt <- grep(pattern, urls, invert = TRUE, value = TRUE, perl = TRUE)
  if (length(filt) > 0) {
    self$set(URL = deparse_urls(filt))
  } else {
    self$del("URL")
  }
  invisible(self)
}

idesc_clear_urls <- function(self, private) {
  self$del("URL")
  invisible(self)
}

idesc_to_latex <- function(self, private) {
  cols <- field_order(names(private$data))
  col_str <- unlist(lapply(
    cols,
    FUN = function(col) {
      toLatex(private$data[[col]])
    }))

  structure(
    c(
      "\\begin{description}",
      "  \\raggedright{}",
      paste0("  ", col_str, collapse = "\n"),
      "\\end{description}"
    ),
    class = "Latex"
  )
}


#' @importFrom utils toLatex
NULL

#' @export
toLatex.character <- function(object, ...) {
  object <- gsub("'([^ ']*)'", "`\\1'", object, useBytes = TRUE)
  object <- gsub("\"([^\"]*)\"", "``\\1''", object, useBytes = TRUE)
  object <- gsub("\\", "\\textbackslash ", object, fixed = TRUE,
               useBytes = TRUE)
  object <- gsub("([{}$#_^%])", "\\\\\\1", object, useBytes = TRUE)
  object
}

#' @export
toLatex.DescriptionField <- function(object, ...) {
  paste0("\\item[", object$key, "] ", toLatex(object$value))
}

#' @export
toLatex.DescriptionCollate <- function(object, ...) {
  invisible(NULL)
}

#' @export
toLatex.DescriptionURLList <- function(object, ...) {
  paste0("\\item[", object$key, "] ", format_url(parse_url_list(object$value)))
}

#' @export
toLatex.DescriptionURL <- function(object, ...) {
  paste0("\\item[", object$key, "] ", format_url(object$value))
}


#' @export
toLatex.DescriptionAuthorsAtR <- function(object, ...) {
  xx <- parse_authors_at_r(object$value)
  c(
    "\\item[Authors@R] ~\\\\",
    "  \\begin{description}",
    paste0("    ", vapply(xx, toLatex, character(1L)), collapse = "\n"),
    "  \\end{description}"
  )
}

#' @export
toLatex.person <- function(object, ...) {
  paste0(
    "\\item",
    format(object, include = c("role")),
    " ",
    format(object, include = c("given", "family")),
    " ",
    if (!is.null(object$email))
      paste0("<\\href{mailto:", object$email, "}{", object$email, "}>"),
    format(object, include = c("comment"))
  )
}

format_url <- function(object) {
  paste0("\\url{", object, "}", collapse = ", ")
}

idesc_get_built <- function(self, private) {
  built <- unname(self$get("Built"))
  if (is.na(built)) stop("No ", sQuote('Built'), " field found")
  built <- as.list(strsplit(built, "; ")[[1L]])
  if (length(built) != 4L) {
    stop(sQuote('Built'), " field is corrupted")
  }
  names(built) <- c("R", "Platform", "Date", "OStype")
  built[["R"]] <- R_system_version(sub("^R ([0-9.]+)", "\\1", built[["R"]]))
  built
}

#' Check encoding of new or existing fields
#'
#' If `new_fields` is `NULL`, then the existing
#' fields are checked. Otherwise `new_fields` are checked.
#'
#' Warnings are given for non-ascii fields, if the `Encoding`
#' field is not set.
#'
#' @param self Object.
#' @param private Private env.
#' @param new_fields New fields, or `NULL` to check existing fields.
#' @return Object, invisibly.
#'
#' @keywords internal

check_encoding <- function(self, private, new_fields) {
  if (!is.na(self$get('Encoding'))) return(invisible(self))

  fields <- if (is.null(new_fields)) {
    as.list(self$get(self$fields()))
  } else {
    new_fields
  }

  nonascii <- !vapply(fields, is_ascii, TRUE)

  if (any(nonascii)) {
    warning(
      "Consider adding an Encoding field to DESCRIPTION,\n",
      "Non-ASCII character(s) in ",
      paste(names(fields)[nonascii], collapse = ", ")
    )
  }

  invisible(self)
}

as_string <- function(x) {
  x <- as.character(x)
  if (length(x) != 1) stop("Value must be a scalar")
  x
}

is_string <- function(x) {
  is.character(x) && length(x) == 1 && ! is.na(x)
}

# Comment can be either a single string
# or a named vector of strings
is_character <- function(x) {
  is.character(x) && all(! is.na(x))
}

is_character_or_null <- function(x){
  is.null(x) || is_character(x)
}

is_named_character_or_null <- function(x){
  is.null(x) ||
    is.character(x) && length(x) == 1 && !is.na(x) ||
    is.character(x) && length(names(x)) == length(x) && all(!is.na(x))

}

is_constructor_cmd <- function(x) {
  is_string(x) && substring(x, 1, 1) == "!"
}

is_path <- function(x) {
  is_string(x)
}

is_existing_file <- function(x) {
  is_path(x) && file.exists(x)
}

has_no_na <- function(x) {
  !any(is.na(x))
}

is_flag <- function(x) {
  is.logical(x) && length(x) == 1 && !is.na(x)
}

is_authors <- function(x) {
  inherits(x, "person")
}

is_string_or_null <- function(x) {
  is_string(x) || is.null(x)
}


is_collate_field <- function(x) {
  is_string(x) && x %in% names(collate_fields)
}


is_collate_field_or_all <- function(x) {
  is_string(x) && (x %in% names(collate_fields) || x == "all")
}

is_collate_field_or_all_or_default <- function(x) {
  is_string(x) && (x %in% names(collate_fields) || x == "all" || x == "default")
}

is_deps_df <- function(x) {
  is.data.frame(x) &&
    identical(sort(names(x)), sort(c("type", "package", "version"))) &&
    all(sapply(x, is.character) | sapply(x, is.factor))
}

is_package_version <- function(x) {
  tryCatch(
    {
      length(package_version(x)) == 1
    },
    error = function(e) FALSE
  )
}

is_version_component <- function(x) {
  (is_string(x) && x %in% c("major", "minor", "patch", "dev")) ||
    (is_count(x) && x <= 5)
}

is_count <- function(x) {
  is.numeric(x) && length(x) == 1 && !is.na(x) && as.integer(x) == x
}

test_that("is_existing_file", {
  miss <- basename(tempfile())
  withr::with_dir(
    tempdir(),
    expect_error(desc::desc(miss), "is_existing_file")
  )
})

test_that("is_named_character_or_null", {
  x <- c(2, 3)
  expect_false(is_named_character_or_null(x))

  x <- "comment"
  expect_true(is_named_character_or_null(x))

  x <- c("comment1", "comment")
  expect_false(is_named_character_or_null(x))

  x <- c(comment1 = "comment1",
         comment2 = "comment")
  expect_true(is_named_character_or_null(x))

  x <- c(comment1 = "comment1",
         comment2 = NA)
  expect_false(is_named_character_or_null(x))


  x <- NULL
  expect_true(is_named_character_or_null(x))
})

idesc_set_dep <- function(self, private, package, type, version) {
  stopifnot(is_string(package), is_string(version))
  deps <- self$get_deps()
  has <- which(deps$package == package & deps$type == type)

  if (length(has)) {
    deps[ has, "version" ] <- version
  } else {
    row <- data.frame(
      stringsAsFactors = FALSE,
      type = type, package = package, version = version
    )
    others <- deps$package[deps$type == type]
    sorted <- !is.unsorted(tolower(others)) && length(others) > 0

    if (sorted) {
      # find first row it should come after
      idx <- which(deps$type == type & tolower(package) > tolower(deps$package))
      if (length(idx) == 0) {
        # must be first
        idx <- which(deps$type == type)[[1]]
      } else {
        idx <- max(idx) + 1
      }
    } else {
      idx <- nrow(deps) + 1
    }

    deps <- insert_row(deps, row, where = idx)
  }

  idesc_set_deps(self, private, deps)
}


idesc_set_deps <- function(self, private, deps) {
  stopifnot(is_deps_df(deps))
  depdeps <- deparse_deps(deps)
  for (d in names(depdeps)) {
    if (! same_deps(depdeps[[d]], private$data[[d]]$value)) {
      self$set(d, depdeps[[d]])
    }
  }

  deldeps <- setdiff(dep_types, names(depdeps))
  self$del(deldeps)

  invisible(self)
}


same_deps <- function(d1, d2) {
  if (is.null(d1) + is.null(d2) == 1) return(FALSE)

  d1 <- parse_deps("foo", d1)
  d2 <- parse_deps("foo", d2)

  d1 <- d1[ order(d1$type, d1$package, d1$version), ]
  d2 <- d2[ order(d2$type, d2$package, d2$version), ]
  nrow(d1) == nrow(d2) &&
    all(d1$type == d2$type) &&
    all(d1$package == d2$package) &&
    all(d1$version == d2$version)
}

#' Get dependencies
#'
#' In case the package has no dependencies at all, we `rbind` the
#' list of data frames with the various dependency types, with an
#' empty data frame. This ensures that we don't get `NULL` for the edge
#' case, but a nice data frame with zero rows.
#'
#' @param self self
#' @param private private self
#' @return data frame of dependencies
#'
#' @keywords internal
#' @noRd

idesc_get_deps <- function(self, private) {
  types <- intersect(names(private$data), dep_types)
  res <- lapply(types, function(type)
    parse_deps(type, private$data[[type]]$value))
  empty <- data.frame(
    stringsAsFactors = FALSE,
    type = character(),
    package = character(),
    version = character()
  )
  do.call(rbind, c(list(empty), res))
}


parse_deps <- function(type, deps) {
  deps <- str_trim(strsplit(deps, ",")[[1]])
  deps <- lapply(strsplit(deps, "\\("), str_trim)
  deps <- lapply(deps, sub, pattern = "\\)$", replacement = "")
  res <- data.frame(
    stringsAsFactors = FALSE,
    type = if (length(deps)) type else character(),
    package = vapply(deps, "[", "", 1),
    version = vapply(deps, "[", "", 2)
  )
  res$version <- gsub("\\s+", " ", res$version)
  res$version [ is.na(res$version) ] <- "*"
  res
}


deparse_deps <- function(deps) {
  tapply(seq_len(nrow(deps)), deps$type, function(x) {
    pkgs <- paste0(
      "    ",
      deps$package[x],
      ifelse(
        deps$version[x] == "*",
        "",
        paste0(" (", deps$version[x], ")")
      ),
      collapse = ",\n"
    )
    paste0("\n", pkgs)
  })
}


idesc_del_dep <- function(self, private, package, type) {
  stopifnot(is_string(package))
  deps <- self$get_deps()

  if (type == "all") {
    has <- which(deps$package == package)
  } else {
    has <- which(deps$package == package & deps$type == type)
  }

  if (length(has)) {
    deps <- deps[-has, ]
    idesc_set_deps(self, private, deps)

  } else {
    invisible(self)
  }
}


idesc_del_deps <- function(self, private) {
  self$del(dep_types)
}


idesc_has_dep <- function(self, private, package, type) {
  stopifnot(is_string(package))

  deps <- self$get_deps()
  if (type == "any") {
    package %in% deps$package

  } else {
    any(deps$package == package & deps$type == type)
  }
}

insert_row <- function(x, y, where = 1L) {
  if (where == 1L) {
    rbind(y, x)
  } else if (where > nrow(x)) {
    rbind(x, y)
  } else {
    top <- 1:(where - 1)
    rbind(x[top, , drop = FALSE], y, x[-top, , drop = FALSE])
  }
}

is_package_archive <- function(file) {
  (is_zip_file(file) || is_tar_gz_file(file)) &&
    is_valid_package_file_name(file)
}

is_zip_file <- function(file) {
  buf <- readBin(file, what = "raw", n = 4)
  length(buf) == 4 &&
    buf[1] == 0x50 &&
    buf[2] == 0x4b &&
    (buf[3] == 0x03 || buf[3] == 0x05 || buf[5] == 0x07) &&
    (buf[4] == 0x04 || buf[4] == 0x06 || buf[4] == 0x08)
}

is_gz_file <- function(file) {
  buf <- readBin(file, what = "raw", n = 3)
  length(buf) == 3 &&
    buf[1] == 0x1f &&
    buf[2] == 0x8b &&
    buf[3] == 0x08
}

is_tar_gz_file <- function(file) {
  if (!is_gz_file(file)) return(FALSE)
  con <- gzfile(file, open = "rb")
  on.exit(close(con))
  buf <- readBin(con, what = "raw", n = 262)
  length(buf) == 262 &&
    buf[258] == 0x75 &&
    buf[259] == 0x73 &&
    buf[260] == 0x74 &&
    buf[261] == 0x61 &&
    buf[262] == 0x72
}

is_valid_package_file_name <- function(filename) {
  grepl(valid_package_archive_name, basename(filename))
}

#' @importFrom utils untar unzip

con_unzip <- function(archive, pkgname) {
  filename <-  paste0(pkgname, "/", "DESCRIPTION")
  con <- unz(archive, filename)
  on.exit(close(con), add = TRUE)
  tmp <- tempfile()
  writeLines(readLines(con), tmp)
  tmp
}

con_untar <- function(archive, pkgname) {
  filename <- paste0(pkgname, "/", "DESCRIPTION")
  tmp <- tempfile()
  suppressWarnings(
    untar(con <- gzfile(archive, open = "rb"), files = filename, exdir = tmp)
  )
  on.exit(close(con), add = TRUE)
  file.path(tmp, pkgname, "DESCRIPTION")
}

get_description_from_package <- function(file) {
  package_name <- sub("_.*$", "", basename(file))

  uncompress <- if (is_zip_file(file)) con_unzip else con_untar
  desc <- uncompress(file, package_name)

  if (!file.exists(desc)) {
    stop("Cannot extract DESCRIPTION from ", sQuote(file))
  }

  desc
}

test_that("is_zip_file", {
  expect_true(is_zip_file(file.path("fixtures", "xxx.zip")))
  expect_false(is_zip_file(file.path("fixtures", "xxx.gz")))
  expect_false(is_zip_file(file.path("fixtures", "xxx.tar.gz")))
})

test_that("is_gz_file", {
  expect_false(is_gz_file(file.path("fixtures", "xxx.zip")))
  expect_true(is_gz_file(file.path("fixtures", "xxx.gz")))
  expect_true(is_gz_file(file.path("fixtures", "xxx.tar.gz")))
})

test_that("is_tar_gz_file", {
  expect_false(is_tar_gz_file(file.path("fixtures", "xxx.zip")))
  expect_false(is_tar_gz_file(file.path("fixtures", "xxx.gz")))
  expect_true(is_tar_gz_file(file.path("fixtures", "xxx.tar.gz")))
})

test_that("is_valid_package_file_name", {
  pos <- c(
    "foo_1.0.tar.gz",
    "a1_0.2.tar.gz",
    "A0_1.2-4.tar.gz",
    "foo_1.0.tgz",
    "a1_0.2.tgz",
    "A0_1.2-4.tgz",
    "foo_1.0.zip",
    "a1_0.2.zip",
    "A0_1.2-4.zip",
    "R6_2.2.0_R_x86_64-pc-linux-gnu.tar.gz"
  )

  neg <- c(
    "1foo_1.0.tar.gz",                  # cannot start with number
    "x_1.5.tar.gz",                     # must be at least two characters
    "xx-1.5.tar.gz",                    # dash separator is invalid
    "foo_1.tar.gz",                     # version number must have 2 comps
    "foo_1.0.tar.gzx",                  # invalid file extension
    "foo_1.0.zipfile"                   # invalid file extension
  )

  for (x in pos) expect_true(is_valid_package_file_name(x), info = x)
  for (x in neg) expect_false(is_valid_package_file_name(x), info = x)
})

test_that("is_package_archive", {
  pos <- file.path("fixtures", c(
    "pkg_1.0.0.tar.gz",
    "pkg_1.0.0.tgz",
    "pkg_1.0.0_R_x86_64-pc-linux-gnu.tar.gz"
  ))
  neg <- file.path("fixtures", c("xxx.zip", "xxx.gz", "xxx.tar.gz"))

  for (x in pos) expect_true(is_package_archive(x), info = x)
  for (x in neg) expect_false(is_package_archive(x), info = x)
})

test_that("get_description_from_package", {
  d1 <- description$new(file.path("fixtures", "pkg_1.0.0.tar.gz"))
  d2 <- description$new(file.path("fixtures", "pkg_1.0.0.tgz"))
  d3 <- description$new(file.path(
    "fixtures",
    "pkg_1.0.0_R_x86_64-pc-linux-gnu.tar.gz"
  ))
  d4 <- description$new(file.path("fixtures", "pkg_1.0.0.zip"))

  expect_equal(d1$get("Package"), c(Package = "pkg"))
  expect_equal(d2$get("Package"), c(Package = "pkg"))
  expect_equal(d3$get("Package"), c(Package = "pkg"))
  expect_equal(d4$get("Package"), c(Package = "pkg"))

  expect_error(
    d4 <- description$new(file.path("fixtures", "notpkg_1.0.tar.gz")),
    "Cannot extract DESCRIPTION"
  )
})

test_that("write errors if from archive", {
  d <- description$new(file.path("fixtures", "pkg_1.0.0.tar.gz"))
  expect_error(d$write(), "Cannot write back DESCRIPTION")
})

# No coverage calculating here, since this code
# runs during install time only.
# nocov start

#' @include description.R
#' @importFrom utils packageName

generate_api <- function(member, self = TRUE, norm = TRUE,
                         invisible = FALSE) {

  res <- function() { }

  func <- description$public_methods[[member]]

  ## Arguments
  xargs <- list(file = ".")
  if (self && norm) xargs <- c(xargs, list(normalize = FALSE))
  formals(res) <- c(formals(func), xargs)

  ## Call to member function
  member_call <- substitute(
    desc[[`_member`]](),
    list(`_member` = member)
  )
  argnames <- names(formals(func))
  dargs <- structure(lapply(argnames, as.name), names = argnames)
  if (!is.null(formals(func))) {
    member_call[1 + 1:length(formals(func))] <- dargs
    argnames2 <- c("", ifelse(argnames == "...", "", argnames))
    names(member_call) <- argnames2
  }
  desc_call <- substitute(
    result <- `_member`,
    list(`_member` = member_call)
  )

  ## Call to write, or just return the result
  write_call <- if (self && norm) {
    quote({
      if (normalize) desc$normalize()
      desc$write(file = file)
    })
  } else if (self) {
    quote(desc$write(file = file))
  }

  ## Put together

  body(res) <- substitute(
    { `_read`; `_trans`; `_write`; `_return` },
    list(
      `_read` = quote(desc <- description$new(file = file)),
      `_trans` = desc_call,
      `_write` = write_call,
      `_return` = if (invisible) quote(invisible(result)) else quote(result)
    )
  )

  environment(res) <- asNamespace(packageName())

  res
}

## -------------------------------------------------------------------

#' List all fields in a DESCRIPTION file
#'
#' @inheritParams desc_set
#' @return Character vector of fields.
#'
#' @family simple queries
#' @export

desc_fields <- generate_api("fields", self = FALSE)

#' Check if some fields are present in a DESCRIPTION file
#'
#' @param keys Character vector of keys to check.
#' @inheritParams desc_set
#' @return Logical vector.
#'
#' @family simple queries
#' @export

desc_has_fields <- generate_api("has_fields", self = FALSE)

#' Get a field from a DESCRIPTION file
#'
#' @param keys Character vector of fields to get.
#' @inheritParams desc_set
#' @return Character vector, values of the specified keys.
#'   Non-existing keys return `NA`.
#'
#' @family simple queries
#' @export

desc_get <- generate_api("get", self = FALSE)

#' Get a single field from a DESCRIPTION file, fail if not found
#'
#' `desc_get_list()` parses a comma separated list into a character
#' vector.
#'
#' @inheritParams desc_get
#' @param key The field to query.
#' @param default Value to return if `key` is not found.
#'   By default it throws an error.
#' @param trim_ws Whether to trim leading and trailing whitespace
#'   from the value. Defaults to `TRUE`.
#' @param squish_ws Whether to reduce repeated whitespace in the value.
#'   Defaults to `trim_ws`.
#' @param sep Separator string for [desc_get_list()].
#' @return Character string, the value of `key`, or `default`
#'   if `key` is not found and `default` is specified.
#'
#' @family simple queries
#' @export

desc_get_field <- generate_api("get_field", self = FALSE)

#' @rdname desc_get_field
#' @export

desc_get_or_fail <- generate_api("get_or_fail", self = FALSE)

#' @rdname desc_get_field
#' @export

desc_get_list <- generate_api("get_list", self = FALSE)

#' Set one or more fields in a DESCRIPTION file
#'
#' @details
#' `desc_set()` supports two forms, the first is two unnamed
#' arguments: the key and its value to set.
#'
#' The second form requires named arguments: names are used as keys
#' and values as values to set.
#'
#' `desc_set_list()` collapses a character vector into string,
#' separating the elements by commas.
#'
#' @param ... Values to set, see details below.
#' @param check Whether to check the validity of the new fields.
#' @param file DESCRIPTION file to use. By default the DESCRIPTION
#'    file of the current package (i.e. the package the working directory
#'    is part of) is used.
#' @param normalize Whether to "normalize" (reorder and reformat) the fields when writing back
#'   the result. See [desc_normalize()].
#' @param key Key to set in `desc_set_list()`.
#' @param list_value Character vector, to collapse in
#'   `desc_set_list()`.
#' @param sep Separator string for `desc_set_list()` list fields.
#'
#' @family simple queries
#' @export

desc_set <- generate_api("set")

#' @rdname desc_set
#' @export

desc_set_list <- generate_api("set_list")

#' Remove fields from a DESCRIPTION file
#'
#' @param keys Character vector of keys to remove.
#' @inheritParams desc_set
#'
#' @family simple queries
#' @export

desc_del <- generate_api("del")

## -------------------------------------------------------------------

#' Print the contents of a DESCRIPTION file to the screen
#'
#' @inheritParams desc_set
#' @export

desc_print <- generate_api("print", self = FALSE, invisible = TRUE)

#' Converts a DESCRIPTION file to LaTeX
#'
#' Returns the contents of the DESCRIPTION in LaTeX format.
#'
#' @inheritParams desc_set
#' @export

desc_to_latex <- generate_api("to_latex", self = FALSE)

#' Normalize a DESCRIPTION file
#'
#' Re-formats and re-orders fields in DESCRIPTION in a standard way.
#' Reorders the packages alphabetically.
#'
#' @inheritParams desc_set
#' @family repair functions
#' @export

desc_normalize <- generate_api("normalize", self = TRUE, norm = FALSE)

#' Reformat fields in a DESCRIPTION file
#'
#' Reformat the fields in DESCRIPTION in a standard way.
#'
#' @inheritParams desc_set
#' @family repair functions
#' @export

desc_reformat_fields <- generate_api("reformat_fields", self = TRUE, norm = FALSE)

#' Reorder fields in a DESCRIPTION file
#'
#' Reorder the fields in DESCRIPTION in a standard way.
#'
#' @inheritParams desc_set
#' @family repair functions
#' @export

desc_reorder_fields <- generate_api("reorder_fields", self = TRUE, norm = FALSE)

#' Validate a DESCRIPTION file
#'
#' This function is not implemented yet.
#'
#' @inheritParams desc_set
#'
#' @export

desc_validate <- generate_api("validate", self = FALSE)

## -------------------------------------------------------------------

#' List all package dependencies from a DESCRIPTION file
#'
#' @inheritParams desc_set
#' @return Data frame with columns: `type` (dependency type),
#'   `package`, and `version`. For non-versioned dependencies
#'   `version` is `*`.
#'
#' @family dependencies
#' @export

desc_get_deps <- generate_api("get_deps", self = FALSE)

#' Add a package dependency to a DESCRIPTION file
#'
#' @param package Package to depend on.
#' @param type Dependency type.
#' @param version Version to depend on, for versioned dependencies.
#' @inheritParams desc_set
#'
#' @family dependencies
#' @export

desc_set_dep <- generate_api("set_dep")

#' Set all package dependencies in DESCRIPTION
#'
#' @param deps Package dependency data frame, in the same format
#'    returned by [desc_get_deps()].
#' @inheritParams desc_set
#'
#' @family dependencies
#' @export

desc_set_deps <- generate_api("set_deps")

#' Remove a package dependency from DESCRIPTION
#'
#' @param package Package dependency to remove.
#' @param type Dependency type to remove. Sometimes a package is depended
#'   on via multiple dependency types, e.g. `LinkingTo` and
#'   `Imports`. Defaults to all types.
#' @inheritParams desc_set
#'
#' @family dependencies
#' @export

desc_del_dep <- generate_api("del_dep")

#' Remove all dependencies from DESCRIPTION
#'
#' @inheritParams desc_set
#'
#' @family dependencies
#' @export

desc_del_deps <- generate_api("del_deps")

#' Check for a dependency
#'
#' @inheritParams desc_set
#' @param package The package name.
#' @param type A dependency type or ``any`.
#' @return A logical scalar.
#'
#' @family dependencies
#' @export

desc_has_dep <- generate_api("has_dep", self = FALSE)

## -------------------------------------------------------------------

#' Set the Collate field in DESCRIPTION
#'
#' @param files Collate field to set, as a character vector.
#' @param which Which collate field to use. Collate fields can
#'   be operating system type specific.
#' @inheritParams desc_set
#'
#' @family Collate field
#' @export

desc_set_collate <- generate_api("set_collate")

#' Query the Collate field in DESCRIPTION
#'
#' @inheritParams desc_set_collate
#' @return Character vector of file names.
#'
#' @family Collate field
#' @export

desc_get_collate <- generate_api("get_collate", self = FALSE)

#' Delete the Collate field from DESCRIPTION
#'
#' @inheritParams desc_set_collate
#'
#' @family Collate field
#' @export

desc_del_collate <- generate_api("del_collate")

#' Add one or more files to the Collate field, in DESCRIPTION
#'
#' @param files Character vector, files to add.
#' @inheritParams desc_set_collate
#'
#' @family Collate field
#' @export

desc_add_to_collate <- generate_api("add_to_collate")

#' Remove files from the Collate field.
#'
#' @param files Files to remove from the Collate field.
#' @inheritParams desc_set_collate
#'
#' @family Collate field
#' @export

desc_del_from_collate <- generate_api("del_from_collate")

## -------------------------------------------------------------------

#' Query all authors in Authors@R, in DESCRIPTION
#'
#' @inheritParams desc_set
#' @return A person object, see [utils::person()].
#'
#' @family Authors@R
#' @export

desc_get_authors <- generate_api("get_authors", self = FALSE)

#' Query authors by role in Authors@R, in DESCRIPTION
#'
#' @param role Role to query. Defaults to the package maintainer.
#' @inheritParams desc_set
#' @return A person object, see [utils::person()].
#'
#' @family Authors@R
#' @export

desc_get_author <- generate_api("get_author", self = FALSE)

#' Set authors in Authors@R, in DESCRIPTION
#'
#' @param authors Authors, to set, a person object, see [utils::person()].
#' @inheritParams desc_set
#'
#' @family Authors@R
#' @export

desc_set_authors <- generate_api("set_authors")

#' Add an author to Authors@R in DESCRIPTION
#'
#' @param given Given name.
#' @param family Family name.
#' @param email Email address.
#' @param role Role.
#' @param comment Comment.
#' @param orcid ORCID.
#' @inheritParams desc_set
#'
#' @family Authors@R
#' @export

desc_add_author <- generate_api("add_author")

#' @title Add a role to one or more authors in Authors@R, in DESCRIPTION
#'
#' @description The author(s) can be specified by a combination of the `given`,
#' `family`, `email`, `comment` and `orcid` fields.
#' If multiple filters are specified, then all must match
#' to identify the author(s).
#'
#' @param role Role to add.
#' @param given Given name to filter on. Regular expression.
#' @param family Family name to filter on. Regular expression.
#' @param email Email address to filter on. Regular expression.
#' @param comment Comment field to filter on. Regular expression.
#' @param orcid ORCID field to filter on.
#' @inheritParams desc_set
#'
#' @family Authors@R
#' @export

desc_add_role <- generate_api("add_role")

#' @title Add an ORCID to one or more authors in Authors@R, in DESCRIPTION
#'
#' @description The author(s) can be specified by a combination of the `given`,
#' `family`, `email`, `comment` and `role` fields.
#' If multiple filters are specified, then all must match
#' to identify the author(s).
#'
#' @param orcid orcid to add.
#' @param given Given name to filter on. Regular expression.
#' @param family Family name to filter on. Regular expression.
#' @param email Email address to filter on. Regular expression.
#' @param comment Comment field to filter on. Regular expression.
#' @param role Role field to filter on.
#' @inheritParams desc_set
#'
#' @family Authors@R
#' @export

desc_add_orcid <- generate_api("add_orcid")

#' Remove one or more authors from DESCRIPTION.
#'
#' It uses the Authors@R field. The author(s) to be removed
#' can be specified via any field(s). All authors matching all
#' specifications will be removed. E.g. if only `given = "Joe"`
#' is supplied, then all authors whole given name matches `Joe` will
#' be removed. The specifications can be (PCRE) regular expressions.
#'
#' @param role Role to filter on. Regular expression.
#' @inheritParams desc_add_role
#'
#' @family Authors@R
#' @export

desc_del_author <- generate_api("del_author")

#' @title Delete a role of an author, in DESCRIPTION
#'
#' @inherit desc_add_role description
#'
#' @param role Role to remove.
#' @inheritParams desc_add_role
#'
#' @family Authors@R
#' @export

desc_del_role <- generate_api("del_role")

#' Change maintainer of the package, in DESCRIPTION
#'
#' Only works with the Authors@R field.
#'
#' The current maintainer is kept if they have at least another role.
#'
#' @inheritParams desc_add_author
#'
#' @family Authors@R
#' @export

desc_change_maintainer <- generate_api("change_maintainer")

#' Add the current user as an author to DESCRIPTION
#'
#' Uses the Authors@R field.
#'
#' @param role Role to set for the user, defaults to contributor.
#' @param comment Comment, empty by default.
#' @param orcid ORCID, empty by default.
#' @inheritParams desc_set
#'
#' @details
#' `desc_add_me` is a convenience function, it adds the
#'  current user as an author, and it needs the
#' `whoami` package to be installed. It'll add your ORCID ID
#' if you provide it as argument or save it as `ORCID_ID` environment
#' variable in .Renviron.
#' The full name is parsed using
#' `as.person` and collapsing the given name and the family name
#' in order to e.g. have the first and middle names together as given
#' name. This approach might be limited to some full name structures.
#'
#' @family Authors@R
#' @export

desc_add_me <- generate_api("add_me")

#' Add a GitHub user as an author to DESCRIPTION
#'
#' Uses the Authors@R field.
#'
#' @param username GitHub username of the GitHub user
#' @param role Role to set for the user, defaults to contributor.
#' @param comment Comment, empty by default.
#' @param orcid ORCID, empty by default.
#' @inheritParams desc_set
#'
#' @details
#' `desc_add_author_gh` is a convenience function, it adds the
#'  GitHub user as an author, and it needs the
#' `gh` package to be installed.
#' The full name is parsed using
#' `as.person` and collapsing the given name and the family name
#' in order to e.g. have the first and middle names together as given
#' name. This approach might be limited to some full name structures.
#'
#' @family Authors@R
#' @export

desc_add_author_gh <- generate_api("add_author_gh")

#' Query the package maintainer in DESCRIPTION
#'
#' Either from the `Maintainer` or the `Authors@R` field.
#' @inheritParams desc_set
#' @return A character scalar.
#'
#' @family Authors@R
#' @export

desc_get_maintainer <- generate_api("get_maintainer", self = FALSE)

#' Coerce Author and Maintainer Fields to Authors@R
#'
#' Convert the `Author` and `Maintainer` fields to
#' `Authors@R`, which is necessary for other functions such as
#' `desc_get_authors()`.
#'
#' @inheritParams desc_set
#'
#' @details
#' If the `Authors@R` field does not exist,
#' `desc_coerce_authors_at_r` tries to parse the `Author` and
#' `Maintainer` fields with [utils::as.person()] and writes
#' them to the `Authors@R` field.
#' Note that `Author` and `Maintainer` are free-form fields, so
#' parsing them may fail.
#'
#' @export
#' @family Authors@R
desc_coerce_authors_at_r <- generate_api("coerce_authors_at_r")


## -------------------------------------------------------------------

#' Query the URL field in DESCRIPTION
#'
#' @inheritParams desc_set
#' @return A character vectors or URLs. A length zero vector is returned
#'   if there is no URL field in the package.
#'
#' @export

desc_get_urls <- generate_api("get_urls", self = FALSE)

#' Set the URL field in DESCRIPTION
#'
#' The specified urls replace the current ones. The URL field is created
#' if it does not exist currently.
#'
#' @param urls A character vector of urls to set.
#' @inheritParams desc_set
#'
#' @export

desc_set_urls <- generate_api("set_urls")

#' Add URLs to the URL field in DESCRIPTION
#'
#' @param urls Character vector of URLs to add. Duplicate URLs are
#'   eliminated.
#' @inheritParams desc_set
#'
#' @export

desc_add_urls <- generate_api("add_urls")

#' Delete URLs from the URL field in DESCRIPTION
#'
#' All URLs matching the specified pattern are deleted.
#'
#' @param pattern Perl-compatible regular expression, all URLs
#'   matching this expression will be deleted.
#' @inheritParams desc_set
#'
#' @export

desc_del_urls <- generate_api("del_urls")

#' Remove all URLs from the URL field of DESCRIPTION
#'
#' @inheritParams desc_set
#'
#' @export

desc_clear_urls <- generate_api("clear_urls")

## -------------------------------------------------------------------

#' List the locations in the Remotes field in DESCRIPTION
#'
#' @inheritParams desc_set
#' @return A character vectors or remote locations. A length zero vector
#'   is returned if there is no Remotes field in the package.
#'
#' @export

desc_get_remotes <- generate_api("get_remotes", self = FALSE)

#' Set the Remotes field in DESCRIPTION
#'
#' The specified locations replace the current ones. The Remotes field is
#' created if it does not exist currently.
#'
#' @param remotes A character vector of remote locations to set.
#' @inheritParams desc_set
#'
#' @export

desc_set_remotes <- generate_api("set_remotes")

#' Add locations in the Remotes field in DESCRIPTION
#'
#' @param remotes Character vector of remote locations to add.
#'   Duplicate locations are eliminated. Note that existing locations
#'   are not updated, so if you want to _change_ a remote location
#'   of a package, you need to delete the old location first and then add
#'   the new one.
#' @inheritParams desc_set
#'
#' @export

desc_add_remotes <- generate_api("add_remotes")

#' Delete locations from the Remotes field in DESCRIPTION
#'
#' All locations matching the specified pattern are deleted.
#'
#' @param pattern Perl-compatible regular expression, all locations
#'   matching this expression will be deleted.
#' @inheritParams desc_set
#'
#' @export

desc_del_remotes <- generate_api("del_remotes")

#' Remove all locations from the Remotes field of DESCRIPTION
#'
#' This simply means that the field is deleted.
#'
#' @inheritParams desc_set
#'
#' @export

desc_clear_remotes <- generate_api("clear_remotes")

## -------------------------------------------------------------------

#' Query the package version in DESCRIPTION
#'
#' If the file has no `Version` field, or it is an invalid
#' version string, then it throws an error.
#'
#' @inheritParams desc_set
#' @return A [base::package_version] object.
#'
#' @export
#' @family version numbers

desc_get_version <- generate_api("get_version", self = FALSE)

#' Set the package version in DESCRIPTION
#'
#' Both `$set_version()` and `$bump_version()` use dots to
#' separate the version number components.
#'
#' @param version A string or a [base::package_version] object.
#' @inheritParams desc_set
#'
#' @export
#' @family version numbers

desc_set_version <- generate_api("set_version")

#' Increase the version number in DESCRIPTION
#'
#' The `which` parameter specifies which component to increase.
#' It can be a string referring to a component: `major`,
#' `minor`, `patch` or `dev`, or an integer
#' scalar, for the latter components are counted from one, and the
#' beginning. I.e. component one is equivalent to `major`.
#'
#' If a component is bumped, then the ones after it are zeroed out.
#' Trailing zero components are omitted from the new version number,
#' but if the old version number had at least two or three components, then
#' the one will also have two or three.
#'
#' The bumping of the `dev` version (the fourth component) is
#' special: if the original version number had less than four components,
#' and the `dev` version is bumped, then it is set to `9000`
#' instead of `1`. This is a convention often used by R developers,
#' it was originally invented by Winston Chang.
#'
#' Both `$set_version()` and `$bump_version()` use dots to
#' separate the version number components.
#'
#' @param which Which component to increase. See details below.
#' @inheritParams desc_set
#'
#' @export
#' @family version numbers

desc_bump_version <- generate_api("bump_version")

## -------------------------------------------------------------------

#' Query the built field in DESCRIPTION
#'
#' If the file has no `Built` field then it throws an error.
#'
#' @inheritParams desc_set
#' @return A list with fields `R`, `Platform`, `Date`,
#' `OStype`.
#'
#' @export
#' @family built
desc_get_built <- generate_api("get_built")

## -------------------------------------------------------------------
# nocov end

`%||%` <- function(l, r) if (is.null(l)) r else l

str_trim <- function(x) {
  sub("^\\s+", "", sub("\\s+$", "", x, useBytes = TRUE), useBytes = TRUE)
}

str_squish <- function(x) {
  gsub("\\s+", " ", x)
}

is_ascii <- function(x) {
  vapply(
    as.character(x),
    function(txt) all(charToRaw(txt) <= as.raw(127)),
    TRUE,
    USE.NAMES = FALSE
  )
}

## This is from tools/R/QC.R
## We do not calculate code coverage for this, as
## it is run at install time
##
## nocov start
RFC_2822_email_regexp <- (function() {

  ## Local part consists of ASCII letters and digits, the characters
  ##   ! # $ % * / ? | ^ { } ` ~ & ' + = _ -
  ## and . provided it is not leading or trailing or repeated, or must
  ## be a quoted string.
  ## Domain part consists of dot-separated elements consisting of
  ## ASCII letters, digits and hyphen.
  ## We could also check that the local and domain parts are no longer
  ## than 64 and 255 characters, respectively.
  ## See http://en.wikipedia.org/wiki/Email_address.

  ASCII_letters_and_digits <-
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
  l <- sprintf("[%s%s]", ASCII_letters_and_digits, "!#$%*/?|^{}`~&'+=_-")
  d <- sprintf("[%s%s]", ASCII_letters_and_digits, "-")
  ## Be careful to arrange the hyphens to come last in the range spec.
  sprintf("(\\\".+\\\"|(%s+\\.)*%s+)@(%s+\\.)*%s+", l, l, d, d)
})()
## nocov end


is_url <- function(x) {
  grepl("^(https?|ftp)://\\S+$", str_trim(x))
}


is_url_list <- function(x) {
  xx <- parse_url_list(x)
  all(vapply(xx, is_url, TRUE))
}


parse_url_list <- function(x) {
  xx <- strsplit(x, ",", fixed = TRUE)[[1]]
  str_trim(xx)
}


all_true <- function(x) {
  all(vapply(x, identical, TRUE, TRUE))
}


flatten <- function(x) {
  if (is.list(x)) {
    x <- lapply(
      x,
      function(e) if (is.null(e)) "" else paste(e, collapse = ",")
    )
    x <- unlist(x)
  }
  x
}

ngrepl <- function(pattern, x, ...) {
  if (is.null(pattern)) pattern <- ""
  x <- flatten(x)
  grepl(pattern, x, ...)
}

check_for_package <- function(pkg, msg = paste0("Package '", pkg,
                                     "' is needed.")) {

  has <- requireNamespace(pkg, quietly = TRUE)
  if (!has) stop(msg, call. = FALSE)
  has
}

is_dir <- function(path) {
  file.info(path)$isdir
}

postprocess_trailing_ws <- function(file, notws) {
  lines <- readLines(file)

  for (n in notws) {
    lines <- sub(paste0("^", n, ": "), paste0(n, ":"), lines)
  }
  writeLines(lines, file)
}

find_description <- function(dir) {
  pkg_root <- find_package_root(dir)
  file.path(pkg_root, "DESCRIPTION")
}

mark_continuation_lines <- function(x) {
  x <- gsub("\n[ \t]*\n", "\n .\n ", x, perl = TRUE, useBytes = TRUE)
  gsub("\n \\.([^\n])", "\n  .\\1", x, perl = TRUE, useBytes = TRUE)
}

parse_full_name <- function(x) {
  given <- paste(as.person(x)$given,
                  collapse = " ")
  family <- paste(as.person(x)$family,
                   collapse = " ")

  return(list(given = given,
              family = family))
}

# It is currently not possible to deparse UTF-8 objects to UTF-8 strings
# without converting them to the local encoding. `deparse()` either converts
# the UTF-8 characters to <U+xxxx> escapes or \ooo escapes. So it is better
# if we convert them to <U+xxxx> with iconv, and then convert back the
# <U+xxxx> strings after the deparsing.
#
# We cannot do the conversion to <U+> with iconv() because it only supports
# this kind of escaping from R 4.0.x.
#
# We also need to do the conversion on UTF-8 systems, because `deparse()`
# on older R versions escapes some Unicode characters.
#
# This function only works for character vectors, obviously. Related:
# https://stat.ethz.ch/pipermail/r-devel/2022-February/081485.html

fixed_deparse1 <- function(x, ...) {
  x <- unicode_encode(x)
  out <- paste(deparse(x, width.cutoff = 500L, ...), collapse = " ")
  out <- unicode_decode(out)
  out
}

unicode_encode <- function(x) {
  x[] <- vapply(x, unicode_encode1, character(1), USE.NAMES = FALSE)
  x
}

unicode_encode1 <- function(x) {
  x <- enc2utf8(x)
  nm <- utf8ToInt(x)
  lt <- intToUtf8(nm, multiple = TRUE)
  lt[nm > 127] <- paste0("<U+", as.hexmode(nm[nm > 127]), ">")
  paste(lt, collapse = "")
}

unicode_decode <- function(x) {
  mch <- gregexpr("<U\\+([0-9a-fA-F]+)>", x, perl = TRUE)
  uni <- regmatches(x, mch)
  rep <- lapply(uni, parse_escaped_unicode)
  regmatches(x, mch) <- rep
  x <- enc2utf8(x)
  Encoding(x) <- "UTF-8"
  x
}

parse_escaped_unicode <- function(x) {
  vapply(x, parse_escaped_unicode1, character(1))
}

parse_escaped_unicode1 <- function(x) {
  x <- gsub("<U\\+([0-9a-fA-F]+)>", "'\\\\U{\\1}'", x, perl = TRUE)
  eval(parse(text = x, encoding = "UTF-8"))
}

desc_message <- function(...) {
  msg <- simpleMessage(paste0(..., "\n"), sys.call())
  class(msg) <- c("descMessage", class(msg))
  message(msg)

}

write_dcf <- function(...) {
  if (getRversion() >= "3.5.0") {
    write.dcf(..., useBytes = TRUE)
  } else {
    write.dcf(...)
  }
}

mkdirp <- function(dir) {
  s <- vapply(dir, dir.create, logical(1), recursive = TRUE, showWarnings = FALSE)
  invisible(s)
}

test_that("check_for_package works", {

  expect_true(check_for_package("utils"))

  expect_error(
    check_for_package("foobarfoobarfoobar"),
    "Package 'foobarfoobarfoobar' is needed"
  )

})

test_that("is_ascii", {

  expect_true(is_ascii(""))
  expect_true(is_ascii("a"))
  expect_true(is_ascii(rawToChar(as.raw(127))))

  expect_equal(
    is_ascii(character()),
    logical()
  )

  expect_equal(
    is_ascii(c("a", "b")),
    c(TRUE, TRUE)
  )

  expect_false(is_ascii(rawToChar(as.raw(128))))
})

test_that("is_url", {

  expect_true(is_url("http://acme.com"))
  expect_true(is_url("https://acme.com"))
  expect_true(is_url("ftp://this.is.it"))

  expect_equal(is_url(character()), logical())

  expect_false(is_url(""))
  expect_false(is_url("this.is.not"))
  expect_false(is_url("http://"))
  expect_false(is_url("http:/this.is.no"))

  expect_equal(
    is_url(c("http://acme.com", "http://index.me")),
    c(TRUE, TRUE)
  )

  expect_equal(
    is_url(c("foo", "https://foo.bar")),
    c(FALSE, TRUE)
  )
})

test_that("is_url_list", {

  expect_true(is_url_list(""))
  expect_true(is_url_list("http://foo.bar"))

  expect_false(is_url_list("this is not it"))
  expect_false(is_url_list("http://so.far.so.good, oh, no!"))
})

test_that("parse_full_name works", {
  # thanks charlatan::ch_name()
  name <- "Chanie Reynolds"
  parsed_name <- parse_full_name(name)
  expect_equal(parsed_name$given, "Chanie")
  expect_equal(parsed_name$family, "Reynolds")


  name <- "Cathryn Schuster-Cruickshank"
  parsed_name <- parse_full_name(name)
  expect_equal(parsed_name$given, "Cathryn")
  expect_equal(parsed_name$family, "Schuster-Cruickshank")

  name <- "Petra J. Heaney"
  parsed_name <- parse_full_name(name)
  expect_equal(parsed_name$given, "Petra J.")
  expect_equal(parsed_name$family, "Heaney")


})

test_that("deparse", {
  x <- "G\u00e1bor \U1F680"
  expect_equal(utf8ToInt(x), c(71L, 225L, 98L, 111L, 114L, 32L, 128640L))
  dx <- fixed_deparse1(x)
  expect_equal(dx, paste0("\"", x, "\""))
  expect_equal(Encoding(dx), "UTF-8")

  # Test in non-UTF-8 locale as well
  dx2 <- callr::r(function(x) {
    Sys.setlocale("LC_ALL", "C")
    asNamespace("desc")$fixed_deparse1(x)
  }, list(x = x))
  expect_equal(dx2, paste0("\"", x, "\""))
  expect_equal(Encoding(dx2), "UTF-8")
})

test_that("find_package_root", {
  tmp <- tempfile()
  on.exit(unlink(tmp, recursive = TRUE), add = TRUE)
  mkdirp(file.path(tmp, "a", "b", "c", "d"))
  lns <- "Package: this"
  writeLines(lns, file.path(tmp, "DESCRIPTION"))

  expect_equal(
    readLines(file.path(find_package_root(tmp), "DESCRIPTION")),
    lns
  )

  expect_equal(
    readLines(file.path(
      find_package_root(file.path(tmp, "a")), "DESCRIPTION"
    )),
    lns
  )

  expect_equal(
    readLines(file.path(
      find_package_root(file.path(tmp, "a", "b", "c", "d")), "DESCRIPTION"
    )),
    lns
  )

  wd <- getwd()
  on.exit(setwd(wd), add = TRUE)
  setwd(file.path(tmp, "a", "b", "c"))
  expect_equal(
    readLines(file.path(find_package_root("."), "DESCRIPTION")),
    lns
  )
})

test_that("find_package_root errors", {
  expect_error(
    find_package_root(basename(tempfile())),
    "Path does not exist"
  )

  if (!file.exists("/DESCRIPTION")) {
    expect_error(
      find_package_root("/"),
      "Could not find R package"
    )
  }
})

chk <- function(msg, check) {
  if (check) TRUE else msg
}

chks <- function(..., x, warn) {
  results <- list(...)
  results <- unlist(setdiff(results, TRUE))
  results <- if (length(results) == 0) TRUE else results

  if (! identical(results, TRUE) && warn) {
    warning(
      call. = FALSE,
      "'", x$key, "'",
      paste0(
        if (length(results) == 1) " " else  "\n    * ",
        strwrap(results, indent = 0, exdent = 6)
      )
    )
  }

  results
}


#' Syntactical check of a DESCRIPTION field
#'
#' @param x The field.
#' @param warn Whether to generate a warning if the syntax check fails.
#' @param ... Additional arguments, they might be used in the future.
#' @return `TRUE` if the field is syntactically correct,
#'   otherwise a character vector, containing one or multiple
#'   error messages.
#'
#' @export

check_field <- function(x, warn = FALSE, ...)
  UseMethod("check_field")

#' @export
#' @method check_field DescriptionField

check_field.DescriptionField <- function(x, warn = FALSE, ...) TRUE

##' @export
##' @method check_field DescriptionPackage

check_field.DescriptionPackage <- function(x, warn = FALSE, R = FALSE, ...) {

  ## In Depends, we can depend on certain 'R' versions
  if (R && x$value == "R") return(TRUE)

  chks(
    x = x, warn = warn,
    chk("must only contain ASCII letters, numbers, dots",
        grepl("^[a-zA-Z0-9\\.]*$", x$value)),
    chk("must be at least two characters long",
        nchar(x$value) >= 2),
    chk("must start with a letter",
        grepl("^[a-zA-Z]", x$value)),
    chk("must not end with a dot",
        !grepl("\\.$", x$value))
  )
}

valid_packagename_regexp <- "[[:alpha:]][[:alnum:].]*[[:alnum:]]"
valid_version_regexp <- "[0-9]+[-\\.][0-9]+([-\\.][0-9]+)*"
valid_package_archive_name <- paste0(
  "^",
  valid_packagename_regexp,
  "_",
  valid_version_regexp,
  "(.*)?",
  "(\\.tar\\.gz|\\.tgz|\\.zip)",
  "$"
)

##' @export
##' @method check_field DescriptionVersion

check_field.DescriptionVersion <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk(paste("must be a sequence of at least two (usually three)",
              " non-negative integers separated by a single dot or dash",
              " character"),
        grepl(paste0("^", valid_version_regexp, "$"), x$value))
  )
}

## TODO: It also must be a license R CMD check recognizes
##
##' @export
##' @method check_field DescriptionLicense

check_field.DescriptionLicense <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must contain only ASCII characters",
        is_ascii(x$value)),
    chk("must not be empty",
        str_trim(x$value) != "")
  )
}

##' @export
##' @method check_field DescriptionDescription

check_field.DescriptionDescription <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must not be empty",
        str_trim(x$value) != ""),
    chk("must contain one or more complete sentences",
        grepl("[.!?]['\")]?$", str_trim(x$value))),
    chk("must not start with 'The package', 'This Package, 'A package'",
        !grepl("^(The|This|A|In this|In the) package", x$value)),
    chk("must start with a capital letter",
        grepl("^['\"]?[[:upper:]]", x$value))
  )
}

##' @export
##' @method check_field DescriptionTitle

check_field.DescriptionTitle <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must not be empty",
         str_trim(x$value) != ""),
    chk("must not end with a period",
        !grepl("[.]$", str_trim(x$value)) ||
        grepl("[[:space:]][.][.][.]|et[[:space:]]al[.]", str_trim(x$value)))
  )
}

##' @export
##' @method check_field DescriptionMaintainer

check_field.DescriptionMaintainer <- function(x, warn = FALSE, ...) {

  re_maint <- paste0(
    "^[[:space:]]*(.*<",
    RFC_2822_email_regexp,
    ">|ORPHANED)[[:space:]]*$"
  )

  chks(
    x = x, warn = warn,
    chk("must not be empty",
        str_trim(x$value) != ""),
    chk("must contain an email address",
        grepl(re_maint, x$value))
  )
}

## TODO
##' @export
##' @method check_field DescriptionAuthorsAtR

check_field.DescriptionAuthorsAtR <- function(x, warn = FALSE, ...) {
  TRUE
}

##' @export
##' @method check_field DescriptionDependencyList

check_field.DescriptionDependencyList <- function(x, warn = FALSE, ...) {

  deps <- parse_deps(x$key, x$value)

  is_package_list <- function(xx) {
    p <- lapply(xx, function(pc)
      check_field.DescriptionPackage(
        list(key = "Package", value = pc),
        R = x$key[1] == "Depends"
      )
    )
    all_true(p)
  }

  is_version_req <- function(x) {

    x <- str_trim(x)
    if (x == "*") return(TRUE)

    re <- paste0(
      "^(<=|>=|<|>|==|!=)\\s*",
      valid_version_regexp,
      "$"
    )
    grepl(re, x)
  }

  is_version_req_list <- function(x) {
    all_true(vapply(x, is_version_req, TRUE))
  }

  chks(
    x = x, warn = warn,
    chk("must contain valid package names",
        is_package_list(deps$package)),
    chk("must contain valid version requirements",
        is_version_req_list(deps$version))
  )
}

##' @export
##' @method check_field DescriptionRemotes

check_field.DescriptionRemotes <- function(x, warn = FALSE, ...) {

  is_remote <- function(x) {
    xx <- str_trim(strsplit(x, ",", fixed = TRUE)[[1]])
    p <- grepl("^[^[:space:]]+$", xx)
    all_true(p)
  }

  chks(
    x = x, warn = warn,
    chk("must be a comma separated list of remotes",
        is_remote(x$value))
  )
}

##' @export
##' @method check_field DescriptionPackageList

check_field.DescriptionPackageList <- function(x, warn = FALSE, ...) {

  is_package_list <- function(x) {
    xx <- str_trim(strsplit(x, ",", fixed = TRUE)[[1]])
    p <- lapply(xx, function(pc)
      check_field.DescriptionPackage(list(key = "Package", value = pc)))
    all_true(p)
  }

  chks(
    x = x, warn = warn,
    chk("must be a comma separated list of package names",
        is_package_list(x$value))
  )
}

##' @export
##' @method check_field DescriptionRepoList

check_field.DescriptionRepoList <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must be a comma separated list repository URLs",
        is_url_list(x$value))
  )
}

##' @export
##' @method check_field DescriptionURL

check_field.DescriptionURL <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must be a http, https or ftp URL",
        is_url(x$value))
  )
}

##' @export
##' @method check_field DescriptionURLList

check_field.DescriptionURLList <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must be a comma separated list of http, https or ftp URLs",
        is_url_list(x$value))
  )
}

##' @export
##' @method check_field DescriptionPriority

check_field.DescriptionPriority <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must be one of 'base', 'recommended' or 'defunct-base'",
        str_trim(x$value) %in% c("base", "recommended", "defunct-base"))
  )
}

##' @export
##' @method check_field DescriptionCollate

check_field.DescriptionCollate <- function(x, warn = FALSE, ...) {

  coll <- tolower(parse_collate(x$value))

  chks(
    x = x, warn = warn,
    chk("must contain a list of .R files",
        all(grepl("[.]r$", coll)))
  )
}

##' @export
##' @method check_field DescriptionLogical

check_field.DescriptionLogical <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must be one of 'true', 'false', 'yes' or 'no' (case insensitive)",
        str_trim(tolower(x$value)) %in% c("true", "false", "yes", "no"))
  )
}

##' @export
##' @method check_field DescriptionEncoding

check_field.DescriptionEncoding <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must be one of 'latin1', 'latin2' and 'UTF-8'",
        x$value %in% c("latin1", "latin2", "UTF-8"))
  )
}

##' @export
##' @method check_field DescriptionOSType

check_field.DescriptionOSType <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must be one of 'unix' and 'windows'",
        x$value %in% c("unix", "windows"))
  )
}

##' @export
##' @method check_field DescriptionType

check_field.DescriptionType <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must be either 'Package' or 'Translation'",
        x$value %in% c("Package", "Translation"))
  )
}

##' @export
##' @method check_field DescriptionClassification

check_field.DescriptionClassification <- function(x, warn = FALSE, ...) {
  TRUE
}

##' @export
##' @method check_field DescriptionLanguage

check_field.DescriptionLanguage <- function(x, warn = FALSE, ...) {

  is_language_list <- function(x) {
    x <- str_trim(strsplit(x, ",", fixed = TRUE)[[1]])
    all(grepl("^[a-z][a-z][a-z]?(-[A-Z]+)?$", x))
  }

  chks(
    x = x, warn = warn,
    chk("must be a list of IETF language codes defined by RFC 5646",
        is_language_list(x$value))
  )
}

##' @export
##' @method check_field DescriptionDate

check_field.DescriptionDate <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk(
      paste0(
        "must be an ISO date: yyyy-mm-dd, but it is actually better\n",
        "to leave this field out completely. It is not required."),
      grepl("^[0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9]$", x$value)
    )
  )
}

##' @export
##' @method check_field DescriptionCompression

check_field.DescriptionCompression <- function(x, warn = FALSE, ...) {

  chks(
    x = x, warn = warn,
    chk("must be one of 'bzip2', 'xz', 'gzip'",
        x$value %in% c("bzip2", "xz", "gzip"))
  )
}

##' @export
##' @method check_field DescriptionRepository

check_field.DescriptionRepository <- function(x, warn = FALSE, ...) {
  TRUE
}

##' @export
##' @method check_field DescriptionFreeForm

check_field.DescriptionFreeForm <- function(x, warn = FALSE, ...) {
  TRUE
}

##' @export
##' @method check_field DescriptionAddedByRCMD

check_field.DescriptionAddedByRCMD <- function(x, warn = FALSE, ...) {
  TRUE
}

#' @importFrom utils as.person

parse_authors_at_r <- function(x) {

  if (is.null(x) || is.na(x)) return(NULL)

  # Need a connection on R 3.6 and before, because the encoding will
  # be messed up. Also need to set the input to `unknown`.
  Encoding(x) <- "unknown"
  con <- textConnection(x)
  on.exit(close(con), add = TRUE)
  out <- tryCatch(
    eval(parse(con, encoding = "UTF-8")),
    error = identity
  )

  if (inherits(out, "error")) NULL else out
}


deparse_authors_at_r <- function(x, package = NULL) {
  # this is to fix a revdep failure in attachment
  if (identical(Sys.getenv("_R_CHECK_PACKAGE_NAME_"), "attachment") &&
      identical(Sys.getenv("TESTTHAT"), "true") &&
      is.na(Sys.getenv("ATTACHMENT_FIXED", NA_character_))) {
    return(old_deparse_authors_at_r(x))
  }
  fmt <- lapply(unclass(x), deparse_author_at_r)
  lines <- vapply(fmt, paste, character(1), collapse = "\n    ")
  if (length(fmt) == 1) {
    paste0("\n    ", lines)
  } else {
    paste0(
      "c(\n",
      paste("   ", lines, collapse = ",\n"),
      "\n  )"
    )
  }
}

deparse_author_at_r <- function(x1) {
  x1 <- x1[! vapply(x1, is.null, TRUE)]
  d <- function(n) {
    if (n %in% names(x1)) fixed_deparse1(x1[[n]]) else ""
  }
  hdr <- paste0(
    "person(",
    d("given"),
    if (any(c("family", "middle", "email") %in% names(x1))) ", ",
    d("family"),
    if (any(c("middle", "email") %in% names(x1))) ", ",
    d("middle"),
    if ("email" %in% names(x1)) ", ",
    d("email"),
    if ("role" %in% names(x1)) paste0(", role = ", d("role"))
  )

  x1 <- x1[setdiff(names(x1), c("given", "family", "middle", "role", "email"))]

  if (length(x1) == 0) {
    paste0(hdr, ")")
  } else {
    c(
      paste0(hdr, ","),
      paste0(
        rep("       ", length(x1)),
        names(x1), " = ", vapply(x1, fixed_deparse1, ""),
        c(rep(",", length(x1) - 1), ")")
      )
    )
  }
}

old_deparse_authors_at_r <- function(x) {
  fmt <- lapply(unclass(x), old_deparse_author_at_r)
  if (length(fmt) == 1) {
    paste0("\n", paste0("    ", fmt[[1]], collapse = "\n"))
  } else {
    for (i in seq_along(fmt)) {
      fmt[[i]] <- paste0("  ", fmt[[i]])
      fmt[[i]][[length(fmt[[i]])]] <- paste0(fmt[[i]][[length(fmt[[i]])]], ",")
    }
    fmt[[1]][[1]] <- sub("^  ", "c(", fmt[[1]][[1]])
    n <- length(fmt)
    fmt[[n]][[length(fmt[[n]])]] <- sub(",$", ")", fmt[[n]][[length(fmt[[n]])]])
    paste0("\n", paste0("    ", unlist(fmt), collapse = "\n"))
  }
}

old_deparse_author_at_r <- function(x1) {
  x1 <- x1[! vapply(x1, is.null, TRUE)]
  paste0(
    c("person(", rep("       ", length(x1) - 1)),
    names(x1), " = ", vapply(x1, fixed_deparse1, ""),
    c(rep(",", length(x1) - 1), ")")
  )
}

set_author_field <- function(authors, which, field, value) {
  rval <- unclass(authors)
  for (w in which) rval[[w]][[field]] <- value
  class(rval) <- class(authors)
  rval
}


ensure_authors_at_r <- function(obj) {
  if (! obj$has_fields("Authors@R")) {
    stop("No 'Authors@R' field!\n",
         "You can create one with $add_author.\n",
         "You can also use $coerce_authors_at_r() to change Author fields")
  }
}

## Find an author in the Authors@R field, based on a particular
## specification. E.g. it is enough to give the first name.

search_for_author <- function(authors, given = NULL, family = NULL,
                              email = NULL, role = NULL, comment = NULL,
                              orcid = NULL) {

  matching <-
    ngrepl(given, authors$given) &
    ngrepl(family, authors$family) &
    ngrepl(email, authors$email) &
    ngrepl(role, authors$role) &
    ngrepl(comment, authors$comment) &
    ngrepl(orcid, authors$comment)

  list(index = which(matching), authors = authors[matching])
}


idesc_get_authors <- function(self, private, ensure = TRUE) {
  stopifnot(is_flag(ensure))
  if (ensure) ensure_authors_at_r(self)
  parse_authors_at_r(self$get("Authors@R"))
}


idesc_get_author <- function(self, private, role) {
  stopifnot(is_string(role))
  if (self$has_fields("Authors@R")) {
    aut <- self$get_authors()
    roles <- aut$role
    ## Broken person() API, vector for 1 author, list otherwise...
    if (!is.list(roles)) roles <- list(roles)
    selected <- vapply(roles, function(r) all(role %in% r), TRUE)
    aut[selected]
  } else {
    NULL
  }
}

idesc_set_authors <- function(self, private, authors) {
  stopifnot(is_authors(authors))
  self$set("Authors@R", deparse_authors_at_r(authors))
}

check_author_args <- function(given = NULL, family = NULL, email = NULL,
                              role = NULL, comment = NULL,
                              orcid = NULL) {
  stopifnot(
    is_string_or_null(given),
    is_string_or_null(family),
    is_string_or_null(email),
    is_character_or_null(role),
    is_named_character_or_null(comment),
    is_string_or_null(orcid)
  )
}

#' @importFrom utils person

idesc_add_author <- function(self, private, given, family, email, role,
                             comment, orcid = NULL) {
  check_author_args(given, family, email, role, comment, orcid)
  orig <- idesc_get_authors(self, private, ensure = FALSE)

  if (!is.null(orcid)) {
    comment["ORCID"] <- orcid
  }

  newp <- person(given = given, family = family, email = email,
                 role = role, comment = comment)
  new_authors <- if (is.null(orig)) newp else c(orig, newp)
  self$set_authors(new_authors)
}


idesc_add_role <- function(self, private, role, given, family, email,
                           comment, orcid = NULL) {

  stopifnot(is.character(role))
  check_author_args(given, family, email, comment = comment,
                    orcid = orcid)

  orig <- idesc_get_authors(self, private, ensure = FALSE)
  wh <- search_for_author(
    orig, given = given, family = family, email = email, comment = comment,
    orcid = orcid,
    role = NULL
  )

  for (w in wh$index) {
    orig <- set_author_field(
      orig,
      w,
      "role",
      unique(c(orig[[w]]$role, role))
    )
  }

  self$set_authors(orig)
}

idesc_add_orcid <- function(self, private, orcid, given, family, email,
                            comment, role) {

  check_author_args(given = given, family = family,
                    email = email,
                    comment = comment,
                    orcid = orcid, role = role)

  orig <- idesc_get_authors(self, private, ensure = FALSE)
  wh <- search_for_author(
    orig, given = given, family = family, email = email, comment = comment,
    orcid = NULL,
    role = role
  )

  if (length(wh$index) > 1) {
    stop("More than one author correspond to the provided arguments.
         ORCID IDs have to be distinct.",
         call. = FALSE)
  }

  orig <- set_author_field(
      orig,
      wh$index,
      "comment",
      add_orcid_to_comment(orig[wh$index]$comment,
                           orcid)
    )

  self$set_authors(orig)
}

idesc_del_author <- function(self, private, given, family, email, role,
                            comment, orcid = NULL) {

  check_author_args(given, family, email, role, comment, orcid)

  orig <- idesc_get_authors(self, private, ensure = FALSE)
  wh <- search_for_author(
    orig, given = given, family = family, email = email,
    comment = comment, orcid = orcid
  )

  if (length(wh$index) == 0) {
    desc_message("Could not find author to remove.")
  } else {
    au <- if (length(wh$index) == 1) "Author" else "Authors"
    desc_message(
      au, " removed: ",
      paste(wh$authors$given, wh$authors$family, collapse = ", "),
      "."
    )
    self$set_authors(orig[-wh$index])
  }

  invisible(self)
}


idesc_del_role <- function(self, private, role, given, family, email,
                          comment, orcid = NULL) {

  stopifnot(is.character(role))
  check_author_args(given, family, email, role = NULL, comment, orcid)

  orig <- idesc_get_authors(self, private, ensure = FALSE)
  wh <- search_for_author(
    orig, given = given, family = family, email = email, comment = comment,
    orcid = orcid, role = NULL
  )

  for (w in wh$index) {
    orig <- set_author_field(
      orig,
      w,
      "role",
      setdiff(orig[[w]]$role, role)
    )
  }

  self$set_authors(orig)
}


idesc_change_maintainer <- function(self, private, given, family, email,
                                   comment, orcid = NULL) {
  check_author_args(given, family, email, role = NULL, comment, orcid)
  ensure_authors_at_r(self)
  self$del_role(role = "cre")
  self$add_role(role = "cre", given = given, family = family,
                email = email, comment = comment, orcid = orcid)
}


#' @importFrom utils tail

idesc_add_me <- function(self, private, role, comment, orcid = NULL) {
  stopifnot(
    is_character_or_null(role),
    is_named_character_or_null(comment),
    is_string_or_null(orcid)
  )
  check_for_package("whoami", "$add_me needs the 'whoami' package")

 # guess ORCID
  if (is.null(orcid)) {
    orcid <- Sys.getenv("ORCID_ID")
    if (orcid == "") {
      orcid <- NULL
    }
  }

  fn <- parse_full_name(whoami::fullname())
  family <- fn$family
  given <- fn$given
  email <- whoami::email_address()
  self$add_author(given = given, family = family, email = email,
                  comment = comment, role = role, orcid = orcid)
}

idesc_add_author_gh <- function(self, private, username, role, comment, orcid = NULL) {
  stopifnot(
    is_character_or_null(role),
    is.character(username),
    is_named_character_or_null(comment),
    is_string_or_null(orcid)
  )

  gh_info <- author_gh(username)

  fn <- parse_full_name(gh_info$name)
  family <- fn$family
  given <- fn$given
  email <- gh_info$email
  self$add_author(given = given, family = family, email = email,
                  comment = comment, role = role, orcid = orcid)
}

author_gh <- function(username) {
  opt <- getOption("desc.gh_user")
  if (!is.null(opt)) return(opt)
  check_for_package("gh", "$add_author_gh needs the 'gh' package")
  gh::gh("GET /users/:username", username = username)
}

idesc_get_maintainer <- function(self, private) {
  if (self$has_fields("Maintainer")) {
    unname(self$get("Maintainer"))
  } else if (self$has_fields("Authors@R")) {
    format(
      self$get_author(role = "cre"),
      include = c("given", "family", "email")
    )
  } else {
    NA_character_
  }
}

idesc_coerce_authors_at_r <- function(self, private) {

  if (self$has_fields("Authors@R")) return(invisible(NULL)) # exit early

  if (!self$has_fields("Author")) {

    stop("No 'Authors@R' or 'Author' field!\n",
         "You can create one with $add_author")

  } else {

    # helper function to set role if role is NULL
    set_role_if_null <- function(person, role) {
      if (length(person) == 1) {
        person$role <- person$role %||% role
      } else {
        person$role <- lapply(person$role, function(y) y %||% role)
      }
      person
    }

    # Parse maintainer field as person and set role
    man <- self$get_maintainer()
    man <- as.person(man)
    man <- set_role_if_null(man, "cre")

    # Parse author field as person and set role
    auth <- self$get("Author")
    author_file <- grepl("AUTHOR", auth, ignore.case = FALSE, fixed = TRUE)
    if (author_file) {
      desc_message(
        "The 'Author' field seems to refer to an AUTHOR file we do not parse. \n",
        "Only the 'Maintainer' field will be converted to 'Authors@R'. \n",
        "You can add additional authors with $add_author."
      )
      auth <- man
      auth$role <- "aut"
    } else {
    auth <- as.person(auth)
    auth <- set_role_if_null(auth, "aut")
    }

    # Determine which author is the maintainer and split auth accordingly
    auth_in_man <- paste(auth$given, auth$family) %in% paste(man$given, man$family)
    mauth <- if(any(auth_in_man)) auth[auth_in_man] else man
    other_auth <- auth[!auth_in_man] # this is an empty list if single author

    # combine info from mauth and man
    mauth$role <- list(unique(c(mauth$role, man$role)))
    mauth$email <- man$email # email is mandatory for maintainers
    mauth$comment <- list(mauth$comment %||% man$comment)

    # combine all authors and set as authors@R
    auths = c(mauth, other_auth)
    self$set_authors(auths)
  }
}

# helper to add or replace ORCID in comment
add_orcid_to_comment <- function(comment, orcid){

  comment["ORCID"] <- orcid
  comment
}

find_package_root <- function(path = ".") {
  is_root <- function(path) {
    identical(
      normalizePath(path, winslash = "/"),
      normalizePath(dirname(path), winslash = "/")
    )
  }

  if (!file.exists(path)) {
    stop("Path does not exist: ", path)
  }
  cur_path <- normalizePath(path, winslash = "/")
  errmsg <- paste0(
    "Could not find R package in `",
    path,
    "` or its parent directories."
  )
  max_depth <- 100
  for (i in 1:max_depth) {
    dsc_path <- file.path(cur_path, "DESCRIPTION")
    if (file.exists(dsc_path) &&
      any(grepl("^Package: ", readLines(dsc_path)))) {
      return(cur_path)
    } else if (is_root(cur_path)) {
      stop(errmsg)
    } else {
      cur_path <- dirname(cur_path)
    }
  }
  stop(errmsg, " Checked ", max_depth, " parent directories.") # nocov
}

test_package_root <- function() {
  x <- tryCatch(
    find_package_root(),
    error = function(e) NULL)

  if (!is.null(x)) return(x)

  pkg <- testthat::testing_package()
  x <- tryCatch(
    find_package_root(
      path = file.path("..", "..", "00_pkg_src", pkg)),
    error = function(e) NULL)

  if (!is.null(x)) return(x)

  stop("Cannot find package root")
}

test_that("spelling", {
  skip_on_cran()
  skip_on_covr()
  pkgroot <- test_package_root()
  err <- spelling::spell_check_package(pkgroot)
  num_spelling_errors <- nrow(err)
  expect_true(
    num_spelling_errors == 0,
    info = paste(
      c("\nSpelling errors:", capture.output(err)),
      collapse = "\n"
    )
  )
})

#' DESCRIPTION fields that denote package dependencies
#'
#' Currently it has the following ones: Imports, Depends,
#' Suggests, Enhances and LinkingTo. See the _Writing R Extensions_
#' manual for when to use which.
#'
#' @family field types
#' @export

dep_types <- c("Imports", "Depends", "Suggests", "Enhances", "LinkingTo")

standard_fields <- c(
  "Additional_repositories",
  "Author",
  "Authors@R",
  "Biarch",
  "BugReports",
  "BuildKeepEmpty",
  "BuildManual",
  "BuildResaveData",
  "BuildVignettes",
  "Built",
  "ByteCompile",
  "Classification/ACM",
  "Classification/ACM-2012",
  "Classification/JEL",
  "Classification/MSC",
  "Classification/MSC-2010",
  "Collate",
  "Collate.unix",
  "Collate.windows",
  "Contact",
  "Copyright",
  "Date",
  "Depends",
  "Description",
  "Encoding",
  "Enhances",
  "Imports",
  "KeepSource",
  "Language",
  "LazyData",
  "LazyDataCompression",
  "LazyLoad",
  "License",
  "LinkingTo",
  "MailingList",
  "Maintainer",
  "Note",
  "OS_type",
  "Package",
  "Packaged",
  "Priority",
  "Suggests",
  "SysDataCompression",
  "SystemRequirements",
  "Title",
  "Type",
  "URL",
  "Version",
  "VignetteBuilder",
  "ZipData",
  "Repository",
  "Path",
  "Date/Publication",
  "LastChangedDate",
  "LastChangedRevision",
  "Revision",
  "RcmdrModels",
  "RcppModules",
  "Roxygen",
  "Acknowledgements",
  "Acknowledgments", # USA/Canadian usage.
  "biocViews"
)

#' A list of DESCRIPTION fields that are valid according to the CRAN checks
#'
#' @family field types
#' @export

cran_valid_fields <- c(
  standard_fields,
  "^(?:X-CRAN|Repository/R-Forge)",
  paste0(standard_fields, "Note")
)

#' The DESCRIPTION fields that are supposed to be in plain ASCII encoding
#'
#' @family field types
#' @export

cran_ascii_fields <- c(
  "Package",
  "Version",
  "Priority",
  "Depends",
  "Imports",
  "LinkingTo",
  "Suggests",
  "Enhances",
  "License",
  "License_is_FOSS",
  "License_restricts_use",
  "OS_type",
  "Archs",
  "MD5sum",
  "NeedsCompilation",
  "Encoding"
)

parse_remotes <- function(remotes) {
  str_trim(strsplit(remotes, "\\s*,\\s*", perl = TRUE)[[1]])
}

deparse_remotes <- function(remotes) {
  paste0(" \n    ", paste(str_trim(remotes), collapse = ",\n    "))
}

idesc_get_remotes <- function(self, private) {
  remotes <- self$get("Remotes")
  if (is.na(remotes)) {
    character()
  } else {
    parse_remotes(remotes)
  }
}

idesc_set_remotes <- function(self, private, remotes) {
  stopifnot(is.character(remotes))
  self$set(Remotes = deparse_remotes(remotes))
  invisible(self)
}

idesc_add_remotes <- function(self, private, remotes) {
  stopifnot(is.character(remotes))
  remotes <- unique(c(self$get_remotes(), remotes))
  self$set(Remotes = deparse_remotes(remotes))
  invisible(self)
}

idesc_del_remotes <- function(self, private, pattern) {
  stopifnot(is_string(pattern))
  remotes <- self$get_remotes()
  if (length(remotes) == 0) return(invisible(self))

  filt <- grep(pattern, remotes, invert = TRUE, value = TRUE, perl = TRUE)
  if (length(filt) > 0) {
    self$set(Remotes = deparse_remotes(filt))
  } else {
    self$del("Remotes")
  }
  invisible(self)
}

idesc_clear_remotes <- function(self, private) {
  self$del("Remotes")
  invisible(self)
}

idesc_get_version <- function(self, private) {
  ver <- unname(self$get("Version"))
  if (is.na(ver)) stop("No ", sQuote('Version'), " field found")
  package_version(ver)
}

idesc_set_version <- function(self, private, version) {
  stopifnot(is_package_version(version))
  self$set(Version = as.character(version))
}

idesc_bump_version <- function(self, private, which) {
  stopifnot(is_version_component(which))
  if (is.character(which)) {
    which <- match(which, c("major", "minor", "patch", "dev"))
  }

  ver_str <- self$get_version()
  ver <- get_version_components(ver_str)

  ## Special dev version
  inc <- if (which == 4 && length(ver) < 4) 9000 else 1

  ## Missing components are equivalent to zero
  if (which > length(ver)) ver <- c(ver, rep(0, which - length(ver)))

  ## Bump selected component
  ver[which] <- ver[which] + inc

  ## Zero out everything after
  if (which < length(ver)) ver[(which+1):length(ver)] <- 0

  ## Keep at most three components if they are zero
  if (length(ver) > 3 && all(ver[4:length(ver)] == 0)) {
    ver <- ver[1:3]
  }

  ## Set the new version
  new_ver <- package_version(paste(ver, collapse = "."))
  self$set_version(new_ver)

  ## Give a message
  desc_message(
    "Package version bumped from ", sQuote(ver_str), " to ", sQuote(new_ver)
  )

  invisible(self)
}

## Note that this is not vectorized

get_version_components <- function(x) {
  as.numeric(strsplit(format(x), "[-\\.]")[[1]])
}

## TODO: continuation lines

idesc_str <- function(self, private, by_field, normalize = TRUE,
                      mode = c("file", "screen")) {

  stopifnot(is_flag(by_field))
  mode <- match.arg(mode)
  cols <- names(private$data)
  if (normalize) cols <- field_order(cols)
  col_str <- vapply(
    cols, FUN.VALUE = "",
    FUN = function(col) {
      if (normalize) {
        format(private$data[[col]], mode = mode)
      } else {
        paste0(
          private$data[[col]]$key, ": ",
          mark_continuation_lines(private$data[[col]]$value)
        )
      }
    })

  if (by_field) col_str else paste(col_str, collapse = "\n")
}

field_order <- function(fields) {
  first <- c(
    "Type", "Package", "Title", "Version", "Date",
    "Authors@R", "Author", "Maintainer",
    "Description", "License", "URL", "BugReports",
    "Depends", setdiff(dep_types, "Depends"), "VignetteBuilder",
    "RdMacros", "Remotes"
  )

  last <- collate_fields

  c(
    intersect(first, fields),
    sort(setdiff(fields, c(first, last))),
    intersect(last, fields)
  )
}

color_bad <- function(x) {
  if (identical(check_field(x), TRUE)) x$value else cli::col_red(x$value)
}

#' @export
#' @method format DescriptionField

format.DescriptionField <- function(x, ..., width = 75) {
  mark_continuation_lines(paste(
    strwrap(paste0(cli::col_blue(x$key), ": ", color_bad(x)), exdent = 4, width = width),
    collapse = "\n"
  ))
}

#' @export
#' @method format DescriptionDependencyList

format.DescriptionDependencyList <- function(x, ...) {
  paste0(
    cli::col_blue(x$key), ":\n",
    paste0(
      "    ",
      sort(str_trim(strsplit(color_bad(x), ",", fixed = TRUE)[[1]])),
      collapse = ",\n"
    )
  )
}

#' @export
#' @method format DescriptionPackageList

format.DescriptionPackageList <- format.DescriptionDependencyList

#' @export
#' @method format DescriptionRemotes

format.DescriptionRemotes <- format.DescriptionDependencyList

#' @export
#' @method format DescriptionCollate

format.DescriptionCollate <- function(x, ...) {
  paste0(
    cli::col_blue(x$key), ":",
    deparse_collate(parse_collate(color_bad(x)))
  )
}

#' @export
#' @method format DescriptionAuthorsAtR

format.DescriptionAuthorsAtR <- function(x, mode = c("file", "screen"),
                                         ...) {
  xx <- parse_authors_at_r(x$value)

  if (mode == "screen") {
    good <- check_field(x)
    xxx <- if (good) xx else cli::col_red(xx)
    paste0(
      cli::col_blue(x$key), " (parsed):\n",
      paste0("    * ", format(xxx), collapse = "\n")
    )

  } else {
    paste0(
      x$key, ":",
      sub("\n$", "", deparse_authors_at_r(xx))
    )
  }
}


idesc_print <- function(self, private) {
  cat(
    idesc_str(self, private, by_field = FALSE, mode = "screen"),
    sep = "",
    "\n"
  )
  invisible(self)
}


idesc_normalize <- function(self, private) {
  self$reformat_fields()
  self$reorder_fields()
  invisible(self)
}

idesc_reformat_fields <- function(self, private) {
  old <- options(cli.num_colors = 1, crayon.enabled = FALSE)
  on.exit(options(old), add = TRUE)
  norm_fields <- idesc_str(self, private, by_field = TRUE)
  for (f in names(norm_fields)) {
    private$data[[f]]$value <-
      sub(paste0(f, ":[ ]?"), "", norm_fields[[f]])
  }
  invisible(self)
}

idesc_reorder_fields <- function(self, private) {
  private$data <- private$data[field_order(names(private$data))]
  invisible(self)
}

which_collate <- function(x) {
  collate_fields[x]
}


idesc_set_collate <- function(self, private, files, which) {
  stopifnot(is.character(files), is_collate_field(which))
  if (length(files) == 0) warning("No files in 'Collate' field")

  idesc_really_set_collate(self, private, files, which_collate(which))
}


idesc_really_set_collate <- function(self, private, files, field) {
  if (!identical(self$get_collate(), files)) {
    self$set(field, deparse_collate(files))
  }
}


idesc_get_collate <- function(self, private, which) {
  stopifnot(is_collate_field(which))
  coll <- unname(self$get(which_collate(which)))
  if (identical(coll, NA_character_)) character() else parse_collate(coll)
}


idesc_del_collate <- function(self, private, which) {
  stopifnot(is_collate_field_or_all(which))

  if (which == "all") {
    self$del(collate_fields)

  } else {
    self$del(collate_fields[which])
  }

  invisible(self)
}


idesc_add_to_collate <- function(self, private, files, which) {
  stopifnot(is.character(files), is_collate_field_or_all_or_default(which))

  if (which == "default") {
    ex_coll <- intersect(collate_fields, self$fields())
    if (length(ex_coll) == 0) {
      real_add_to_collate(self, private, which_collate("main"), files)
    } else {
      for (ex in ex_coll) real_add_to_collate(self, private, ex, files)
    }

  } else if (which == "all") {
    for (coll in collate_fields) {
      real_add_to_collate(self, private, coll, files)
    }

  } else {
    real_add_to_collate(self, private, which_collate(which), files)
  }
  
}

## TODO: better order, and support dependencies

real_add_to_collate <- function(self, private, field, files) {
  ex <- if (!self$has_fields(field)) {
    character()
  } else {
    parse_collate(self$get(field))
  }

  files <- unique(c(ex, files))
  idesc_really_set_collate(self, private, files, field)
}


idesc_del_from_collate <- function(self, private, files, which) {
  stopifnot(is.character(files), is_collate_field_or_all(which))

  if (which == "all") {
    for (coll in collate_fields) {
      real_del_from_collate(self, private, coll, files)
    }

  } else {
    real_del_from_collate(self, private, which_collate(which), files)
  }
}

real_del_from_collate <- function(self, private, field, files) {
  if (self$has_fields(field)) {
    coll <- setdiff(parse_collate(self$get(field)), files)
    idesc_really_set_collate(self, private, coll, field)
  } else {
    invisible(self)
  }
}


parse_collate <- function(str) {
  scan(
    text = gsub("\n", " ", str),
    what = "",
    strip.white = TRUE,
    quiet = TRUE
  )
}


deparse_collate <- function(list) {
  paste0(
    "\n",
    paste0(
      "    '",
      list,
      "'",
      collapse = "\n"
    )
  )
}

#' Read a DESCRIPTION file
#'
#' This is a convenience wrapper for `description$new()`.
#' Very often you want to read an existing `DESCRIPTION`
#' file, and to do this you can just supply the path to the file or its
#' directory to `desc()`.
#'
#' @param cmd A command to create a description from scratch.
#'   Currently only `"!new"` is implemented. If it does not start
#'   with an exclamation mark, it will be interpreted as the `file`
#'   argument.
#' @param file Name of the `DESCRIPTION` file to load. If all of
#'   `cmd`, `file` and `text` are `NULL` (the default), then the
#'   `DESCRIPTION` file in the current working  directory is used.
#'   The file can also be an R package (source, or
#'   binary), in which case the `DESCRIPTION` file is extracted from it, but
#'   note that in this case `$write()` cannot write the file back in
#'   the package archive.
#' @param text A character scalar containing the full DESCRIPTION.
#'   Character vectors are collapsed into a character scalar, with
#'   newline as the separator.
#' @param package If not NULL, then the name of an installed package
#'     and the DESCRIPTION file of this package will be loaded.
#'
#' @export
#' @examples
#' desc(package = "desc")
#' DESCRIPTION <- system.file("DESCRIPTION", package = "desc")
#' desc(DESCRIPTION)

desc <- function(cmd = NULL, file = NULL, text = NULL, package = NULL) {
  description$new(cmd, file, text, package)
}

#' Read, write, update, validate DESCRIPTION files
#'
#' @section Constructors:
#'
#' There are two ways of creating a description object. The first
#' is reading an already existing `DESCRIPTION` file; simply give
#' the name of the file as an argument. The default is `DESCRIPTION`:
#' ```r
#' x <- description$new()
#' x2 <- description$new("path/to/DESCRIPTION")
#' ```
#'
#' The second way is creating a description object from scratch,
#' supply `"!new"` as an argument to do this.
#' ```r
#' x3 <- description$new("!new")
#' ```
#'
#' The complete API reference:
#' ```r
#' description$new(cmd = NULL, file = NULL, text = NULL,
#'     package = NULL)
#' ```
#'
#' * `cmd`: a command to create a description from scratch.
#'   Currently only `"!new"` is implemented. If it does not start
#'   with an exclamation mark, it will be interpreted as a `file`
#'   argument.
#' * `file`: name of the `DESCRIPTION` file to load. If it is
#'   a directory, then we assume that it is inside an R package and
#'   conduct a search for the package root directory, i.e. the first
#'   directory up the tree that contains a `DESCRIPTION` file.
#'   If `cmd`, `file`, `text` and `package` are all `NULL` (the default),
#'   then the search is started from the working directory. The file can
#'   also be an R package (source, or binary), in which case the
#'   `DESCRIPTION` file is extracted from it, but note that in this case
#'   `$write()` cannot write the file back in the package archive.
#' * `text`: a character scalar containing the full DESCRIPTION.
#'   Character vectors are collapsed into a character scalar, with
#'   newline as the separator.
#' * `package`: if not NULL, then the name of an installed package
#'   and the DESCRIPTION file of this package will be loaded.
#'
#' @section Setting and Querying fields:
#' Set a field with `$set` and query it with `$get`:
#' ```r
#' x <- description$new("!new")
#' x$get("Package")
#' x$set("Package", "foobar")
#' x$set(Title = "Example Package for 'description'")
#' x$get("Package")
#' ```
#'
#' Note that `$set` has two forms. You can either give the field name
#' and new value as two arguments; or you can use a single named argument,
#' the argument name is the field name, the argument value is the field
#' value.
#'
#' The `$fields` method simply lists the fields in the object:
#' ```r
#' x$fields()
#' ```
#'
#' The `$has_fields` method checks if one or multiple fields are
#' present in a description object:
#' ```r
#' x$has_fields("Package")
#' x$has_fields(c("Title", "foobar"))
#' ```
#'
#' The `$del` method removes the specified fields:
#' ```r
#' x$set(foo = "bar")
#' x$del("foo")
#' ```
#'
#' `$get_field` is similar to `$get`, but it queries a single
#' field, it returns an unnamed vector if found, and returns the
#' specified `default` value if not. By default it throws an error
#' if the field is not found.
#'
#' The complete API reference:
#' ```r
#' description$get(keys)
#' description$get_field(key, default, trim_ws = TRUE, squish_ws = trim_ws)
#' description$set(..., check = TRUE)
#' description$fields()
#' description$has_fields(keys)
#' description$del(keys)
#' ```
#'
#'  * `key`: a character string (length one), the key to query.
#'  * `default`: If specified and `key` is missing, this value
#'     is returned. If not specified, an error is thrown.
#'  * `trim_ws`: whether to trim leading and trailing whitespace
#'     from the returned value.
#'  * `squish_ws`: whether to reduce repeated whitespace in the
#'     returned value.
#'  * `keys`: a character vector of keys to query, check or delete.
#'  * `...`: this must be either two unnamed arguments, the key and
#'     and the value to set; or an arbitrary number of named arguments,
#'     names are used as keys, values as values to set.
#'  * `check`: A logical scalar. Whether to check the validity of the
#'     new values.
#'
#' @section Normalizing:
#' Format DESCRIPTION in a standard way. `$str` formats each
#' field in a standard way and returns them (it does not change the
#' object itself), `$print` is used to print it to the
#' screen. The `$normalize` function normalizes each field (i.e.
#' it changes the object). Normalization means reformatting the fields,
#' via `{$reformat_fields()` and also reordering them via
#' `$reorder_fields()`. The format of the various fields is
#' opinionated and you might like it or not. Note that `desc` only
#' re-formats fields that it updates, and only on demand, so if your
#' formatting preferences differ, you can still manually edit
#' `DESCRIPTION` and `desc` will respect your edits.
#'
#' ```r
#' description$str(by_field = FALSE, normalize = TRUE,
#'     mode = c("file", "screen"))
#' description$normalize()
#' description$reformat_fields()
#' description$reorder_fields()
#' description$print()
#'```
#'
#' * `by_field`: whether to return the normalized format
#'     by field, or collapsed into a character scalar.
#' * `normalize`: whether to reorder and reformat the fields.
#' * `mode`: `file` mode formats the fields as they are
#'     written to a file with the `write` method. `screen`
#'     mode adds extra markup to some fields, e.g. formats the
#'     `Authors@R` field in a readable way.
#'
#' @section Writing it to file:
#' The `$write` method writes the description to a file.
#' By default it writes it to the file it was created from, if it was
#' created from a file. Otherwise giving a file name is compulsory:
#' ```r
#' x$write(file = "DESCRIPTION")
#' ```
#'
#' The API:
#' ```r
#' description$write(file = NULL)
#' ```
#'
#' * `file`: path to write the description to. If it was created
#'      from a file in the first place, then it is written to the same
#'      file. Otherwise this argument must be specified.
#'
#' @section Version numbers:
#'
#' ```r
#' description$get_version()
#' description$set_version(version)
#' description$bump_version(which = c("patch", "minor", "major", "dev"))
#' ```
#'
#' * `version`: a string or a [base::package_version] object.
#' * `which`: which component of the version number to increase.
#'     See details just below.
#'
#' These functions are simple helpers to make it easier to query, set and
#' increase the version number of a package.
#'
#' `$get_version()` returns the version number as a
#' [base::package_version] object. It throws an error if the
#' package does not have a `Version` field.
#'
#' `$set_version()` takes a string or a [base::package_version] object and
#' sets the `Version` field to it.
#'
#' `$bump_version()` increases the version number. The `which`
#' parameter specifies which component to increase.
#' It can be a string referring to a component: `major`,
#' `minor`, `patch` or `dev`, or an integer
#' scalar, for the latter components are counted from one, and the
#' beginning. I.e. component one is equivalent to `major`.
#'
#' If a component is bumped, then the ones after it are zeroed out.
#' Trailing zero components are omitted from the new version number,
#' but if the old version number had at least two or three components, then
#' the one will also have two or three.
#'
#' The bumping of the `dev` version (the fourth component) is
#' special: if the original version number had less than four components,
#' and the `dev` version is bumped, then it is set to `9000`
#' instead of `1`. This is a convention often used by R developers,
#' it was originally invented by Winston Chang.
#'
#' Both `$set_version()` and `$bump_version()` use dots to
#' separate the version number components.
#'
#' @section Dependencies:
#' These functions handle the fields that define how the R package
#' uses another R packages. See [dep_types] for the
#' list of fields in this group.
#'
#' The `$get_deps` method returns all declared dependencies, in a
#' data frame with columns: `type`, `package` and `version`.
#' `type` is the name of the dependency field, `package` is the
#' name of the R package, and `version` is the required version. If
#' no specific versions are required, then this is a `"*"`.
#'
#' The `$set_deps` method is the opposite of `$get_deps` and
#' it sets all dependencies. The input is a data frame, with the same
#' structure as the return value of `$get_deps`.
#'
#' The `$has_dep` method checks if a package is included in the
#' dependencies. It returns a logical scalar. If `type` is not
#' `any`, then it has to match as well.
#'
#' The `$del_deps` method removes all declared dependencies.
#'
#' The `$set_dep` method adds or updates a single dependency. By
#' default it adds the package to the `Imports` field.
#'
#' The API:
#' ```r
#' description$set_dep(package, type = dep_types, version = "*")
#' description$set_deps(deps)
#' description$get_deps()
#' description$has_dep(package, type = c("any", dep_types))
#' description$del_dep(package, type = c("all", dep_types))
#' description$del_deps()
#' ```
#'
#' * `package`: name of the package to add to or remove from the
#'     dependencies.
#' * `type`: dependency type, see [dep_types]. For
#'     `$del_dep` it may also be `"all"`, and then the package
#'     will be deleted from all dependency types.
#' * `version`: required version. Defaults to `"*"`, which means
#'     no explicit version requirements.
#' * `deps`: a data frame with columns `type`, `package` and
#'     `version`. `$get_deps` returns the same format.
#'
#' @section Collate fields:
#' Collate fields contain lists of file names with R source code,
#' and the package has a separate API for them. In brief, you can
#' use `$add_to_collate` to add one or more files to the main or
#' other collate field. You can use `$del_from_collate` to remove
#' it from there.
#'
#' The API:
#' ```r
#' description$set_collate(files, which = c("main", "windows", "unix"))
#' description$get_collate(which = c("main", "windows", "unix"))
#' description$del_collate(which = c("all", "main", "windows", "unix"))
#' description$add_to_collate(files, which = c("default", "all", "main",
#'   "windows", "unix"))
#' description$del_from_collate(files, which = c("all", "main",
#'   "windows", "unix"))
#' ```
#'
#' * `iles`: the files to add or remove, in a character vector.
#' * `which: which collate field to manipulate. `"default"` for
#'   `$add_to_collate` means all existing collate fields, or the
#'   main one if none exist.
#'
#' @section Authors:
#' There is a specialized API for the `Authors@R` field,
#' to add and remove authors, update their roles, change the maintainer,
#' etc.
#'
#' The API:
#' ```r
#' description$get_authors()
#' description$set_authors(authors)
#' description$get_author(role)
#' description$get_maintainer()
#' description$coerce_authors_at_r()
#' ```
#'
#' * `authors`: a `person` object, a list of authors.
#' * `role`: The role to query. See `person` for details.
#'
#' `$get_authors` returns a `person` object, the parsed
#' authors. See [utils::person()] for details.
#'
#' `$get_author` returns a `person` object, all authors with
#' the specified role.
#'
#' `$get_maintainer` returns the maintainer of the package. It works
#' with `Authors@R` fields and with traditional `Maintainer`
#' fields as well.
#'
#' `$coerce_authors_at_r` converts an `Author` field to one with
#' a `person` object. This coercion may be necessary for other
#' functions such as `$get_authors`.
#'
#' ```r
#' description$add_author(given = NULL, family = NULL, email = NULL,
#'     role = NULL, comment = NULL, orcid = NULL)
#' description$add_me(role = "ctb", comment = NULL, orcid = NULL)
#' description$add_author_gh(username, role = "ctb", comment = NULL, orcid = NULL)
#' ```
#'
#' Add a new author. The arguments correspond to the arguments of the
#' [utils::person()] function. `add_me` is a convenience
#' function, it adds the current user as an author, and it needs the
#' `whoami` package to be installed. It'll add your ORCID ID
#' if you provide it as argument or save it as `ORCID_ID` environment
#' variable in .Renviron.
#' The full name is parsed by `add_me` and `add_author_gh` using
#' `as.person` and collapsing the given name and the family name
#' in order to e.g. have the first and middle names together as given
#' name. This approach might be limited to some full name structures.
#'
#' ```r
#' description$del_author(given = NULL, family = NULL, email = NULL,
#'     role = NULL, comment = NULL, orcid = NULL)
#' ```
#'
#' Remove an author, or multiple authors. The author(s) to be removed
#' can be specified via any field(s). All authors matching all
#' specifications will be removed. E.g. if only `given = "Joe"`
#' is supplied, then all authors whole given name matches `Joe` will
#' be removed. The specifications can be (PCRE) regular expressions.
#'
#' ```r
#' description$add_role(role, given = NULL, family = NULL, email = NULL,
#'     comment = NULL, orcid = NULL)
#' description$add_orcid(orcid, given = NULL, family = NULL, email = NULL,
#'     comment = NULL, role = NULL)
#' description$del_role(role, given = NULL, family = NULL, email = NULL,
#'     comment = NULL, orcid = NULL)
#' description$change_maintainer(given = NULL, family = NULL,
#'     email = NULL, comment = NULL, orcid = NULL)
#' ```
#'
#' `role` is the role to add or delete. The other arguments
#' are used to select a subset of the authors, on which the operation
#' is performed, similarly to `$del_author`.
#'
#' @section URLs:
#'
#' We provide helper functions for manipulating URLs in the `URL`
#' field:
#'
#' ```r
#' description$get_urls()
#' description$set_urls(urls)
#' description$add_urls(urls)
#' description$del_urls(pattern)
#' description$clear_urls()
#' ```
#'
#' * `urls`: character vector of URLs to set or add.
#' * `pattern`: Perl compatible regular expression to specify the
#'     URLs to be removed.
#'
#' `$get_urls()` returns all urls in a character vector. If no URL
#' fields are present, a zero length vector is returned.
#'
#' `$set_urls()` sets the URL field to the URLs specified in the
#' character vector argument.
#'
#' `$add_urls()` appends the specified URLs to the URL field. It
#' creates the field if it does not exists. Duplicate URLs are removed.
#'
#' `$del_urls()` deletes the URLs that match the specified pattern.
#'
#' `$clear_urls()` deletes all URLs.
#'
#' @section Remotes:
#'
#' `devtools`, `remotes` and some other packages support the
#' non-standard `Remotes` field in `DESCRIPTION`. This field
#' can be used to specify locations of dependent packages: GitHub or
#' BitBucket repositories, generic git repositories, etc. Please see the
#' `Package remotes` vignette in the `devtools` package.
#'
#' `desc` has helper functions for manipulating the `Remotes`
#' field:
#'
#' ```r
#' description$get_remotes()
#' description$get_remotes()
#' description$set_remotes(remotes)
#' description$add_remotes(remotes)
#' description$del_remotes(pattern)
#' description$clear_remotes()
#' ```
#'
#' * `remotes`: character vector of remote dependency locations to
#'     set or add.
#' * `pattern`: Perl compatible regular expression to specify the
#'     remote dependency locations to remove.
#'
#' `$get_remotes()` returns all remotes in a character vector.
#' If no URL fields are present, a zero length vector is returned.
#'
#' `$set_remotes()` sets the URL field to the Remotes specified in the
#' character vector argument.
#'
#' `$add_remotes()` appends the specified remotes to the
#' `Remotes` field. It creates the field if it does not exists.
#' Duplicate remotes are removed.
#'
#' `$del_remotes()` deletes the remotes that match the specified
#' pattern.
#'
#' `$clear_remotes()` deletes all remotes.
#'
#' @section Built:
#'
#' The `Built` field is used in binary packages to store information
#' about when and how a binary package was built.
#'
#' `$get_built()` returns the built information as a list with fields
#' `R`, `Platform`, `Date`, `OStype`. It throws an
#' error if the package does not have a `Built` field.
#'
#' @section Encodings:
#' When creating a `description` object, `desc` observes the `Encoding`
#' field, if present, and uses the specified encoding to parse the file.
#' Internally, it converts all fields to UTF-8.
#'
#' When writing a `description` object to a file, `desc` uses the
#' `Encoding` field (if present), and converts all fields to the specified
#' encoding.
#'
#' We suggest that whenever you need to use non-ASCII characters in your
#' package, you use the UTF-8 encoding, for maximum portability.
#'
#' @export
#' @importFrom R6 R6Class
#' @docType class
#' @format An R6 class.
#'
#' @examples
#' ## Create a template
#' desc <- description$new("!new")
#' desc
#'
#' ## Read a file
#' desc2 <- description$new(file = system.file("DESCRIPTION",
#'                            package = "desc"))
#' desc2
#'
#' ## Remove a field
#' desc2$del("LazyData")
#'
#' ## Add another one
#' desc2$set(VignetteBuilder = "knitr")
#' desc2$get("VignetteBuilder")
#' desc2

description <- R6Class("description",
  public = list(

    ## Either from a file, or from a character vector
    initialize = function(cmd = NULL, file = NULL, text = NULL, package = NULL)
      idesc_create(self, private, cmd, file, text, package),

    write = function(file = NULL)
      idesc_write(self, private, file),

    fields = function()
      idesc_fields(self, private),

    has_fields = function(keys)
      idesc_has_fields(self, private, keys),

    get = function(keys)
      idesc_get(self, private, keys),

    get_field = function(key, default = stop("Field '", key, "' not found"),
                         trim_ws = TRUE, squish_ws = trim_ws)
      idesc_get_field(self, private, key, default, trim_ws, squish_ws),

    get_or_fail = function(keys)
      idesc_get_or_fail(self, private, keys),

    get_list = function(key, default = stop("Field '", key, "' not found"),
                        sep = ",", trim_ws = TRUE, squish_ws = trim_ws)
      idesc_get_list(self, private, key, default, sep, trim_ws, squish_ws),

    set = function(..., check = TRUE)
      idesc_set(self, private, ..., check = check),

    set_list = function(key, list_value, sep = ", ")
      idesc_set_list(self, private, key, list_value, sep),

    del = function(keys)
      idesc_del(self, private, keys),

    validate = function()
      idesc_validate(self, private),

    print = function()
      idesc_print(self, private),

    str = function(by_field = FALSE, normalize = TRUE,
      mode = c("file", "screen"))
      idesc_str(self, private, by_field, normalize, mode),

    to_latex = function()
      idesc_to_latex(self, private),

    normalize = function()
      idesc_normalize(self, private),

    reformat_fields = function()
      idesc_reformat_fields(self, private),

    reorder_fields = function()
      idesc_reorder_fields(self, private),

    ## -----------------------------------------------------------------
    ## Version numbers

    get_version = function()
      idesc_get_version(self, private),

    set_version = function(version)
      idesc_set_version(self, private, version),

    bump_version = function(which)
      idesc_bump_version(self, private, which),

    ## -----------------------------------------------------------------
    ## Package dependencies

    set_dep = function(package, type = desc::dep_types, version = "*")
      idesc_set_dep(self, private, package, match.arg(type), version),

    set_deps = function(deps)
      idesc_set_deps(self, private, deps),

    get_deps = function()
      idesc_get_deps(self, private),

    del_dep = function(package, type = c("all", desc::dep_types))
      idesc_del_dep(self, private, package, match.arg(type)),

    del_deps = function()
      idesc_del_deps(self, private),

    has_dep = function(package, type = c("any", desc::dep_types))
      idesc_has_dep(self, private, package, match.arg(type)),

    ## -----------------------------------------------------------------
    ## Collate fields

    set_collate = function(files, which = c("main", "windows", "unix"))
      idesc_set_collate(self, private, files, match.arg(which)),

    get_collate = function(which = c("main", "windows", "unix"))
      idesc_get_collate(self, private, match.arg(which)),

    del_collate = function(which = c("all", "main", "windows", "unix"))
      idesc_del_collate(self, private, match.arg(which)),

    add_to_collate = function(files,
      which = c("default", "all", "main", "windows", "unix"))
      idesc_add_to_collate(self, private, files, match.arg(which)),

    del_from_collate = function(files,
      which = c("all", "main", "windows", "unix"))
      idesc_del_from_collate(self, private, files, match.arg(which)),

    ## -----------------------------------------------------------------
    ## Authors@R

    get_authors = function()
      idesc_get_authors(self, private),

    get_author = function(role = "cre")
      idesc_get_author(self, private, role),

    set_authors = function(authors)
      idesc_set_authors(self, private, authors),

    add_author = function(given = NULL, family = NULL, email = NULL,
                          role = NULL, comment = NULL, orcid = NULL)
      idesc_add_author(self, private, given, family, email, role, comment,
                       orcid),

    add_role = function(role, given = NULL, family = NULL, email = NULL,
                        comment = NULL, orcid = NULL)
      idesc_add_role(self, private, role, given, family, email, comment,
                     orcid),

    add_orcid = function(orcid, given = NULL, family = NULL, email = NULL,
                        comment = NULL, role = NULL)
      idesc_add_orcid(self, private, role = role, given = given, family = family,
                     email = email, comment = comment,
                     orcid = orcid),

    del_author = function(given = NULL, family = NULL, email = NULL,
                          role = NULL, comment = NULL, orcid = NULL)
      idesc_del_author(self, private, given, family, email, role, comment,
                       orcid),

    del_role = function(role, given = NULL, family = NULL, email = NULL,
                        comment = NULL, orcid = NULL)
      idesc_del_role(self, private, role, given, family, email, comment,
                     orcid),

    change_maintainer = function(given = NULL, family = NULL, email = NULL,
                                 comment = NULL, orcid = NULL)
      idesc_change_maintainer(self, private, given, family, email, comment,
                              orcid),

    add_me = function(role = "ctb", comment = NULL, orcid = NULL)
      idesc_add_me(self, private, role, comment, orcid),

    add_author_gh = function(username, role = "ctb", comment = NULL, orcid = NULL)
      idesc_add_author_gh(self, private, role = role,
                   username = username,
                   comment = comment, orcid = orcid),

    get_maintainer = function()
      idesc_get_maintainer(self, private),

    coerce_authors_at_r = function()
      idesc_coerce_authors_at_r(self, private),

    ## -----------------------------------------------------------------
    ## URL

    get_urls = function()
      idesc_get_urls(self, private),

    set_urls = function(urls)
      idesc_set_urls(self, private, urls),

    add_urls = function(urls)
      idesc_add_urls(self, private, urls),

    del_urls = function(pattern)
      idesc_del_urls(self, private, pattern),

    clear_urls = function()
      idesc_clear_urls(self, private),

    ## -----------------------------------------------------------------
    ## Remotes

    get_remotes = function()
      idesc_get_remotes(self, private),

    set_remotes = function(remotes)
      idesc_set_remotes(self, private, remotes),

    add_remotes = function(remotes)
      idesc_add_remotes(self, private, remotes),

    del_remotes = function(pattern)
      idesc_del_remotes(self, private, pattern),

    clear_remotes = function()
      idesc_clear_remotes(self, private),

    ## -----------------------------------------------------------------
    ## Built

    get_built = function()
      idesc_get_built(self, private)
  ),

  private = list(
    data = NULL,
    path = NULL,
    notws = character()                   # entries without trailing ws
  )
)

idesc_create <- function(self, private, cmd, file, text, package) {

  if (!is.null(cmd) && substring(cmd, 1, 1) != "!") {
    file <- cmd
    cmd <- NULL
  }

  if (!is.null(cmd)) {
    if (!is.null(file)) warning("file argument ignored")
    if (!is.null(text)) warning("text argument ignored")
    if (!is.null(package)) warning("package argument ignored")
    idesc_create_cmd(self, private, cmd)

  } else if (is.null(cmd) && is.null(file) && is.null(text) &&
             is.null(package)) {
    idesc_create_file(self, private, ".")

  } else if (!is.null(file)) {
    if (!is.null(text)) warning("text argument ignored")
    if (!is.null(package)) warning("package argument ignored")
    idesc_create_file(self, private, file)

  } else if (!is.null(text)) {
    if (!is.null(package)) warning("package argument ignored")
    idesc_create_text(self, private, text)

  } else {
    idesc_create_package(self, private, package)
  }

  invisible(self)
}

idesc_create_cmd <- function(self, private, cmd = c("new")) {
  stopifnot(is_constructor_cmd(cmd))

  if (cmd == "!new") {
    txt <-
'Package: {{ Package }}
Title: {{ Title }}
Version: 1.0.0
Authors@R:
    c(person(given = "Jo", family = "Doe", email = "jodoe@dom.ain",
      role = c("aut", "cre")))
Maintainer: {{ Maintainer }}
Description: {{ Description }}
License: {{ License }}
URL: {{ URL }}
BugReports: {{ BugReports }}
Encoding: UTF-8
'
    txt <- sub("Authors@R:", "Authors@R: ", txt)
    idesc_create_text(self, private, text = txt)
  }

  invisible(self)
}

idesc_create_file <- function(self, private, file) {
  stopifnot(is_path(file))

  if (file.exists(file) && is_dir(file)) file <- find_description(file)
  stopifnot(is_existing_file(file))

  if (is_package_archive(file)) {
    file <- get_description_from_package(file)

  } else {
    private$path <- normalizePath(file)
  }

  tryCatch(
    lines <- readLines(file),
    error = function(e) stop("Cannot read ", file, ": ", e$message)
  )

  idesc_create_text(self, private, lines)
}

idesc_create_text <- function(self, private, text) {
  stopifnot(is.character(text))
  con <- textConnection(text, local = TRUE, encoding = "bytes")
  on.exit(close(con), add = TRUE)
  dcf <- read_dcf(con)
  private$notws <- dcf$notws
  private$data <- dcf$dcf
  check_encoding(self, private, NULL)
}

idesc_create_package <- function(self, private, package) {
  stopifnot(is_string(package))
  path <- system.file(package = package, "DESCRIPTION")
  if (path == "") {
    stop("Cannot find DESCRIPTION for installed package ", package)
  }
  idesc_create_file(self, private, path)
}

idesc_write <- function(self, private, file) {
  if (is.null(file)) file <- private$path
  if (is.null(file)) {
    stop("Cannot write back DESCRIPTION. Note that it is not possible
          to update DESCRIPTION files within package archives")
  }

  mat <- idesc_as_matrix(private$data)

  ## Need to write to a temp file first, to preserve absense of trailing ws,
  ## and also because recently write.dcf cannot write out files in unknown
  ## encodings. So we write the file in UTF-8 and then re-encode it later.
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  ## Need to tell older R not to mess with the encoding
  ## Cannot do this for newer R, but for newer R we use useBytes = TRUE
  ## in write_dcf()
  if (getRversion() < "4.2.0") Encoding(mat) <- "unknown"
  write_dcf(mat, file = tmp, keep.white = names(private$data))

  removed <- ! names(private$notws) %in% colnames(mat)
  if (any(removed)) private$notws <- private$notws[! removed]

  postprocess_trailing_ws(tmp, names(private$notws))
  if (file.exists(file) && is_dir(file)) file <- find_description(file)

  ofile <- file(file, raw = TRUE, open = "wb+")
  on.exit(close(ofile), add = TRUE)

  lines <- readLines(tmp)
  if ("Encoding" %in% colnames(mat)) {
    encoding <- mat[, "Encoding"]
    lines <- iconv(lines, from = "UTF-8", to = encoding)
  }
  writeLines(lines, ofile, useBytes = TRUE)

  invisible(self)
}

idesc_fields <- function(self, private) {
  names(private$data)
}

idesc_has_fields <- function(self, private, keys) {
  stopifnot(is.character(keys), has_no_na(keys))
  keys %in% self$fields()
}

idesc_as_matrix <- function(data) {
  matrix(
    vapply(data, "[[", "", "value"),
    nrow = 1,
    dimnames = list(NULL, names(data))
  )
}

idesc_get <- function(self, private, keys) {
  stopifnot(is.character(keys), has_no_na(keys))
  res <- lapply(private$data[keys], "[[", "value")
  res[vapply(res, is.null, logical(1))] <- NA_character_
  res <- as.character(unlist(res))
  names(res) <- keys
  res
}

idesc_get_field <- function(self, private, key, default, trim_ws, squish_ws) {
  stopifnot(is_string(key))
  stopifnot(is_flag(trim_ws))
  val <- private$data[[key]]$value
  if (!is.null(val)) {
    if (trim_ws) val <- str_trim(val)
    if (squish_ws) val <- str_squish(val)
  }
  val %||% default
}

idesc_get_or_fail <- function(self, private, keys) {
  stopifnot(is.character(keys), has_no_na(keys))
  res <- self$get(keys)
  if (any(is.na(res))) {
    w <- is.na(res)
    msg <- paste0(
      "Could not find DESCRIPTION ",
      if (sum(w) == 1) "field: " else "fields: ",
      paste(sQuote(keys[w]), collapse = ", "),
      "."
    )
    stop(msg, call. = FALSE)
  }
  res
}

idesc_get_list <- function(self, private, key, default, sep, trim_ws, squish_ws) {
  stopifnot(is_string(key), is_flag(trim_ws), is_flag(squish_ws))
  val <- private$data[[key]]$value %||% default
  val <- strsplit(val, sep, fixed = TRUE)[[1]]
  if (trim_ws) val <- str_trim(val)
  if (squish_ws) val <- str_squish(val)
  val
}

## ... are either
## - two unnamed arguments, key and value, or
## - an arbitrary number of named arguments, the names are the keys,
##   the values are the values

idesc_set <- function(self, private, ..., check = TRUE) {
  args <- list(...)

  if (is.null(names(args)) && length(args) == 2) {
    keys <- as_string(args[[1]])
    values <- as_string(args[[2]])

  } else if (!is.null(names(args)) && all(names(args) != "")) {
    keys <- names(args)
    values <- unlist(args)

  } else {
    stop("$set needs two unnamed args, or all named args, see docs")
  }

  fields <- create_fields(keys, enc2utf8(values))
  if (check) {
    lapply(fields, check_field, warn = TRUE)
    check_encoding(self, private, lapply(fields, "[[", "value"))
  }
  private$data[keys] <- fields

  invisible(self)
}

idesc_set_list <- function(self, private, key, list_value, sep) {
  stopifnot(is_string(key), is.character(list_value))
  value <- paste(list_value, collapse = sep)
  idesc_set(self, private, key, value)
}

idesc_del <- function(self, private, keys) {
  stopifnot(is.character(keys), has_no_na(keys))
  private$data <- private$data[setdiff(names(private$data), keys)]
  invisible(self)
}

test_that("get_deps", {
  desc <- description$new(test_path("D1"))

  res <- data.frame(
    stringsAsFactors = FALSE,
    type = c("Imports", "Suggests"),
    package = c("R6", "testthat"),
    version = c("*", "*")
  )

  expect_equal(desc$get_deps(), res)
})


test_that("set_dep", {
  desc <- description$new(test_path("D1"))

  desc$set_dep("igraph")

  res <- data.frame(
    stringsAsFactors = FALSE,
    type = c("Imports", "Imports", "Suggests"),
    package = c("igraph", "R6", "testthat"),
    version = c("*", "*", "*")
  )
  expect_equal(desc$get_deps(), res)

  desc$set_dep("igraph", version = ">= 1.0.0")

  res <- data.frame(
    stringsAsFactors = FALSE,
    type = c("Imports", "Imports", "Suggests"),
    package = c("igraph", "R6", "testthat"),
    version = c(">= 1.0.0", "*", "*")
  )

  expect_equal(desc$get_deps(), res)

  desc$set_dep("igraph", type = "Depends", version = ">= 1.0.0")

  res <- data.frame(
    stringsAsFactors = FALSE,
    type = c("Imports", "Imports", "Suggests", "Depends"),
    package = c("igraph", "R6", "testthat", "igraph"),
    version = c(">= 1.0.0", "*", "*", ">= 1.0.0")
  )

  expect_equal(desc$get_deps(), res)

})

test_that("set_dep for the first dependency", {

  desc <- description$new("!new")

  expect_equal(eval(formals(desc$set_dep)[["type"]])[[1L]], "Imports")

  desc$set_dep("igraph")

  res <- data.frame(
    stringsAsFactors = FALSE,
    type = c("Imports"),
    package = c("igraph"),
    version = c("*")
  )
  expect_equal(desc$get_deps(), res)
})

test_that("set_dep preserves order", {
  desc <- description$new("!new")

  desc$set_deps(data.frame(
    stringsAsFactors = FALSE,
    type = c("Depends", "Imports", "Imports"),
    package = c("R", "covr", "testthat"),
    version = "*"
  ))
  desc$set_dep("R6", "Imports")

  expect_equal(
    desc$get_deps()$package,
    c("R", "covr", "R6", "testthat")
  )
})

test_that("set_dep inserts at end if not ordered", {
  desc <- description$new("!new")

  desc$set_deps(data.frame(
    stringsAsFactors = FALSE,
    type = "Imports",
    package = c("testthat", "covr"),
    version = "*"
  ))
  desc$set_dep("R6", "Imports")

  expect_equal(
    desc$get_deps()$package,
    c("testthat", "covr", "R6")
  )
})

test_that("del_dep", {
  desc <- description$new(test_path("D1"))

  desc$set_dep("igraph")
  desc$set_dep("igraph", type = "Depends", version = ">= 1.0.0")
  desc$del_dep("igraph")

  res <- data.frame(
    stringsAsFactors = FALSE,
    type = c("Imports", "Suggests"),
    package = c("R6", "testthat"),
    version = c("*", "*")
  )

  expect_equal(desc$get_deps(), res)

  desc <- description$new(test_path("D1"))

  desc$set_dep("igraph")
  desc$set_dep("igraph", type = "Depends", version = ">= 1.0.0")
  desc$del_dep("igraph", type = "Imports")

  res <- data.frame(
    stringsAsFactors = FALSE,
    type = c("Imports", "Suggests", "Depends"),
    package = c("R6", "testthat", "igraph"),
    version = c("*", "*", ">= 1.0.0")
  )

  expect_equal(desc$get_deps(), res)

})

test_that("deleting all dependencies", {

  desc <- description$new(test_path("D1"))
  desc$del_deps()
  expect_equal(desc$get("Imports"), c(Imports = NA_character_))
  expect_equal(desc$get("Suggests"), c(Suggests = NA_character_))

})

test_that("deleting a non-dependency is OK", {

  desc <- description$new(test_path("D1"))
  before <- desc$get("Imports")
  desc$del_dep("foobar", "Imports")
  after <- desc$get("Imports")
  expect_equal(before, after)
})

test_that("has_dep", {

  desc <- description$new(test_path("D1"))
  expect_true(desc$has_dep("R6"))
  expect_true(desc$has_dep("testthat"))

  expect_true(desc$has_dep("R6", "Imports"))
  expect_true(desc$has_dep("testthat", "Suggests"))

  expect_false(desc$has_dep("foobar"))

  expect_false(desc$has_dep("testthat", "Imports"))

  expect_error(desc$has_dep(123))
  expect_error(desc$has_dep("testthat", "xxx"))
})

test_that("has_dep works when package listed twice", {
  desc <- description$new(test_path("D2"))
  expect_true(desc$has_dep("Rcpp"))
  expect_true(desc$has_dep("Rcpp", "Imports"))
  expect_true(desc$has_dep("Rcpp", "LinkingTo"))
  expect_false(desc$has_dep("Rcpp", "Suggests"))
})

test_that("issue #34 is fine (empty dep fields)", {

  empty_deps <- data.frame(
    stringsAsFactors = FALSE,
    type = character(),
    package = character(),
    version = character()
  )

  desc <- description$new(test_path("D4"))
  expect_silent(deps <- desc$get_deps())
  expect_equal(deps, empty_deps)

  desc$set(Imports = "")
  expect_silent(deps <- desc$get_deps())
  expect_equal(deps, empty_deps)

  expect_silent(desc$set_deps(deps))
  expect_silent(deps <- desc$get_deps())
  expect_equal(deps, empty_deps)
})

test_that("no dependencies at all", {

  empty_deps <- data.frame(
    stringsAsFactors = FALSE,
    type = character(),
    package = character(),
    version = character()
  )

  desc <- description$new(test_path("D6"))
  expect_silent(deps <- desc$get_deps())
  expect_equal(deps, empty_deps)

  expect_silent(desc$set_deps(deps))
  expect_silent(deps <- desc$get_deps())
  expect_equal(deps, empty_deps)
})

test_that("extra whitespace is removed from deps, but kept in raw data", {
  D7 <- description$new(test_path("D7"))
  deps <- D7$get_deps()
  expect_equal(
    deps$version[deps$package == "lme4"],
    ">= 1.0.0"
  )
  expect_equal(
    deps$version[deps$package == "survival"],
    ">= 1.0.1"
  )
  expect_match(
    D7$get("Suggests"),
    "lme4\n        (>= 1.0.0), survival (>=\n        1.0.1)",
    fixed = TRUE
  )
})

test_that("Encoding field is observed", {

  expect_silent(
    desc <- description$new(
      text = paste0(
        "Package: foo\n",
        "Title: Foo Package\n",
        "Author: Package Author\n",
        "Maintainer: Package Author <author@here.net>\n",
        "Description: The great foo package.\n",
        "License: GPL\n",
        "Encoding: UTF-8\n"
      )
    )
  )

  expect_silent(desc$set(Author = "G\u00e1bor Cs\u00e1rdi"))
})

test_that("Unset Encoding results warning", {

  expect_warning(
    desc <- description$new(
      text = paste0(
        "Package: foo\n",
        "Title: Foo Package\n",
        "Author: Package Author\n",
        "Maintainer: G\u00e1bor Cs\u00e1rdi <author@here.net>\n",
        "Description: The great foo package.\n",
        "License: GPL\n"
      )
    ),
    "Encoding"
  )

  expect_warning(desc$set(Author = "G\u00e1bor Cs\u00e1rdi"), "Encoding")

})

test_that("different encoding is converted to UTF-8 when reading", {

  expect_silent(
    desc <- description$new(
      text = paste0(
        "Package: foo\n",
        "Title: Foo Package\n",
        "Author: Package Author\n",
        "Maintainer: G\xE1bor Cs\xE1rdi <author@here.net>\n",
        "Description: The great foo package.\n",
        "License: GPL\n",
        "Encoding: latin1\n"
      )
    )
  )

  expect_equal(Encoding(desc$get("Maintainer")), "UTF-8")
  expect_silent(desc$set(Author = "G\u00e1bor Cs\u00e1rdi"))
})

test_that("handles case when text is marked with a non-default locale", {

  expect_silent(
    desc <- description$new(
      text = enc2utf8(paste0(
        "Package: foo\n",
        "Title: Foo Package\n",
        "Author: Package Author\n",
        "Maintainer: G\u00e1bor Cs\u00e1rdi <author@here.net>\n",
        "Description: The great foo package.\n",
        "License: GPL\n",
        "Encoding: UTF-8\n"
      ))
    )
  )

  expect_equal(Encoding(desc$get("Maintainer")), "UTF-8")
  expect_silent(desc$set(Author = "G\u00e1bor Cs\u00e1rdi"))
})

test_that("encoding is converted to specified when writing", {

  desc <- description$new(
    text = paste0(
      "Package: foo\n",
      "Title: Foo Package\n",
      "Author: Package Author\n",
      "Maintainer: G\xE1bor Cs\xE1rdi <author@here.net>\n",
      "Description: The great foo package.\n",
      "License: GPL\n",
      "Encoding: latin1\n"
    )
  )

  desc$write(file = tmp <- tempfile())
  on.exit(unlink(tmp))
  tmpf <- file(tmp, encoding = "", open = "r")
  lines <- readLines(tmpf, encoding = "latin1")
  close(tmpf)
  maint <- grep("^Maintainer", lines, value = TRUE)

  exp <- "Maintainer: G\xE1bor Cs\xE1rdi <author@here.net>"
  Encoding(exp) <- "latin1"
  expect_equal(charToRaw(maint), charToRaw(exp))
})

test_that("no encoding roundtrip when writing", {

  desc <- description$new(
    text = paste0(
      "Package: foo\n",
      "Name: \u0144\u0119\u0118\u0142\u0141\u017A\u017C\n",
      "Encoding: UTF-8\n"
    )
  )

  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  desc$write(tmp)
  desc2 <- desc(tmp)
  expect_equal(desc$get("Name"), desc2$get("Name"))
  expect_equal(Encoding(desc2$get("Name")), "UTF-8")
})

test_that("checking other fields is always ok", {

  desc <- description$new(test_path("D1"))
  desc$set("Note", "Blah-blah")

  expect_equal(desc$get("Note"), c(Note = "Blah-blah"))
})


test_that("we catch syntax errors", {

  desc <- description$new(test_path("D1"))

  expect_warning(
    desc$set("Package", "444!!! not a valid package name"),
    "must only contain ASCII letters.*must start with a letter"
  )

  expect_warning(
    desc$set("Package", "4aaaa"),
    "must start with a letter"
  )
})


test_that("generic field check is always true", {
  field <- list(key = "XY", value = "foobar")
  class(field) <- "DescriptionField"
  expect_silent(check_field(field, warn = TRUE))
  expect_true(check_field(field))
})


test_chk <- function(field, value, warn_msg, warn = TRUE, class = field) {
  rec <- list(key = field, value = value)
  class(rec) <- c(paste0("Description", class), "DescriptionField")

  test_that(paste(field, "syntax"), {
    if (warn) {
      expect_warning(check_field(rec, warn = TRUE), warn_msg)
    } else {
      expect_silent(check_field(rec, warn = TRUE))
    }
  })
}

test_chk("License", "GPL", warn = FALSE)
test_chk("License", "", "must not be empty")
test_chk("License", "almost good but \x80", "only ASCII characters")

test_chk("Title", "This is a Good Title", warn = FALSE)
test_chk("Title", "", "must not be empty")
test_chk("Title", "Not a good title.", "must not end with a period")
test_chk("Title", "Good title by Bugs Bunny et al.", warn = FALSE)

test_chk("Maintainer", "Bugs Bunny <bb@acme.com>", warn = FALSE)
test_chk("Maintainer", "ORPHANED", warn = FALSE)
test_chk("Maintainer", "", "must not be empty")
test_chk("Maintainer", "foobar", "must contain an email address")

test_chk("RepoList", "", warn = FALSE)
test_chk("RepoList", "http://cran.rstudio.com", warn = FALSE)
test_chk("RepoList", "http://cran.rstudio.com, https://cran.r-project.org",
         warn = FALSE)
test_chk("RepoList", "foobar", "must be a comma .* repository URLs")
test_chk("RepoList", "http://foo.bar http://fobar", "must be a comma")

test_chk("URL", "http://acme.com", warn = FALSE)
test_chk("URL", "not this one", "must be a http, https or ftp URL")

test_chk("URLList", "", warn = FALSE)
test_chk("URLList", "http://cran.rstudio.com", warn = FALSE)
test_chk("URLList", "http://cran.rstudio.com, https://cran.r-project.org",
         warn = FALSE)
test_chk("URLList", "foobar", "must be a comma .* URLs")
test_chk("URLList", "http://foo.bar http://fobar", "must be a comma")

test_chk("Priority", "recommended", warn = FALSE)
test_chk("Priority", "foobar", "must be one of")

test_chk("LazyLoad", "yes", warn = FALSE, class = "Logical")
test_chk("LazyLoad", "foobar", "must be one of", class = "Logical")

test_chk("VignetteBuilder", "devtools, knitr", warn = FALSE,
         class = "PackageList")
test_chk("VignetteBuilder", "this is not", "must be a comma",
         class = "PackageList")

test_chk("Encoding", "UTF-8", warn = FALSE)
test_chk("Encoding", "foobar", "must be one of")

test_chk("OSType", "unix", warn = FALSE)
test_chk("OSType", "foobar", "must be one of")

test_chk("Type", "Translation", warn = FALSE)
test_chk("Type", "foobar", "must be either")

test_chk("Classification", "", warn = FALSE)

test_chk("Language", "hun, deu", warn = FALSE)
test_chk("Language", "this is not", "must be a list of IETF language")

test_chk("Date", "2015-01-21", warn = FALSE)
test_chk("Date", "foobar", "must be an ISO date")

test_chk("Compression", "gzip", warn = FALSE)
test_chk("Compression", "foobar", "must be one of")

test_chk("Repository", "", warn = FALSE)

test_chk("AddedByRCMD", "", warn = FALSE)

test_that("get, set, etc. urls", {
  desc <- description$new(test_path("D2"))
  expect_identical(
    desc$get_urls(), "https://github.com/klutometis/roxygen"
  )

  desc$set_urls(c("https://foo.bar", "http://x.y"))
  expect_identical(desc$get_urls(), c("https://foo.bar", "http://x.y"))

  desc$add_urls("http://another.one")
  expect_identical(
    desc$get_urls(),
    c("https://foo.bar", "http://x.y", "http://another.one")
  )

  desc$del_urls("^http://")
  expect_identical(desc$get_urls(), "https://foo.bar")

  desc$clear_urls()
  expect_identical(desc$get_urls(), character())

  desc$add_urls("http://another.one")
  expect_identical(desc$get_urls(), "http://another.one")

  desc$del_urls("another.one")
  expect_identical(desc$get_urls(), character())
  expect_identical(desc$get("URL"), c(URL = NA_character_))
})

test_that("leading newlines and embedded descriptors are ignored", {
  desc <- description$new(test_path("D8"))
  expect_identical(
    desc$get_urls(),
    c("https://github.com/ropensci/hunspell#readme",
      "https://hunspell.github.io")
  )
})

test_that("normalization", {

  desc <- description$new("!new")
  desc$set("Imports", "foo, bar, foobar")

  before_fields <- desc$fields()
  before_data <- desc$get(before_fields)
  desc$normalize()
  after_fields <- desc$fields()
  after_data <- desc$get(after_fields)

  expect_equal(sort(before_fields), sort(after_fields))
  expect_lt(match("Imports", after_fields), match("Imports", before_fields))
  expect_gt(match("Encoding", after_fields), match("Encoding", before_fields))
  expect_equal(after_data[["Imports"]], "\n    bar,\n    foo,\n    foobar")

})

test_that("reformatting", {

  desc <- description$new("!new")
  desc$set("Imports", "foo, bar, foobar")

  before_fields <- desc$fields()
  before_data <- desc$get(before_fields)
  desc$reformat_fields()
  after_fields <- desc$fields()
  after_data <- desc$get(after_fields)

  expect_equal(before_fields, after_fields)
  expect_equal(after_data[["Imports"]], "\n    bar,\n    foo,\n    foobar")

})

test_that("reordering", {

  desc <- description$new("!new")
  desc$set("Imports", "foo, bar, foobar")

  before_fields <- desc$fields()
  before_data <- desc$get(before_fields)
  desc$reorder_fields()
  after_fields <- desc$fields()
  after_data <- desc$get(after_fields)

  expect_equal(sort(before_fields), sort(after_fields))
  expect_lt(match("Imports", after_fields), match("Imports", before_fields))
  expect_gt(match("Encoding", after_fields), match("Encoding", before_fields))
  expect_identical(before_data[after_fields], after_data)

})

test_that("Test expected LaTeX output", {
  desc <- description$new("!new")

  desc$set_authors(person("Kirill", "M\u{00fc}ller", email = "aaa@bbb.xx", role = "cre"))
  desc$set(Package = "Test.Package",
           Title = "Must be in Title Case",
           Description = "Words not in the dictionary must be 'quoted'. \"Double quotes\" can also be used, as well as \\_{}[]^$#%. Must end with a full stop.",
           License = "CC-BY-SA",
           URL = "http://somewhere.io, http://somewhereel.se",
           BugReports = "http://somewhere.io/trac")

  new <- capture.output(print(desc$to_latex()))
  old <- readLines(test_path("output/to_latex.tex"), encoding = "UTF-8")

  new1 <- enc2native(new)
  old1 <- enc2native(old)

  expect_equal(new1, old1)
})

test_that("we can get the authors", {
  desc <- description$new(test_path("D2"))

  ans <- c(
    person("Hadley", "Wickham", email = "h.wickham@gmail.com",
           role = c("aut", "cre", "cph")),
    person("Peter", "Danenberg", email = "pcd@roxygen.org",
           role = c("aut", "cph")),
    person("Manuel", "Eugster", role = c("aut", "cph")),
    person("RStudio", role = "cph")
  )

  expect_identical(desc$get_authors(), ans)
})

test_that("we can set the authors", {

  desc1 <- description$new(test_path("D1"))
  desc2 <- description$new(test_path("D2"))

  desc1$set_authors(desc2$get_authors())

  expect_identical(desc1$get_authors(), desc2$get_authors())
})

test_that("we can add an author", {
  desc <- description$new(test_path(test_path("D2")))

  desc$add_author("G\u00e1bor", "Cs\u00e1rdi", email = "csardi.gabor@gmail.com",
                  role = "ctb", comment = "Really?")

  expect_identical(
    format(desc$get_authors()[5]),
    "G\u00e1bor Cs\u00e1rdi <csardi.gabor@gmail.com> [ctb] (Really?)"
  )
})

test_that("we can add an author with ORCID via comment", {

  R_version <- paste(R.version$major,
                   R.version$minor,
                   sep = ".")

  skip_if_not(R_version >= "3.5.0")

  desc <- description$new(cmd = "!new")

  desc$add_author("G\u00e1bor", "Cs\u00e1rdi", email = "csardi.gabor@gmail.com",
                  role = "ctb",
                  comment = c(ORCID = "0000-0001-7098-9676", what="he did it"))

  expect_identical(
    format(desc$get_authors()[2]),
    paste0(
      "G\u00e1bor Cs\u00e1rdi <csardi.gabor@gmail.com> [ctb] ",
      "(<https://orcid.org/0000-0001-7098-9676>, he did it)"
    )
  )
})

test_that("we can add an author with ORCID", {

  R_version <- paste(R.version$major,
                     R.version$minor,
                     sep = ".")

  skip_if_not(R_version >= "3.5.0")

  desc <- description$new(cmd = "!new")

  desc$add_author("G\u00e1bor", "Cs\u00e1rdi", email = "csardi.gabor@gmail.com",
                  role = "ctb",
                  comment = c(what="he did it"),
                  orcid = "0000-0001-7098-9676")

  expect_identical(
    format(desc$get_authors()[2]),
    paste0(
      "G\u00e1bor Cs\u00e1rdi <csardi.gabor@gmail.com> [ctb] ",
      "(he did it, <https://orcid.org/0000-0001-7098-9676>)"
    )
  )
})

test_that("we cannot add an author with malformatted comment", {

  desc <- description$new(cmd = "!new")

  expect_error(desc$add_author("G\u00e1bor", "Cs\u00e1rdi", email = "csardi.gabor@gmail.com",
                  role = "ctb",
                  comment = c(ORCID = "orcid_number", what=NA)),
               "is_named_character_or_null")


})

test_that("we can search for authors", {
  desc <- description$new(test_path("D9"))
  authors <- desc$get_authors()

  expect_equal(
    search_for_author(authors, given = "Hadley")$index,
    1L
  )

  expect_equal(
    search_for_author(authors, orcid = "0000-0003-4757-117X")$index,
    1L
  )


  expect_equal(
    search_for_author(authors, orcid = "117X")$index,
    1L
  )

})

test_that("we can add a role to an author", {
  desc <- description$new(test_path("D2"))

  desc$add_author("G\u00e1bor", "Cs\u00e1rdi", email = "csardi.gabor@gmail.com",
                  role = "ctb", comment = "Really?")
  desc$add_role(given = "G\u00e1bor", role = "cph")

  expect_identical(
    format(desc$get_authors()[5]),
    "G\u00e1bor Cs\u00e1rdi <csardi.gabor@gmail.com> [ctb, cph] (Really?)"
  )
})

test_that("we can add an ORCID to an author", {
  R_version <- paste(R.version$major,
                     R.version$minor,
                     sep = ".")

  skip_if_not(R_version >= "3.5.0")

  desc <- description$new(test_path("D2"))

  desc$add_author("G\u00e1bor", "Cs\u00e1rdi", email = "csardi.gabor@gmail.com",
                  role = "ctb", comment = "Really?")
  desc$add_orcid(given = "G\u00e1bor", orcid = "0000-0001-7098-9676")

  expect_identical(
    format(desc$get_authors()[5]),
    paste0(
      "G\u00e1bor Cs\u00e1rdi <csardi.gabor@gmail.com> [ctb] ",
      "(Really?, <https://orcid.org/0000-0001-7098-9676>)"
    )
  )
})

test_that("we can replace the ORCID of an author", {
  R_version <- paste(R.version$major,
                     R.version$minor,
                     sep = ".")

  skip_if_not(R_version >= "3.5.0")

  desc <- description$new(test_path("D9"))

  desc$add_orcid(given = "Hadley", orcid = "0000-0003-4757-117X")

  expect_identical(
    format(desc$get_authors()[1]),
    paste0(
      "Hadley Wickham <h.wickham@gmail.com> [aut, cre, cph] ",
      "(<https://orcid.org/0000-0003-4757-117X>)"
    )
  )
})

test_that("we cannot add the same ORCID to more than one author", {

  desc <- description$new(test_path("D10"))

  expect_error(desc$add_orcid(given = "Peter",
                              orcid = "orcidid"),
               "More than one author correspond")

})


test_that("we can delete an author", {
  desc <- description$new(test_path("D2"))

  expect_message(desc$del_author(given = "Hadley"), "removed:")
  expect_message(desc$del_author(family = "Danenberg"), "removed:")

  ans <- c(
    person("Manuel", "Eugster", role = c("aut", "cph")),
    person("RStudio", role = "cph")
  )

  expect_identical(desc$get_authors(), ans)
})

test_that("we can delete a role", {
  desc <- description$new(test_path("D2"))

  desc$add_author("G\u00e1bor", "Cs\u00e1rdi", email = "csardi.gabor@gmail.com",
                  role = "ctb", comment = "Really?")
  desc$add_role(given = "G\u00e1bor", role = "cph")
  desc$del_role(family = "Cs\u00e1rdi", role = "ctb")

  expect_identical(
    format(desc$get_authors()[5]),
    "G\u00e1bor Cs\u00e1rdi <csardi.gabor@gmail.com> [cph] (Really?)"
  )
})

test_that("we can change the maintainer", {
  desc <- description$new(test_path("D2"))

  desc$change_maintainer(given = "Peter")

  ans <- c(
    person("Hadley", "Wickham", email = "h.wickham@gmail.com",
           role = c("aut", "cph")),
    person("Peter", "Danenberg", email = "pcd@roxygen.org",
           role = c("aut", "cph", "cre")),
    person("Manuel", "Eugster", role = c("aut", "cph")),
    person("RStudio", role = "cph")
  )

  expect_identical(desc$get_authors(), ans)

})

test_that("add_me works", {
  withr::local_envvar(
    FULLNAME = "Bugs Bunny",
    EMAIL = "bugs.bunny@acme.com",
    ORCID_ID = ""
  )

  desc <- description$new(test_path("D2"))
  desc$add_me(comment = "Yikes!")

  expect_identical(
    format(desc$get_authors()[5]),
    "Bugs Bunny <bugs.bunny@acme.com> [ctb] (Yikes!)"
  )
})

test_that("add_me can use ORCID_ID", {
  R_version <- paste(R.version$major,
                     R.version$minor,
                     sep = ".")

  skip_if_not(R_version >= "3.5.0")

  withr::local_envvar(
    FULLNAME = "Bugs Bunny",
    EMAIL = "bugs.bunny@acme.com",
    ORCID_ID = "0000-0002-0775-162X"
  )

  desc <- description$new(test_path("D2"))
  desc$add_me()

  expect_identical(
    format(desc$get_authors()[5]),
    paste0(
      "Bugs Bunny <bugs.bunny@acme.com> [ctb] ",
      "(<https://orcid.org/0000-0002-0775-162X>)"
    )
  )
})

test_that("add_author_gh works", {
  withr::local_options(
    desc.gh_user = list(name = "Jeroen Ooms", email = "notanemail")
  )

  desc <- description$new(test_path("D2"))
  desc$add_author_gh(username = "jeroen")

  expect_identical(
    format(desc$get_authors()[5]),
    "Jeroen Ooms <notanemail> [ctb]"
  )
})

test_that("error if not Authors@R field", {

  desc <- description$new(test_path("D1"))
  expect_error(
    desc$get_authors(),
    "No 'Authors@R' field"
  )
})

test_that("message if not author to delete does not exist", {

  desc <- description$new(test_path("D2"))
  expect_message(
    desc$del_author(given = "G\u00e1bor"),
    "Could not find author to remove"
  )
})

test_that("get_author is OK", {

  D2 <- description$new(test_path("D2"))

  expect_equal(
    D2$get_author(role = "cre"),
    person(
      given = "Hadley",
      family = "Wickham",
      email = "h.wickham@gmail.com",
      role = c("aut", "cre", "cph"),
      comment = NULL
    )
  )

  expect_equal(
    D2$get_author(role = "aut"),
    D2$get_authors()[1:3]
  )

  D1 <- description$new(test_path("D1"))
  expect_null(D1$get_author(role = "cre"))
})

test_that("get_maintainer is OK, too", {

  D1 <- description$new(test_path("D1"))
  expect_equal(
    D1$get_maintainer(),
    "G\u00e1bor Cs\u00e1rdi <csardi.gabor@gmail.com>"
  )

  D2 <- description$new(test_path("D2"))
  expect_equal(
    D2$get_maintainer(),
    "Hadley Wickham <h.wickham@gmail.com>"
  )

  D1$del("Maintainer")
  expect_equal(
    D1$get_maintainer(),
    NA_character_
  )
})

test_that("coerce_authors_at_r if there is no Authors@R field", {
  D1 <- description$new(test_path("D1"))
  expect_error(D1$get_authors())
  expect_silent(D1$coerce_authors_at_r())
  expect_silent(auth <- D1$get_authors())
  expect_equal(
    auth,
    as.person("G\u00e1bor Cs\u00e1rdi <csardi.gabor@gmail.com> [aut, cre]")
  )
  # author and maintainer are the same in this case
  expect_equal(D1$get_author("cre"), D1$get_author("aut"))
})

test_that("coerce_authors_at_r does nothing if there IS an Authors@R field", {
  D2 <- description$new(test_path("D2"))
  expect_null(D2$coerce_authors_at_r())
})

test_that("coerce_authors_at_r errors if no authors fields at all", {
  D1 <- description$new(test_path("D1"))
  D1$del("Author")
  expect_error(D1$coerce_authors_at_r(), "No 'Authors@R' or 'Author' field!")
})

test_that("coerce_authors_at_r with multiple authors in Author: field", {
  D6 <- description$new(test_path("D6"))
  expect_silent(D6$coerce_authors_at_r())
  expect_equal(
    D6$get_author("cre"),
    as.person("Gábor Csárdi <csardi.gabor@gmail.com> [aut, cre]")
  )
  a <- D6$get_author("aut")
  expect_equal(a[1], as.person("Gábor Csárdi <csardi.gabor@gmail.com> [aut, cre]"))
  expect_equal(a[2], as.person("John Muschelli [aut]"))
})

test_that("coerce_authors_at_r handles role tags, #114", {
  D13 <- description$new(test_path("D13"))
  expect_silent(D13$coerce_authors_at_r())
  # Joe Developer is a maintainer
  expect_equal(
    D13$get_author("cre"),
    as.person("Joe Developer <Joe.Developer@some.domain.net> [aut, cre]")
  )
  # Joe and Pat Developer are authors
  a <- D13$get_author("aut")
  expect_length(a, 2)
  expect_equal(
    a[1],
    as.person("Joe Developer <Joe.Developer@some.domain.net> [aut, cre]")
  )
  expect_equal(a[2], as.person("Pat Developer [aut]"))
  # "A. User" is a contributor
  expect_equal(D13$get_author("ctb"), as.person("A. User [ctb]"))
})

test_that("coerce_authors_at_r ignores reference to AUTHOR files, #114", {
  D14 <- description$new("D14")
  expect_message(D14$coerce_authors_at_r(), "AUTHOR file")
  expect_equal(
    D14$get_authors(),
    as.person("Gábor Csárdi <csardi.gabor@gmail.com> [aut, cre]")
  )
})

test_that("coerce_authors_at_r handles maintainer not being author", {
  D15 <- description$new("D15")
  expect_silent(D15$coerce_authors_at_r())
  expect_equal(
    D15$get_author("cre"),
    as.person("Masami Saga <msaga@mtb.biglobe.ne.jp> [cre]")
  )
  expect_equal(
    D15$get_author("aut"),
    as.person("The Institute of Statistical Mathematics [aut]")
  )
})

test_that("add_author if there is no Authors@R field", {
  D1 <- description$new(test_path("D1"))
  D1$add_author("Gabor", "Csardi", "csardi.gabor@gmail.com", role = "ctb")
  expect_identical(
    format(D1$get_authors()[1]),
    "Gabor Csardi <csardi.gabor@gmail.com> [ctb]"
  )
})

test_that("add myself if there is no Authors@R field", {
  withr::local_envvar(
    FULLNAME = "Bugs Bunny",
    EMAIL = "bugs.bunny@acme.com",
    ORCID_ID = ""
  )

  D1 <- description$new(test_path("D1"))
  D1$add_me(comment = "Yikes!")

  expect_identical(
    format(D1$get_authors()[1]),
    "Bugs Bunny <bugs.bunny@acme.com> [ctb] (Yikes!)"
  )
})

test_that("normalization keeps authors in UTF-8", {
  D11 <- description$new(test_path("D11"))
  expect_equal(
    Encoding(private(D11)$data$`Authors@R`$value),
    "UTF-8"
  )
  D11$normalize()
  expect_equal(
    Encoding(private(D11)$data$`Authors@R`$value),
    "UTF-8"
  )
})

test_that("long comments are deparsed properly", {
  authors <- c(
    person(
      given = "First",
      family = "Last",
      role = c("aut", "cre"),
      email = "flast@email.org",
      comment = c(
        ORCID = "0000-0000-0000-0000",
        affiliation = "University One"
      )
    ),
    person(
      given = "Second",
      family = "Last",
      role = "aut",
      email = "slast@email.org",
      comment = c(
        ORCID = "0000-0000-0000-0000",
        affiliation = c("University One", "University Two")
      )
    )
  )

  desc <- desc::description$new("!new")
  desc$set_authors(authors)

  expect_equal(
    desc$get_authors()[[1]]$comment,
    authors[[1]]$comment
  )
  expect_equal(
    desc$get_authors()[[2]]$comment,
    authors[[2]]$comment
  )
})

test_that("deparse_authors_at_r", {
  # old R deparses named vectors differently
  if (getRversion() < "3.5") skip("Needs newer R")

  ppl <- c(
    person("Hadley", "Wickham", , "hadley@rstudio.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0003-4757-117X")
           ),
    person("Jennifer", "Bryan", , "jenny@rstudio.com", role = "aut",
           comment = c(ORCID = "0000-0002-6983-2759")
           ),
    person("RStudio", role = c("cph", "fnd"))
  )

  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)

  desc <- description$new(text = "")

  desc$set_authors(ppl[[1]])
  desc$write(tmp)
  expect_snapshot(readLines(tmp))

  desc$set_authors(ppl)
  desc$write(tmp)
  expect_snapshot(readLines(tmp))
})

test_that("can create new object", {
  desc <- description$new("!new")

  expect_true(!is.na(desc$get("Package")))
  expect_true(!is.na(desc$get("Title")))
  expect_true(!is.na(desc$get("Version")))
  expect_true(!is.na(desc$get("Authors@R")))
  expect_true(!is.na(desc$get("Maintainer")))
  expect_true(!is.na(desc$get("Description")))
  expect_true(!is.na(desc$get("License")))
  expect_true(is.na(desc$get("LazyData")))
  expect_true(!is.na(desc$get("URL")))
  expect_true(!is.na(desc$get("BugReports")))
})

test_that("can read object from file", {
  desc <- description$new(test_path("D1"))

  expect_true(!is.na(desc$get("Package")))
  expect_true(!is.na(desc$get("Title")))
  expect_true(!is.na(desc$get("Version")))
  expect_true(!is.na(desc$get("Author")))
  expect_true(!is.na(desc$get("Maintainer")))
  expect_true(!is.na(desc$get("Description")))
  expect_true(!is.na(desc$get("License")))
  expect_true(!is.na(desc$get("URL")))
  expect_true(!is.na(desc$get("BugReports")))

})

test_that("can read object from character vector", {
  lines <- readLines(test_path("D1"))
  desc <- description$new(text = lines)

  expect_true(!is.na(desc$get("Package")))
  expect_true(!is.na(desc$get("Title")))
  expect_true(!is.na(desc$get("Version")))
  expect_true(!is.na(desc$get("Author")))
  expect_true(!is.na(desc$get("Maintainer")))
  expect_true(!is.na(desc$get("Description")))
  expect_true(!is.na(desc$get("License")))
  expect_true(!is.na(desc$get("URL")))
  expect_true(!is.na(desc$get("BugReports")))

})

test_that("DESCRPTION is read by default", {

  wd <- getwd()
  on.exit(setwd(wd), add = TRUE)
  setwd("files")

  d1 <- description$new()
  d2 <- description$new("DESCRIPTION")

  expect_equal(d1, d2)
})

test_that("From installed package", {

  desc <- description$new(package = "utils")
  expect_match(desc$get("Author"), "Core Team")

  expect_error(
    description$new(package = "fgsdgsdhldsknfglkedsfgsdf"),
    "Cannot find DESCRIPTION for installed package"
  )
})

test_that("Package root is found", {

  wd <- getwd()
  on.exit(setwd(wd), add = TRUE)
  setwd("files")

  d1 <- description$new()

  dir.create("subdir", showWarnings = FALSE)
  setwd("subdir")
  d2 <- description$new()

  expect_equal(d1, d2)
})

test_that("get, set, etc. remotes", {
  desc <- description$new(test_path("D2"))
  expect_identical(
    desc$get_remotes(),
    c("foo/digest",
      "svn::https://github.com/hadley/stringr",
      "local::/pkgs/testthat"
      )
  )

  desc$set_remotes(c("bar/knitr", "local::/pkgs/Rcpp"))
  expect_identical(desc$get_remotes(), c("bar/knitr", "local::/pkgs/Rcpp"))

  desc$add_remotes("github::brewer/brew")
  expect_identical(
    desc$get_remotes(),
    c("bar/knitr", "local::/pkgs/Rcpp", "github::brewer/brew")
  )

  desc$del_remotes("^local::")
  expect_identical(
    desc$get_remotes(),
    c("bar/knitr", "github::brewer/brew")
  )

  desc$clear_remotes()
  expect_identical(desc$get_remotes(), character())

  desc$add_remotes("hadley/stringr")
  expect_identical(desc$get_remotes(), "hadley/stringr")

  desc$del_remotes("stringr")
  expect_identical(desc$get_remotes(), character())
  expect_identical(desc$get("Remotes"), c(Remotes = NA_character_))

  expect_warning(
    desc$set("Remotes", "my remote"),
    "must be a comma separated list of remotes"
  )
})

test_that("get works", {
  desc <- description$new(test_path("D1"))

  expect_equal(desc$get("Package"), c(Package = "desc"))
  expect_equal(desc$get("Version"), c(Version = "1.0.0"))
  expect_equal(desc$get("Author"), c(Author = "G\u00e1bor Cs\u00e1rdi"))
  expect_equal(desc$get("Imports"), c(Imports = "\n    R6"))
})

test_that("get nothing", {
  desc <- description$new(test_path("D1"))
  empty <- structure(character(), names = character())
  expect_identical(desc$get(character()), empty)
})

test_that("get_field works", {
  desc <- description$new(test_path("D1"))

  expect_identical(desc$get_field("Package"), "desc")
  expect_identical(desc$get_field("Version"), "1.0.0")
  expect_identical(desc$get_field("Author"), "G\u00e1bor Cs\u00e1rdi")
  expect_identical(desc$get_field("Imports"), "R6")
  expect_identical(desc$get_field("Imports", trim_ws = FALSE), "\n    R6")
  expect_match(desc$get_field("Description", trim_ws = FALSE), "\\s+")
  expect_match(desc$get_field("Description", trim_ws = TRUE, squish_ws = FALSE), "\\s+")
  expect_false(grepl("\n", desc$get_field("Description", trim_ws = TRUE)))
  expect_false(grepl("\n", desc$get_field("Description", trim_ws = FALSE, squish_ws = TRUE)))

  expect_error(
    desc$get_field("package"),
    "Field 'package' not found"
  )
})

test_that("get_or_fail works", {
  desc <- description$new(test_path("D1"))

  expect_equal(desc$get_or_fail("Package"), c(Package = "desc"))
  expect_equal(desc$get_or_fail("Version"), c(Version = "1.0.0"))
  expect_equal(desc$get_or_fail("Author"), c(Author = "G\u00e1bor Cs\u00e1rdi"))
  expect_equal(desc$get_or_fail("Imports"), c(Imports = "\n    R6"))

  expect_equal(
    desc$get_or_fail(c("Package", "Version")),
    c(Package = "desc", Version = "1.0.0")
  )

  expect_error(
    desc$get_or_fail("package"),
    "Could not find DESCRIPTION field.*package"
  )
  expect_error(
    desc$get_or_fail(c("Package", "versionx")),
    "Could not find DESCRIPTION field.*versionx"
  )
  expect_error(
    desc$get_or_fail(c("Package", "versionx", "foobar")),
    "Could not find DESCRIPTION fields.*versionx.*foobar"
  )
})

test_that("set works", {
  desc <- description$new(test_path("D1"))
  expect_equal(desc$get("Package"), c(Package = "desc"))

  desc$set(Package = "foobar")
  expect_equal(desc$get("Package"), c(Package = "foobar"))

  desc$set("Package", "foo")
  expect_equal(desc$get("Package"), c(Package = "foo"))

  desc$set(Version = "100.0", Author = "Bugs Bunny")
  expect_equal(desc$get("Version"), c(Version = "100.0"))
  expect_equal(desc$get("Author"), c(Author = "Bugs Bunny"))

  desc$set("Description", "Foo\n  foobar\n  foobar2.")
  expect_equal(desc$get("Description"),
               c(Description = "Foo\n  foobar\n  foobar2."))
})

test_that("get with non-exixting fields", {
  desc <- description$new(test_path("D1"))
  expect_equal(desc$get("foobar"), c(foobar = NA_character_))
})

test_that("del works", {
  desc <- description$new(test_path("D1"))
  desc$del("Package")
  expect_equal(desc$get("Package"), c(Package = NA_character_))
  expect_false(is.na(desc$get("Title")))
})

test_that("set errors on invalid input", {

  desc <- description$new(test_path("D1"))
  expect_error(
    desc$set("foobar"),
    "needs two unnamed args"
  )
})

test_that("get_list, set_list", {
  desc <- description$new(test_path("D1"))
  desc$set(foo = "  this, is   a, \n   list")
  expect_equal(
    desc$get_list("foo"),
    c("this", "is a", "list")
  )
  expect_equal(
    desc$get_list("foo", trim_ws = FALSE, squish_ws = TRUE),
    c(" this", " is a", " list")
  )
  expect_equal(
    desc$get_list("foo", trim_ws = TRUE, squish_ws = FALSE),
    c("this", "is   a", "list")
  )
  expect_equal(
    desc$get_list("foo", trim_ws = FALSE, squish_ws = FALSE),
    c("  this", " is   a", " \n   list")
  )

  desc$set_list("key", c("this", "that"))
  expect_equal(desc$get_list("key"), c("this", "that"))
})

test_that("DCF reader works", {
  desc <- description$new(test_path("D1"))

  expect_equal(desc$get("Package"), c(Package = "desc"))
  expect_equal(desc$get("Version"), c(Version = "1.0.0"))
  expect_equal(desc$get("Author"), c(Author = "G\u00e1bor Cs\u00e1rdi"))
  expect_equal(desc$get("Imports"), c(Imports = "\n    R6"))
})

test_that("DCF reader keeps whitespace", {
  desc <- description$new(test_path("D1"))

  expect_equal(desc$get("Suggests"), c(Suggests = "\n    testthat"))
  expect_equal(desc$get("Description"), c(
    Description = paste0(
      "Tools to read, write, create, and manipulate DESCRIPTION\n",
      "    files. It is intented for packages that create or manipulate other\n",
      "    packages."
    )
  ))

})

test_that("duplicate fields, #43", {
  expect_error(
    description$new(test_path("D5")),
    "Duplicate DESCRIPTION fields.*Remotes"
  )
})

test_that("empty lines error", {
  expect_error(
    description$new(test_path("D12")),
    "Empty lines found in DESCRIPTION file"
  )
})

test_that("Empty DESCRIPTION", {
  expect_error(description$new(text = ""), NA)
  expect_error(description$new(text = character()), NA)
})

test_that("desc_add_author", {
  d <- temp_desc()
  on.exit(unlink(d))
  x <- desc_add_author(file = d, "Bunny", "Bugs", "bugs.bunny@acme.com")
  expect_match(desc_get(file = d, "Authors@R"), "Bunny")
})

test_that("desc_add_me", {
  withr::local_envvar(
    FULLNAME = "First Last",
    EMAIL = "first.last@dom.com"
  )

  d <- temp_desc()
  on.exit(unlink(d))
  desc_add_me(file = d)

  expect_match(desc_get(file = d, "Authors@R"), "First")
  expect_match(desc_get(file = d, "Authors@R"), "first.last@dom.com")
})

test_that("desc_add_author_gh", {
  withr::local_options(
    desc.gh_user = list(name = "Jeroen Ooms", email = "notanemail")
  )
  d <- temp_desc()
  on.exit(unlink(d))
  desc_add_author_gh(file = d,
                     username = "jeroen")

  expect_match(desc_get(file = d, "Authors@R"), "Jeroen")
  expect_match(desc_get(file = d, "Authors@R"), "notanemail")
})

test_that("desc_add_role", {
  d <- temp_desc()
  on.exit(unlink(d))
  x <- desc_add_role(file = d, "ctb", given = "Manuel")
  expect_match(
    as.character(desc_get_author(file = d, role = "ctb")),
    "Manuel"
  )
})

test_that("desc_add_to_collate et al.", {
  d <- temp_desc()
  on.exit(unlink(d))
  expect_true("roxygenize.R" %in% desc_get_collate(file = d))
  x <- desc_del_from_collate(file = d, "roxygenize.R")
  expect_false("roxygenize.R" %in% desc_get_collate(file = d))
  x <- desc_add_to_collate(file = d, "roxygenize.R")
  expect_true("roxygenize.R" %in% desc_get_collate(file = d))
})

test_that("desc_get_maintainer, desc_change_maintainer", {
  d <- temp_desc()
  on.exit(unlink(d))
  expect_match(
    as.character(desc_get_maintainer(file = d)),
    "Hadley"
  )
  x <- desc_change_maintainer(file = d, given = "Peter")
  expect_match(
    as.character(desc_get_maintainer(file = d)),
    "Peter"
  )
})

test_that("desc_set, desc_get, desc_del", {
  d <- temp_desc()
  on.exit(unlink(d))
  expect_equal(
    desc_get(file = d, c("Package", "Version")),
    c(Package = "roxygen2", Version = "4.1.1.9000")
  )
  desc_set(file = d, Package = "foobar")
  expect_equal(
    desc_get(file = d, c("Package", "Version")),
    c(Package = "foobar", Version = "4.1.1.9000")
  )
})

test_that("desc_del_author", {
  d <- temp_desc()
  on.exit(unlink(d))
  desc_del_author(file = d, given = "Peter")
  expect_false(
    any(grepl("Peter", as.character(desc_get_authors(file = d))))
  )
})

test_that("desc_del_collate", {
  d <- temp_desc()
  on.exit(unlink(d))
  desc_del_collate(file = d)
  expect_equal(
    desc_get(file = d, "Collate"),
    c(Collate = NA_character_)
  )
})

test_that("desc_del_dep", {
  d <- temp_desc()
  on.exit(unlink(d))
  expect_true(
    "testthat" %in% desc_get_deps(file = d)$package
  )
  desc_del_dep(file = d, "testthat")
  expect_false(
    "testthat" %in% desc_get_deps(file = d)$package
  )
})

test_that("desc_del_deps", {
  d <- temp_desc()
  on.exit(unlink(d))
  desc_del_deps(file = d)
  expect_equal(nrow(desc_get_deps(file = d)), 0)
})

test_that("desc_del_role", {
  d <- temp_desc()
  on.exit(unlink(d))
  desc_del_role(file = d, "aut", given = "Manuel")
  expect_false(
    any(grepl("Manuel", desc_get_author(file = d, role = "aut")))
  )
})

test_that("desc_fields", {
  d <- temp_desc()
  on.exit(unlink(d))
  expect_true(
    all(c("Package", "Title", "Version", "URL", "Collate") %in%
        desc_fields(file = d))
  )
})

test_that("desc_has_fields", {
  d <- temp_desc()
  on.exit(unlink(d))
  expect_equal(
    desc_has_fields(file = d, c("Package", "foobar", "Collate")),
    c(TRUE, FALSE, TRUE)
  )
})

test_that("desc_normalize", {
  d <- temp_desc()
  on.exit(unlink(d))
  desc <- description$new(d)
  desc_normalize(file = d)
  desc$normalize()

  d2 <- tempfile()
  on.exit(unlink(d2), add = TRUE)
  desc$write(d2)
  expect_equal(readLines(d), readLines(d2))
})

test_that("desc_print", {
  d <- temp_desc()
  on.exit(unlink(d))
  capt <- capture.output(description$new(test_path("D2"))$print())
  expect_output(
    desc_print(file = d),
    paste(capt, collapse = "\n"),
    fixed = TRUE
  )
})

test_that("desc_reformat_fields", {
  d <- temp_desc()
  on.exit(unlink(d))
  desc_reformat_fields(file = d)
  expect_equal(
    desc_get(file = d, "Description"),
    description$new(test_path("D2"))$reformat_fields()$get("Description")
  )
})

test_that("desc_reorder_fields", {
  d <- temp_desc()
  on.exit(unlink(d))
  desc_reorder_fields(file = d)
  expect_equal(
    desc_fields(file = d),
    c("Package", "Title", "Version", "Authors@R", "Description",
      "License", "URL", "Depends", "Imports", "Suggests", "LinkingTo",
      "VignetteBuilder", "Remotes", "Encoding", "RoxygenNote", "Collate")
  )
})

test_that("desc_set_authors", {
  d <- temp_desc(test_path("D1"))
  on.exit(unlink(d))
  desc_set_authors(file = d, desc_get_authors(file = test_path("D2")))
  expect_equal(
    desc_get_authors(file = d),
    desc_get_authors(test_path("D2"))
  )
})

test_that("desc_set_collate", {
  d <- temp_desc()
  on.exit(unlink(d))
  desc_set_collate(file = d, c("foo.R", "bar.R"))
  expect_equal(
    desc_get_collate(file = d),
    c("foo.R", "bar.R")
  )
})

test_that("desc_set_dep", {
  d <- temp_desc()
  on.exit(unlink(d))
  desc_set_dep(file = d, "foobar", type = "Suggests")
  expect_true(
    "foobar" %in% desc_get_deps(file = d)$package
  )
})

test_that("desc_set_deps", {
  d <- temp_desc()
  on.exit(unlink(d))
  desc_set_deps(file = d, desc_get_deps(file = test_path("D1")))
  expect_equal(
    desc_get_deps(file = d),
    desc_get_deps(file = test_path("D1"))
  )
})

test_that("desc_to_latex", {
  expect_equal(
    desc_to_latex(file = test_path("D2")),
    description$new(test_path("D2"))$to_latex()
  )
})

test_that("desc_validate", {
  expect_warning(
    desc_validate(file = test_path("D1")),
    "not implemented"
  )
})

test_that("can write back automatically found DESCRIPTION file", {
  dir.create(tmp <- tempfile())
  file.copy(file.path("files", "DESCRIPTION"), tmp)
  withr::with_dir(
    tmp,
    desc_set_dep("somepackage", "Suggests")
  )
  expect_true("somepackage" %in% desc_get_deps(file = tmp)$package)
})

test_that("get built", {
  desc <- description$new(test_path("D4"))
  expect_identical(
    desc$get_built(),
    list(R = R_system_version("3.4.1"),
      Platform = "x86_64-apple-darwin15.6.0",
      Date = "2017-09-14 20:30:19 UTC",
      OStype = "unix")
  )
})

test_that("corrupted Build field", {
  desc <- description$new("!new")
  desc$set(Built = "foobar")
  expect_error(desc$get_built(), "corrupted")
})

test_that("dependencies are not reformatted if new value is the same", {

  desc <- description$new(test_path("D1"))
  desc$set("Imports", "R6")
  before <- desc$get("Imports")
  desc$set_dep("R6")
  after <- desc$get("Imports")
  expect_equal(before, after)
  
  desc <- description$new(test_path("D1"))
  desc$set("Imports", "R6")
  before <- desc$get("Imports")
  desc$set_deps(data.frame(package = "R6", type = "Imports", version = "*"))
  after <- desc$get("Imports")
  expect_equal(before, after)
})


test_that("collate fields are not reformatted if new value is the same", {

  desc <- description$new(test_path("D1"))
  desc$set("Collate", "'foo.R' 'bar.R' foobar.R")
  before <- desc$get("Collate")
  desc$set_collate(desc$get_collate())
  after <- desc$get("Collate")
  expect_equal(before, after)
})

test_that("No WS is kept if field is not modified", {
  d <- description$new(test_path("D3"))
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  d$write(tmp)
  expect_equal(readLines(test_path("D3")), readLines(tmp))
})

test_that("WS is present in newly created fields", {
  d <- description$new(test_path("D3"))
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  d$set("Foobar" = "\n    TRAZ")
  d$write(tmp)
  contents <- paste0(paste0(readLines(tmp), collapse = "\n"), "\n")
  expect_match(contents, "\nFoobar: \n    TRAZ\n")
})

test_that("WS is present in newly created files", {
  desc <- description$new("!new")
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  desc$write(tmp)
  contents <- paste0(readLines(tmp), collapse = "\n")
  expect_match(contents, "\nAuthors@R: \n")
})

test_that("WS is added if field is changed", {
  d <- description$new(test_path("D3"))
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  d$set(Author = "Gabor Csardi <foo@bar.com>")
  d$write(tmp)
  contents <- paste0(readLines(tmp), collapse = "\n")
  expect_match(contents, "Author: ")
})

test_that("No WS is added if an other field is changed", {
  d <- description$new(test_path("D3"))
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  d$add_author("Gabor", "Csardi", "foo@bar.com")
  d$write(tmp)
  contents <- paste0(readLines(tmp), collapse = "\n")
  expect_match(contents, "Imports:\n")
})

test_that("can write to file", {

  desc <- description$new("!new")
  tmp <- tempfile()
  desc$write(tmp)

  desc2 <- description$new(tmp)
  expect_equal(desc$str(), desc2$str())

})

test_that("normalization while writing to file", {

  desc <- description$new("!new")
  desc$set("Imports", "foo, bar, foobar")

  tmp <- tempfile()
  desc$write(tmp)

  desc$normalize()

  desc2 <- description$new(tmp)
  expect_equal(desc$str(), desc2$str())
})

test_that("whitespace after : if field was updated", {

  on.exit(unlink(c(t1, t2), recursive = TRUE), add = TRUE)

  ## Space is kept if it was there
  desc <- description$new(text = "Imports: \n    one,\n    two\n")
  desc$set_dep("ugh")
  desc$write(t1 <- tempfile())

  expect_equal(
    readLines(t1),
    c("Imports: ", "    one,", "    two,", "    ugh")
  )

  ## Space is not added if it was not there
  desc <- description$new(text = "Imports:\n    one,\n    two\n")
  desc$set_dep("ugh")
  desc$write(t2  <- tempfile())

  expect_equal(
    readLines(t2),
    c("Imports:", "    one,", "    two,", "    ugh")
  )
})

test_that("set_collate and get_collate work", {
  desc <- description$new(test_path("D1"))

  files <- c("foo.R", "bar.R", "foobar.R")
  desc$set_collate(files)

  expect_equal(desc$get_collate(), files)
  expect_equal(desc$get_collate(which = "windows"), character())
  expect_equal(desc$get_collate(which = "unix"), character())

  files2 <- c(files, "foo-win.R")
  desc$set_collate(files2, which = "windows")

  expect_equal(desc$get_collate("windows"), files2)
  expect_equal(desc$get_collate(which = "main"), files)
  expect_equal(desc$get_collate(which = "unix"), character())

  files3 <- c(files, "foo-unix.R")
  desc$set_collate(files3, which = "unix")

  expect_equal(desc$get_collate(which = "unix"), files3)
  expect_equal(desc$get_collate(which = "windows"), files2)
  expect_equal(desc$get_collate(which = "main"), files)

})

test_that("del_collate works", {
  desc <- description$new(test_path("D1"))

  files <- c("foo.R", "bar.R", "foobar.R")
  files2 <- c(files, "foo-win.R")
  files3 <- c(files, "foo-unix.R")

  desc$set_collate(files, which = "main")
  desc$set_collate(files2, which = "windows")
  desc$set_collate(files3, which = "unix")

  desc$del_collate(which = "windows")

  expect_equal(desc$get_collate(which = "windows"), character())
  expect_equal(desc$get_collate(which = "main"), files)
  expect_equal(desc$get_collate(which = "unix"), files3)

  desc$del_collate()

  expect_equal(desc$get_collate(which = "windows"), character())
  expect_equal(desc$get_collate(which = "main"), character())
  expect_equal(desc$get_collate(which = "unix"), character())

})

test_that("add_to_collate works", {
  desc <- description$new(test_path("D1"))

  desc$add_to_collate("bar.R")
  expect_equal(desc$get_collate(), "bar.R")

  desc$add_to_collate("foo.R")
  expect_equal(desc$get_collate(), c("bar.R", "foo.R"))

  desc$add_to_collate("foobar.R", which = "windows")
  expect_equal(desc$get_collate(), c("bar.R", "foo.R"))
  expect_equal(desc$get_collate(which = "windows"), "foobar.R")

  desc$add_to_collate("foobar2.R")
  expect_equal(desc$get_collate(), c("bar.R", "foo.R", "foobar2.R"))
  expect_equal(desc$get_collate(which = "windows"),
               c("foobar.R", "foobar2.R"))

})

test_that("del_from_collate works", {
  desc <- description$new(test_path("D1"))

  files <- c("foo.R", "bar.R", "foobar.R")
  files2 <- c(files, "foo-win.R")
  files3 <- c(files, "foo-unix.R")

  desc$set_collate(files, which = "main")
  desc$set_collate(files2, which = "windows")
  desc$set_collate(files3, which = "unix")

  desc$del_from_collate("foo.R")

  expect_equal(desc$get_collate(which = "main"), c("bar.R", "foobar.R"))
  expect_equal(desc$get_collate(which = "windows"),
               c("bar.R", "foobar.R", "foo-win.R"))
  expect_equal(desc$get_collate(which = "unix"),
               c("bar.R", "foobar.R", "foo-unix.R"))

  desc$del_from_collate("bar.R", which = "windows")

  expect_equal(desc$get_collate(which = "main"), c("bar.R", "foobar.R"))
  expect_equal(desc$get_collate(which = "windows"),
               c("foobar.R", "foo-win.R"))
  expect_equal(desc$get_collate(which = "unix"),
               c("bar.R", "foobar.R", "foo-unix.R"))

})

test_that("add to all collate fields", {

  desc <- description$new(test_path("D1"))
  desc$set_collate(c("f1.R", "f2.R"), which = "main")
  desc$set_collate(c("f3.R", "f4.R"), which = "win")
  desc$add_to_collate("f5.R", which = "all")

  expect_equal(
    desc$get_collate(which = "main"),
    c("f1.R", "f2.R", "f5.R")
  )
  expect_equal(
    desc$get_collate(which = "win"),
    c("f3.R", "f4.R", "f5.R")
  )
})

test_that("deleting from non-existing collate does nothing", {

  desc <- description$new(test_path("D1"))
  expect_silent(desc$del_from_collate('foo.R'))
})

test_that("str orders fields", {
  desc <- description$new("!new")

  desc$del("Package")
  desc$set("Package", "foobar")

  expect_match(cli::ansi_strip(desc$str()), "^Package:")
})

test_that("str formats some fields specially", {
  desc <- description$new("!new")

  desc$set("Imports", "pkg1, pkg2, \n pkg3, pkg4")
  expect_match(
    cli::ansi_strip(desc$str()),
    "Imports:\n    pkg1,\n    pkg2,\n    pkg3,\n    pkg4"
  )

  desc$set("Collate", "file1.R 'file2.R' 'file with spaces.R' file4.R")
  expect_match(
    cli::ansi_strip(desc$str()),
    "Collate:\n    'file1.R'\n    'file2.R'\n    'file with spaces.R'\n    'file4.R'"
  )
})

test_that("str formats authors properly", {

  desc <- description$new(test_path("D2"))

  expect_snapshot(
    cat(cli::ansi_strip(desc$str(by_field = TRUE)[["Authors@R"]]))
  )
})

test_that("authors are printed to the screen properly", {

  desc <- description$new(test_path("D2"))

  expect_output(
    print(desc),
    "(parsed):
    * Hadley Wickham <h.wickham@gmail.com> [aut, cre, cph]
    * Peter Danenberg <pcd@roxygen.org> [aut, cph]
    * Manuel Eugster [aut, cph]
    * RStudio [cph]",
    fixed = TRUE
  )

})

test_that("continuation lines", {
  desc <- description$new(test_path("D7"))
  t1 <- desc$str(normalize = TRUE)
  t2 <- desc$str(normalize = FALSE)
  expect_false(grepl("\n[ \t]*\n", t1))
  expect_false(grepl("\n[ \t]*\n", t2))
})

collate_fields <- c(
  main = "Collate",
  windows = "Collate.windows",
  unix = "Collate.unix"
)

field_classes <- list(

  Package = "Package",
  Version = "Version",
  License = "License",
  Description = "Description",
  Title = "Title",
  Maintainer = "Maintainer",
  AuthorsAtR = "Authors@R",

  DependencyList = c("Imports", "Suggests", "Depends", "Enhances",
    "LinkingTo"),
  PackageList = c("VignetteBuilder", "RdMacros"),
  Remotes = "Remotes",
  RepoList = "Additional_repositories",
  URL = "BugReports",
  URLList = "URL",
  Priority = "Priority",
  Collate = unname(collate_fields),
  Logical = c("LazyData", "KeepSource", "ByteCompile", "ZipData", "Biarch",
    "BuildVignettes", "NeedsCompilation", "License_is_FOSS",
    "License_restricts_use", "BuildKeepEmpty", "BuildManual",
    "BuildResaveData", "LazyLoad"),
  Encoding = "Encoding",
  OSType = "OS_type",
  Type = "Type",
  Classification = c("Classification/ACM", "Classification/ACM-2012",
    "Classification/JEL", "Classification/MSC", "Classification/MSC-2010"),
  Language = "Language",
  Date = "Date",
  Compression = c("LazyDataCompression", "SysDataCompression"),
  Repository = "Repository",

  FreeForm = c("Author", "SystemRequirements",
    "Archs", "Contact", "Copyright", "MailingList", "Note", "Path",
    "LastChangedDate", "LastChangedRevision", "Revision", "RcmdrModels",
    "RcppModules", "Roxygen", "Acknowledgements", "Acknowledgments",
    "biocViews"),

  AddedByRCMD = c("Built", "Packaged", "MD5sum", "Date/Publication")
)

field_classes$FreeForm <- c(
  field_classes$FreeForm,
  paste0(unlist(field_classes), "Note")
)

create_fields <- function(keys, values) {
  # Need to add names explicitly, because mapply() might drop them
  # https://bugs.r-project.org/show_bug.cgi?id=18201
  structure(
    mapply(keys, values, SIMPLIFY = FALSE, FUN = create_field),
    names = keys
  )
}

create_field <- function(key, value) {
  f <- structure(list(key = key, value = value), class = "DescriptionField")
  if (key %in% unlist(field_classes)) {
    cl <- paste0("Description", find_field_class(key))
    class(f) <- c(cl, class(f))
  }
  f
}

find_field_class <- function(k) {
  names(which(vapply(field_classes, `%in%`, logical(1), x = k)))
}

# deparse_authors_at_r

    Code
      readLines(tmp)
    Output
      [1] "Authors@R: "                                                                              
      [2] "    person(\"Hadley\", \"Wickham\", , \"hadley@rstudio.com\", role = c(\"aut\", \"cre\"),"
      [3] "           comment = c(ORCID = \"0000-0003-4757-117X\"))"                                 

---

    Code
      readLines(tmp)
    Output
      [1] "Authors@R: c("                                                                            
      [2] "    person(\"Hadley\", \"Wickham\", , \"hadley@rstudio.com\", role = c(\"aut\", \"cre\"),"
      [3] "           comment = c(ORCID = \"0000-0003-4757-117X\")),"                                
      [4] "    person(\"Jennifer\", \"Bryan\", , \"jenny@rstudio.com\", role = \"aut\","             
      [5] "           comment = c(ORCID = \"0000-0002-6983-2759\")),"                                
      [6] "    person(\"RStudio\", role = c(\"cph\", \"fnd\"))"                                      
      [7] "  )"                                                                                      

# str formats authors properly

    Code
      cat(cli::ansi_strip(desc$str(by_field = TRUE)[["Authors@R"]]))
    Output
      Authors@R:c(
          person("Hadley", "Wickham", , "h.wickham@gmail.com", role = c("aut", "cre", "cph")),
          person("Peter", "Danenberg", , "pcd@roxygen.org", role = c("aut", "cph")),
          person("Manuel", "Eugster", role = c("aut", "cph")),
          person("RStudio", role = "cph")
        )

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_del_remotes}
\alias{desc_del_remotes}
\title{Delete locations from the Remotes field in DESCRIPTION}
\usage{
desc_del_remotes(pattern, file = ".", normalize = FALSE)
}
\arguments{
\item{pattern}{Perl-compatible regular expression, all locations
matching this expression will be deleted.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
All locations matching the specified pattern are deleted.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_get_deps}
\alias{desc_get_deps}
\title{List all package dependencies from a DESCRIPTION file}
\usage{
desc_get_deps(file = ".")
}
\arguments{
\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}
}
\value{
Data frame with columns: \code{type} (dependency type),
\code{package}, and \code{version}. For non-versioned dependencies
\code{version} is \code{*}.
}
\description{
List all package dependencies from a DESCRIPTION file
}
\seealso{
Other dependencies: 
\code{\link{desc_del_deps}()},
\code{\link{desc_del_dep}()},
\code{\link{desc_has_dep}()},
\code{\link{desc_set_deps}()},
\code{\link{desc_set_dep}()}
}
\concept{dependencies}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_get_built}
\alias{desc_get_built}
\title{Query the built field in DESCRIPTION}
\usage{
desc_get_built(file = ".", normalize = FALSE)
}
\arguments{
\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\value{
A list with fields \code{R}, \code{Platform}, \code{Date},
\code{OStype}.
}
\description{
If the file has no \code{Built} field then it throws an error.
}
\concept{built}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_validate}
\alias{desc_validate}
\title{Validate a DESCRIPTION file}
\usage{
desc_validate(file = ".")
}
\arguments{
\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}
}
\description{
This function is not implemented yet.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_add_author}
\alias{desc_add_author}
\title{Add an author to Authors@R in DESCRIPTION}
\usage{
desc_add_author(
  given = NULL,
  family = NULL,
  email = NULL,
  role = NULL,
  comment = NULL,
  orcid = NULL,
  file = ".",
  normalize = FALSE
)
}
\arguments{
\item{given}{Given name.}

\item{family}{Family name.}

\item{email}{Email address.}

\item{role}{Role.}

\item{comment}{Comment.}

\item{orcid}{ORCID.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
Add an author to Authors@R in DESCRIPTION
}
\seealso{
Other Authors@R: 
\code{\link{desc_add_author_gh}()},
\code{\link{desc_add_me}()},
\code{\link{desc_add_orcid}()},
\code{\link{desc_add_role}()},
\code{\link{desc_change_maintainer}()},
\code{\link{desc_coerce_authors_at_r}()},
\code{\link{desc_del_author}()},
\code{\link{desc_del_role}()},
\code{\link{desc_get_authors}()},
\code{\link{desc_get_author}()},
\code{\link{desc_get_maintainer}()},
\code{\link{desc_set_authors}()}
}
\concept{Authors@R}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_add_me}
\alias{desc_add_me}
\title{Add the current user as an author to DESCRIPTION}
\usage{
desc_add_me(
  role = "ctb",
  comment = NULL,
  orcid = NULL,
  file = ".",
  normalize = FALSE
)
}
\arguments{
\item{role}{Role to set for the user, defaults to contributor.}

\item{comment}{Comment, empty by default.}

\item{orcid}{ORCID, empty by default.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
Uses the Authors@R field.
}
\details{
\code{desc_add_me} is a convenience function, it adds the
current user as an author, and it needs the
\code{whoami} package to be installed. It'll add your ORCID ID
if you provide it as argument or save it as \code{ORCID_ID} environment
variable in .Renviron.
The full name is parsed using
\code{as.person} and collapsing the given name and the family name
in order to e.g. have the first and middle names together as given
name. This approach might be limited to some full name structures.
}
\seealso{
Other Authors@R: 
\code{\link{desc_add_author_gh}()},
\code{\link{desc_add_author}()},
\code{\link{desc_add_orcid}()},
\code{\link{desc_add_role}()},
\code{\link{desc_change_maintainer}()},
\code{\link{desc_coerce_authors_at_r}()},
\code{\link{desc_del_author}()},
\code{\link{desc_del_role}()},
\code{\link{desc_get_authors}()},
\code{\link{desc_get_author}()},
\code{\link{desc_get_maintainer}()},
\code{\link{desc_set_authors}()}
}
\concept{Authors@R}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constants.R
\docType{data}
\name{dep_types}
\alias{dep_types}
\title{DESCRIPTION fields that denote package dependencies}
\format{
An object of class \code{character} of length 5.
}
\usage{
dep_types
}
\description{
Currently it has the following ones: Imports, Depends,
Suggests, Enhances and LinkingTo. See the \emph{Writing R Extensions}
manual for when to use which.
}
\seealso{
Other field types: 
\code{\link{cran_ascii_fields}},
\code{\link{cran_valid_fields}}
}
\concept{field types}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_set_authors}
\alias{desc_set_authors}
\title{Set authors in Authors@R, in DESCRIPTION}
\usage{
desc_set_authors(authors, file = ".", normalize = FALSE)
}
\arguments{
\item{authors}{Authors, to set, a person object, see \code{\link[utils:person]{utils::person()}}.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
Set authors in Authors@R, in DESCRIPTION
}
\seealso{
Other Authors@R: 
\code{\link{desc_add_author_gh}()},
\code{\link{desc_add_author}()},
\code{\link{desc_add_me}()},
\code{\link{desc_add_orcid}()},
\code{\link{desc_add_role}()},
\code{\link{desc_change_maintainer}()},
\code{\link{desc_coerce_authors_at_r}()},
\code{\link{desc_del_author}()},
\code{\link{desc_del_role}()},
\code{\link{desc_get_authors}()},
\code{\link{desc_get_author}()},
\code{\link{desc_get_maintainer}()}
}
\concept{Authors@R}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/description.R
\docType{class}
\name{description}
\alias{description}
\title{Read, write, update, validate DESCRIPTION files}
\format{
An R6 class.
}
\description{
Read, write, update, validate DESCRIPTION files
}
\section{Constructors}{


There are two ways of creating a description object. The first
is reading an already existing \code{DESCRIPTION} file; simply give
the name of the file as an argument. The default is \code{DESCRIPTION}:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{x <- description$new()
x2 <- description$new("path/to/DESCRIPTION")
}\if{html}{\out{</div>}}

The second way is creating a description object from scratch,
supply \code{"!new"} as an argument to do this.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{x3 <- description$new("!new")
}\if{html}{\out{</div>}}

The complete API reference:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$new(cmd = NULL, file = NULL, text = NULL,
    package = NULL)
}\if{html}{\out{</div>}}
\itemize{
\item \code{cmd}: a command to create a description from scratch.
Currently only \code{"!new"} is implemented. If it does not start
with an exclamation mark, it will be interpreted as a \code{file}
argument.
\item \code{file}: name of the \code{DESCRIPTION} file to load. If it is
a directory, then we assume that it is inside an R package and
conduct a search for the package root directory, i.e. the first
directory up the tree that contains a \code{DESCRIPTION} file.
If \code{cmd}, \code{file}, \code{text} and \code{package} are all \code{NULL} (the default),
then the search is started from the working directory. The file can
also be an R package (source, or binary), in which case the
\code{DESCRIPTION} file is extracted from it, but note that in this case
\verb{$write()} cannot write the file back in the package archive.
\item \code{text}: a character scalar containing the full DESCRIPTION.
Character vectors are collapsed into a character scalar, with
newline as the separator.
\item \code{package}: if not NULL, then the name of an installed package
and the DESCRIPTION file of this package will be loaded.
}
}

\section{Setting and Querying fields}{

Set a field with \verb{$set} and query it with \verb{$get}:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{x <- description$new("!new")
x$get("Package")
x$set("Package", "foobar")
x$set(Title = "Example Package for 'description'")
x$get("Package")
}\if{html}{\out{</div>}}

Note that \verb{$set} has two forms. You can either give the field name
and new value as two arguments; or you can use a single named argument,
the argument name is the field name, the argument value is the field
value.

The \verb{$fields} method simply lists the fields in the object:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{x$fields()
}\if{html}{\out{</div>}}

The \verb{$has_fields} method checks if one or multiple fields are
present in a description object:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{x$has_fields("Package")
x$has_fields(c("Title", "foobar"))
}\if{html}{\out{</div>}}

The \verb{$del} method removes the specified fields:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{x$set(foo = "bar")
x$del("foo")
}\if{html}{\out{</div>}}

\verb{$get_field} is similar to \verb{$get}, but it queries a single
field, it returns an unnamed vector if found, and returns the
specified \code{default} value if not. By default it throws an error
if the field is not found.

The complete API reference:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$get(keys)
description$get_field(key, default, trim_ws = TRUE, squish_ws = trim_ws)
description$set(..., check = TRUE)
description$fields()
description$has_fields(keys)
description$del(keys)
}\if{html}{\out{</div>}}
\itemize{
\item \code{key}: a character string (length one), the key to query.
\item \code{default}: If specified and \code{key} is missing, this value
is returned. If not specified, an error is thrown.
\item \code{trim_ws}: whether to trim leading and trailing whitespace
from the returned value.
\item \code{squish_ws}: whether to reduce repeated whitespace in the
returned value.
\item \code{keys}: a character vector of keys to query, check or delete.
\item \code{...}: this must be either two unnamed arguments, the key and
and the value to set; or an arbitrary number of named arguments,
names are used as keys, values as values to set.
\item \code{check}: A logical scalar. Whether to check the validity of the
new values.
}
}

\section{Normalizing}{

Format DESCRIPTION in a standard way. \verb{$str} formats each
field in a standard way and returns them (it does not change the
object itself), \verb{$print} is used to print it to the
screen. The \verb{$normalize} function normalizes each field (i.e.
it changes the object). Normalization means reformatting the fields,
via \verb{\{$reformat_fields()} and also reordering them via
\verb{$reorder_fields()}. The format of the various fields is
opinionated and you might like it or not. Note that \code{desc} only
re-formats fields that it updates, and only on demand, so if your
formatting preferences differ, you can still manually edit
\code{DESCRIPTION} and \code{desc} will respect your edits.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$str(by_field = FALSE, normalize = TRUE,
    mode = c("file", "screen"))
description$normalize()
description$reformat_fields()
description$reorder_fields()
description$print()
}\if{html}{\out{</div>}}
\itemize{
\item \code{by_field}: whether to return the normalized format
by field, or collapsed into a character scalar.
\item \code{normalize}: whether to reorder and reformat the fields.
\item \code{mode}: \code{file} mode formats the fields as they are
written to a file with the \code{write} method. \code{screen}
mode adds extra markup to some fields, e.g. formats the
\code{Authors@R} field in a readable way.
}
}

\section{Writing it to file}{

The \verb{$write} method writes the description to a file.
By default it writes it to the file it was created from, if it was
created from a file. Otherwise giving a file name is compulsory:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{x$write(file = "DESCRIPTION")
}\if{html}{\out{</div>}}

The API:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$write(file = NULL)
}\if{html}{\out{</div>}}
\itemize{
\item \code{file}: path to write the description to. If it was created
from a file in the first place, then it is written to the same
file. Otherwise this argument must be specified.
}
}

\section{Version numbers}{


\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$get_version()
description$set_version(version)
description$bump_version(which = c("patch", "minor", "major", "dev"))
}\if{html}{\out{</div>}}
\itemize{
\item \code{version}: a string or a \link[base:numeric_version]{base::package_version} object.
\item \code{which}: which component of the version number to increase.
See details just below.
}

These functions are simple helpers to make it easier to query, set and
increase the version number of a package.

\verb{$get_version()} returns the version number as a
\link[base:numeric_version]{base::package_version} object. It throws an error if the
package does not have a \code{Version} field.

\verb{$set_version()} takes a string or a \link[base:numeric_version]{base::package_version} object and
sets the \code{Version} field to it.

\verb{$bump_version()} increases the version number. The \code{which}
parameter specifies which component to increase.
It can be a string referring to a component: \code{major},
\code{minor}, \code{patch} or \code{dev}, or an integer
scalar, for the latter components are counted from one, and the
beginning. I.e. component one is equivalent to \code{major}.

If a component is bumped, then the ones after it are zeroed out.
Trailing zero components are omitted from the new version number,
but if the old version number had at least two or three components, then
the one will also have two or three.

The bumping of the \code{dev} version (the fourth component) is
special: if the original version number had less than four components,
and the \code{dev} version is bumped, then it is set to \code{9000}
instead of \code{1}. This is a convention often used by R developers,
it was originally invented by Winston Chang.

Both \verb{$set_version()} and \verb{$bump_version()} use dots to
separate the version number components.
}

\section{Dependencies}{

These functions handle the fields that define how the R package
uses another R packages. See \link{dep_types} for the
list of fields in this group.

The \verb{$get_deps} method returns all declared dependencies, in a
data frame with columns: \code{type}, \code{package} and \code{version}.
\code{type} is the name of the dependency field, \code{package} is the
name of the R package, and \code{version} is the required version. If
no specific versions are required, then this is a \code{"*"}.

The \verb{$set_deps} method is the opposite of \verb{$get_deps} and
it sets all dependencies. The input is a data frame, with the same
structure as the return value of \verb{$get_deps}.

The \verb{$has_dep} method checks if a package is included in the
dependencies. It returns a logical scalar. If \code{type} is not
\code{any}, then it has to match as well.

The \verb{$del_deps} method removes all declared dependencies.

The \verb{$set_dep} method adds or updates a single dependency. By
default it adds the package to the \code{Imports} field.

The API:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$set_dep(package, type = dep_types, version = "*")
description$set_deps(deps)
description$get_deps()
description$has_dep(package, type = c("any", dep_types))
description$del_dep(package, type = c("all", dep_types))
description$del_deps()
}\if{html}{\out{</div>}}
\itemize{
\item \code{package}: name of the package to add to or remove from the
dependencies.
\item \code{type}: dependency type, see \link{dep_types}. For
\verb{$del_dep} it may also be \code{"all"}, and then the package
will be deleted from all dependency types.
\item \code{version}: required version. Defaults to \code{"*"}, which means
no explicit version requirements.
\item \code{deps}: a data frame with columns \code{type}, \code{package} and
\code{version}. \verb{$get_deps} returns the same format.
}
}

\section{Collate fields}{

Collate fields contain lists of file names with R source code,
and the package has a separate API for them. In brief, you can
use \verb{$add_to_collate} to add one or more files to the main or
other collate field. You can use \verb{$del_from_collate} to remove
it from there.

The API:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$set_collate(files, which = c("main", "windows", "unix"))
description$get_collate(which = c("main", "windows", "unix"))
description$del_collate(which = c("all", "main", "windows", "unix"))
description$add_to_collate(files, which = c("default", "all", "main",
  "windows", "unix"))
description$del_from_collate(files, which = c("all", "main",
  "windows", "unix"))
}\if{html}{\out{</div>}}
\itemize{
\item \code{iles}: the files to add or remove, in a character vector.
\item \verb{which: which collate field to manipulate. }"default"\code{for}$add_to_collate` means all existing collate fields, or the
main one if none exist.
}
}

\section{Authors}{

There is a specialized API for the \code{Authors@R} field,
to add and remove authors, update their roles, change the maintainer,
etc.

The API:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$get_authors()
description$set_authors(authors)
description$get_author(role)
description$get_maintainer()
description$coerce_authors_at_r()
}\if{html}{\out{</div>}}
\itemize{
\item \code{authors}: a \code{person} object, a list of authors.
\item \code{role}: The role to query. See \code{person} for details.
}

\verb{$get_authors} returns a \code{person} object, the parsed
authors. See \code{\link[utils:person]{utils::person()}} for details.

\verb{$get_author} returns a \code{person} object, all authors with
the specified role.

\verb{$get_maintainer} returns the maintainer of the package. It works
with \code{Authors@R} fields and with traditional \code{Maintainer}
fields as well.

\verb{$coerce_authors_at_r} converts an \code{Author} field to one with
a \code{person} object. This coercion may be necessary for other
functions such as \verb{$get_authors}.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$add_author(given = NULL, family = NULL, email = NULL,
    role = NULL, comment = NULL, orcid = NULL)
description$add_me(role = "ctb", comment = NULL, orcid = NULL)
description$add_author_gh(username, role = "ctb", comment = NULL, orcid = NULL)
}\if{html}{\out{</div>}}

Add a new author. The arguments correspond to the arguments of the
\code{\link[utils:person]{utils::person()}} function. \code{add_me} is a convenience
function, it adds the current user as an author, and it needs the
\code{whoami} package to be installed. It'll add your ORCID ID
if you provide it as argument or save it as \code{ORCID_ID} environment
variable in .Renviron.
The full name is parsed by \code{add_me} and \code{add_author_gh} using
\code{as.person} and collapsing the given name and the family name
in order to e.g. have the first and middle names together as given
name. This approach might be limited to some full name structures.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$del_author(given = NULL, family = NULL, email = NULL,
    role = NULL, comment = NULL, orcid = NULL)
}\if{html}{\out{</div>}}

Remove an author, or multiple authors. The author(s) to be removed
can be specified via any field(s). All authors matching all
specifications will be removed. E.g. if only \code{given = "Joe"}
is supplied, then all authors whole given name matches \code{Joe} will
be removed. The specifications can be (PCRE) regular expressions.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$add_role(role, given = NULL, family = NULL, email = NULL,
    comment = NULL, orcid = NULL)
description$add_orcid(orcid, given = NULL, family = NULL, email = NULL,
    comment = NULL, role = NULL)
description$del_role(role, given = NULL, family = NULL, email = NULL,
    comment = NULL, orcid = NULL)
description$change_maintainer(given = NULL, family = NULL,
    email = NULL, comment = NULL, orcid = NULL)
}\if{html}{\out{</div>}}

\code{role} is the role to add or delete. The other arguments
are used to select a subset of the authors, on which the operation
is performed, similarly to \verb{$del_author}.
}

\section{URLs}{


We provide helper functions for manipulating URLs in the \code{URL}
field:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$get_urls()
description$set_urls(urls)
description$add_urls(urls)
description$del_urls(pattern)
description$clear_urls()
}\if{html}{\out{</div>}}
\itemize{
\item \code{urls}: character vector of URLs to set or add.
\item \code{pattern}: Perl compatible regular expression to specify the
URLs to be removed.
}

\verb{$get_urls()} returns all urls in a character vector. If no URL
fields are present, a zero length vector is returned.

\verb{$set_urls()} sets the URL field to the URLs specified in the
character vector argument.

\verb{$add_urls()} appends the specified URLs to the URL field. It
creates the field if it does not exists. Duplicate URLs are removed.

\verb{$del_urls()} deletes the URLs that match the specified pattern.

\verb{$clear_urls()} deletes all URLs.
}

\section{Remotes}{


\code{devtools}, \code{remotes} and some other packages support the
non-standard \code{Remotes} field in \code{DESCRIPTION}. This field
can be used to specify locations of dependent packages: GitHub or
BitBucket repositories, generic git repositories, etc. Please see the
\verb{Package remotes} vignette in the \code{devtools} package.

\code{desc} has helper functions for manipulating the \code{Remotes}
field:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{description$get_remotes()
description$get_remotes()
description$set_remotes(remotes)
description$add_remotes(remotes)
description$del_remotes(pattern)
description$clear_remotes()
}\if{html}{\out{</div>}}
\itemize{
\item \code{remotes}: character vector of remote dependency locations to
set or add.
\item \code{pattern}: Perl compatible regular expression to specify the
remote dependency locations to remove.
}

\verb{$get_remotes()} returns all remotes in a character vector.
If no URL fields are present, a zero length vector is returned.

\verb{$set_remotes()} sets the URL field to the Remotes specified in the
character vector argument.

\verb{$add_remotes()} appends the specified remotes to the
\code{Remotes} field. It creates the field if it does not exists.
Duplicate remotes are removed.

\verb{$del_remotes()} deletes the remotes that match the specified
pattern.

\verb{$clear_remotes()} deletes all remotes.
}

\section{Built}{


The \code{Built} field is used in binary packages to store information
about when and how a binary package was built.

\verb{$get_built()} returns the built information as a list with fields
\code{R}, \code{Platform}, \code{Date}, \code{OStype}. It throws an
error if the package does not have a \code{Built} field.
}

\section{Encodings}{

When creating a \code{description} object, \code{desc} observes the \code{Encoding}
field, if present, and uses the specified encoding to parse the file.
Internally, it converts all fields to UTF-8.

When writing a \code{description} object to a file, \code{desc} uses the
\code{Encoding} field (if present), and converts all fields to the specified
encoding.

We suggest that whenever you need to use non-ASCII characters in your
package, you use the UTF-8 encoding, for maximum portability.
}

\examples{
## Create a template
desc <- description$new("!new")
desc

## Read a file
desc2 <- description$new(file = system.file("DESCRIPTION",
                           package = "desc"))
desc2

## Remove a field
desc2$del("LazyData")

## Add another one
desc2$set(VignetteBuilder = "knitr")
desc2$get("VignetteBuilder")
desc2
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/desc-package.R
\docType{package}
\name{desc-package}
\alias{desc-package}
\alias{_PACKAGE}
\title{desc: Manipulate DESCRIPTION Files}
\description{
Tools to read, write, create, and manipulate DESCRIPTION files. It is intended for packages that create or manipulate other packages.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://desc.r-lib.org/}
  \item \url{https://github.com/r-lib/desc}
  \item Report bugs at \url{https://github.com/r-lib/desc/issues}
}

}
\author{
\strong{Maintainer}: Gábor Csárdi \email{csardi.gabor@gmail.com}

Authors:
\itemize{
  \item Kirill Müller
  \item Jim Hester \email{james.f.hester@gmail.com}
}

Other contributors:
\itemize{
  \item Maëlle Salmon (\href{https://orcid.org/0000-0002-2815-0399}{ORCID}) [contributor]
  \item Posit Software, PBC [copyright holder, funder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constants.R
\docType{data}
\name{cran_valid_fields}
\alias{cran_valid_fields}
\title{A list of DESCRIPTION fields that are valid according to the CRAN checks}
\format{
An object of class \code{character} of length 125.
}
\usage{
cran_valid_fields
}
\description{
A list of DESCRIPTION fields that are valid according to the CRAN checks
}
\seealso{
Other field types: 
\code{\link{cran_ascii_fields}},
\code{\link{dep_types}}
}
\concept{field types}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_get_version}
\alias{desc_get_version}
\title{Query the package version in DESCRIPTION}
\usage{
desc_get_version(file = ".")
}
\arguments{
\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}
}
\value{
A \link[base:numeric_version]{base::package_version} object.
}
\description{
If the file has no \code{Version} field, or it is an invalid
version string, then it throws an error.
}
\seealso{
Other version numbers: 
\code{\link{desc_bump_version}()},
\code{\link{desc_set_version}()}
}
\concept{version numbers}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/description.R
\name{desc}
\alias{desc}
\title{Read a DESCRIPTION file}
\usage{
desc(cmd = NULL, file = NULL, text = NULL, package = NULL)
}
\arguments{
\item{cmd}{A command to create a description from scratch.
Currently only \code{"!new"} is implemented. If it does not start
with an exclamation mark, it will be interpreted as the \code{file}
argument.}

\item{file}{Name of the \code{DESCRIPTION} file to load. If all of
\code{cmd}, \code{file} and \code{text} are \code{NULL} (the default), then the
\code{DESCRIPTION} file in the current working  directory is used.
The file can also be an R package (source, or
binary), in which case the \code{DESCRIPTION} file is extracted from it, but
note that in this case \verb{$write()} cannot write the file back in
the package archive.}

\item{text}{A character scalar containing the full DESCRIPTION.
Character vectors are collapsed into a character scalar, with
newline as the separator.}

\item{package}{If not NULL, then the name of an installed package
and the DESCRIPTION file of this package will be loaded.}
}
\description{
This is a convenience wrapper for \code{description$new()}.
Very often you want to read an existing \code{DESCRIPTION}
file, and to do this you can just supply the path to the file or its
directory to \code{desc()}.
}
\examples{
desc(package = "desc")
DESCRIPTION <- system.file("DESCRIPTION", package = "desc")
desc(DESCRIPTION)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_has_dep}
\alias{desc_has_dep}
\title{Check for a dependency}
\usage{
desc_has_dep(package, type = c("any", desc::dep_types), file = ".")
}
\arguments{
\item{package}{The package name.}

\item{type}{A dependency type or ``any`.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}
}
\value{
A logical scalar.
}
\description{
Check for a dependency
}
\seealso{
Other dependencies: 
\code{\link{desc_del_deps}()},
\code{\link{desc_del_dep}()},
\code{\link{desc_get_deps}()},
\code{\link{desc_set_deps}()},
\code{\link{desc_set_dep}()}
}
\concept{dependencies}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_get_field}
\alias{desc_get_field}
\alias{desc_get_or_fail}
\alias{desc_get_list}
\title{Get a single field from a DESCRIPTION file, fail if not found}
\usage{
desc_get_field(
  key,
  default = stop("Field '", key, "' not found"),
  trim_ws = TRUE,
  squish_ws = trim_ws,
  file = "."
)

desc_get_or_fail(keys, file = ".")

desc_get_list(
  key,
  default = stop("Field '", key, "' not found"),
  sep = ",",
  trim_ws = TRUE,
  squish_ws = trim_ws,
  file = "."
)
}
\arguments{
\item{key}{The field to query.}

\item{default}{Value to return if \code{key} is not found.
By default it throws an error.}

\item{trim_ws}{Whether to trim leading and trailing whitespace
from the value. Defaults to \code{TRUE}.}

\item{squish_ws}{Whether to reduce repeated whitespace in the value.
Defaults to \code{trim_ws}.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{keys}{Character vector of fields to get.}

\item{sep}{Separator string for \code{\link[=desc_get_list]{desc_get_list()}}.}
}
\value{
Character string, the value of \code{key}, or \code{default}
if \code{key} is not found and \code{default} is specified.
}
\description{
\code{desc_get_list()} parses a comma separated list into a character
vector.
}
\seealso{
Other simple queries: 
\code{\link{desc_del}()},
\code{\link{desc_fields}()},
\code{\link{desc_get}()},
\code{\link{desc_has_fields}()},
\code{\link{desc_set}()}
}
\concept{simple queries}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_add_orcid}
\alias{desc_add_orcid}
\title{Add an ORCID to one or more authors in Authors@R, in DESCRIPTION}
\usage{
desc_add_orcid(
  orcid,
  given = NULL,
  family = NULL,
  email = NULL,
  comment = NULL,
  role = NULL,
  file = ".",
  normalize = FALSE
)
}
\arguments{
\item{orcid}{orcid to add.}

\item{given}{Given name to filter on. Regular expression.}

\item{family}{Family name to filter on. Regular expression.}

\item{email}{Email address to filter on. Regular expression.}

\item{comment}{Comment field to filter on. Regular expression.}

\item{role}{Role field to filter on.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
The author(s) can be specified by a combination of the \code{given},
\code{family}, \code{email}, \code{comment} and \code{role} fields.
If multiple filters are specified, then all must match
to identify the author(s).
}
\seealso{
Other Authors@R: 
\code{\link{desc_add_author_gh}()},
\code{\link{desc_add_author}()},
\code{\link{desc_add_me}()},
\code{\link{desc_add_role}()},
\code{\link{desc_change_maintainer}()},
\code{\link{desc_coerce_authors_at_r}()},
\code{\link{desc_del_author}()},
\code{\link{desc_del_role}()},
\code{\link{desc_get_authors}()},
\code{\link{desc_get_author}()},
\code{\link{desc_get_maintainer}()},
\code{\link{desc_set_authors}()}
}
\concept{Authors@R}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_set_deps}
\alias{desc_set_deps}
\title{Set all package dependencies in DESCRIPTION}
\usage{
desc_set_deps(deps, file = ".", normalize = FALSE)
}
\arguments{
\item{deps}{Package dependency data frame, in the same format
returned by \code{\link[=desc_get_deps]{desc_get_deps()}}.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
Set all package dependencies in DESCRIPTION
}
\seealso{
Other dependencies: 
\code{\link{desc_del_deps}()},
\code{\link{desc_del_dep}()},
\code{\link{desc_get_deps}()},
\code{\link{desc_has_dep}()},
\code{\link{desc_set_dep}()}
}
\concept{dependencies}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_set}
\alias{desc_set}
\alias{desc_set_list}
\title{Set one or more fields in a DESCRIPTION file}
\usage{
desc_set(..., check = TRUE, file = ".", normalize = FALSE)

desc_set_list(key, list_value, sep = ", ", file = ".", normalize = FALSE)
}
\arguments{
\item{...}{Values to set, see details below.}

\item{check}{Whether to check the validity of the new fields.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}

\item{key}{Key to set in \code{desc_set_list()}.}

\item{list_value}{Character vector, to collapse in
\code{desc_set_list()}.}

\item{sep}{Separator string for \code{desc_set_list()} list fields.}
}
\description{
Set one or more fields in a DESCRIPTION file
}
\details{
\code{desc_set()} supports two forms, the first is two unnamed
arguments: the key and its value to set.

The second form requires named arguments: names are used as keys
and values as values to set.

\code{desc_set_list()} collapses a character vector into string,
separating the elements by commas.
}
\seealso{
Other simple queries: 
\code{\link{desc_del}()},
\code{\link{desc_fields}()},
\code{\link{desc_get_field}()},
\code{\link{desc_get}()},
\code{\link{desc_has_fields}()}
}
\concept{simple queries}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_get_maintainer}
\alias{desc_get_maintainer}
\title{Query the package maintainer in DESCRIPTION}
\usage{
desc_get_maintainer(file = ".")
}
\arguments{
\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}
}
\value{
A character scalar.
}
\description{
Either from the \code{Maintainer} or the \code{Authors@R} field.
}
\seealso{
Other Authors@R: 
\code{\link{desc_add_author_gh}()},
\code{\link{desc_add_author}()},
\code{\link{desc_add_me}()},
\code{\link{desc_add_orcid}()},
\code{\link{desc_add_role}()},
\code{\link{desc_change_maintainer}()},
\code{\link{desc_coerce_authors_at_r}()},
\code{\link{desc_del_author}()},
\code{\link{desc_del_role}()},
\code{\link{desc_get_authors}()},
\code{\link{desc_get_author}()},
\code{\link{desc_set_authors}()}
}
\concept{Authors@R}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/encoding.R
\name{check_encoding}
\alias{check_encoding}
\title{Check encoding of new or existing fields}
\usage{
check_encoding(self, private, new_fields)
}
\arguments{
\item{self}{Object.}

\item{private}{Private env.}

\item{new_fields}{New fields, or \code{NULL} to check existing fields.}
}
\value{
Object, invisibly.
}
\description{
If \code{new_fields} is \code{NULL}, then the existing
fields are checked. Otherwise \code{new_fields} are checked.
}
\details{
Warnings are given for non-ascii fields, if the \code{Encoding}
field is not set.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/syntax_checks.R
\name{check_field}
\alias{check_field}
\title{Syntactical check of a DESCRIPTION field}
\usage{
check_field(x, warn = FALSE, ...)
}
\arguments{
\item{x}{The field.}

\item{warn}{Whether to generate a warning if the syntax check fails.}

\item{...}{Additional arguments, they might be used in the future.}
}
\value{
\code{TRUE} if the field is syntactically correct,
otherwise a character vector, containing one or multiple
error messages.
}
\description{
Syntactical check of a DESCRIPTION field
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_bump_version}
\alias{desc_bump_version}
\title{Increase the version number in DESCRIPTION}
\usage{
desc_bump_version(which, file = ".", normalize = FALSE)
}
\arguments{
\item{which}{Which component to increase. See details below.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
The \code{which} parameter specifies which component to increase.
It can be a string referring to a component: \code{major},
\code{minor}, \code{patch} or \code{dev}, or an integer
scalar, for the latter components are counted from one, and the
beginning. I.e. component one is equivalent to \code{major}.
}
\details{
If a component is bumped, then the ones after it are zeroed out.
Trailing zero components are omitted from the new version number,
but if the old version number had at least two or three components, then
the one will also have two or three.

The bumping of the \code{dev} version (the fourth component) is
special: if the original version number had less than four components,
and the \code{dev} version is bumped, then it is set to \code{9000}
instead of \code{1}. This is a convention often used by R developers,
it was originally invented by Winston Chang.

Both \verb{$set_version()} and \verb{$bump_version()} use dots to
separate the version number components.
}
\seealso{
Other version numbers: 
\code{\link{desc_get_version}()},
\code{\link{desc_set_version}()}
}
\concept{version numbers}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_add_urls}
\alias{desc_add_urls}
\title{Add URLs to the URL field in DESCRIPTION}
\usage{
desc_add_urls(urls, file = ".", normalize = FALSE)
}
\arguments{
\item{urls}{Character vector of URLs to add. Duplicate URLs are
eliminated.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to normalize the write when writing back
the result. See \code{\link{desc_normalize}}.}
}
\description{
Add URLs to the URL field in DESCRIPTION
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_get_collate}
\alias{desc_get_collate}
\title{Query the Collate field in DESCRIPTION}
\usage{
desc_get_collate(which = c("main", "windows", "unix"), file = ".")
}
\arguments{
\item{which}{Which collate field to use. Collate fields can
be operating system type specific.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}
}
\value{
Character vector of file names.
}
\description{
Query the Collate field in DESCRIPTION
}
\seealso{
Other Collate field: 
\code{\link{desc_add_to_collate}()},
\code{\link{desc_del_collate}()},
\code{\link{desc_del_from_collate}()},
\code{\link{desc_set_collate}()}
}
\concept{Collate field}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_set_version}
\alias{desc_set_version}
\title{Set the package version in DESCRIPTION}
\usage{
desc_set_version(version, file = ".", normalize = FALSE)
}
\arguments{
\item{version}{A string or a \link[base:numeric_version]{base::package_version} object.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
Both \verb{$set_version()} and \verb{$bump_version()} use dots to
separate the version number components.
}
\seealso{
Other version numbers: 
\code{\link{desc_bump_version}()},
\code{\link{desc_get_version}()}
}
\concept{version numbers}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_add_to_collate}
\alias{desc_add_to_collate}
\title{Add one or more files to the Collate field, in DESCRIPTION}
\usage{
desc_add_to_collate(
  files,
  which = c("default", "all", "main", "windows", "unix"),
  file = ".",
  normalize = FALSE
)
}
\arguments{
\item{files}{Character vector, files to add.}

\item{which}{Which collate field to use. Collate fields can
be operating system type specific.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
Add one or more files to the Collate field, in DESCRIPTION
}
\seealso{
Other Collate field: 
\code{\link{desc_del_collate}()},
\code{\link{desc_del_from_collate}()},
\code{\link{desc_get_collate}()},
\code{\link{desc_set_collate}()}
}
\concept{Collate field}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_get_urls}
\alias{desc_get_urls}
\title{Query the URL field in DESCRIPTION}
\usage{
desc_get_urls(file = ".")
}
\arguments{
\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}
}
\value{
A character vectors or URLs. A length zero vector is returned
if there is no URL field in the package.
}
\description{
Query the URL field in DESCRIPTION
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_coerce_authors_at_r}
\alias{desc_coerce_authors_at_r}
\title{Coerce Author and Maintainer Fields to Authors@R}
\usage{
desc_coerce_authors_at_r(file = ".", normalize = FALSE)
}
\arguments{
\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
Convert the \code{Author} and \code{Maintainer} fields to
\code{Authors@R}, which is necessary for other functions such as
\code{desc_get_authors()}.
}
\details{
If the \code{Authors@R} field does not exist,
\code{desc_coerce_authors_at_r} tries to parse the \code{Author} and
\code{Maintainer} fields with \code{\link[utils:person]{utils::as.person()}} and writes
them to the \code{Authors@R} field.
Note that \code{Author} and \code{Maintainer} are free-form fields, so
parsing them may fail.
}
\seealso{
Other Authors@R: 
\code{\link{desc_add_author_gh}()},
\code{\link{desc_add_author}()},
\code{\link{desc_add_me}()},
\code{\link{desc_add_orcid}()},
\code{\link{desc_add_role}()},
\code{\link{desc_change_maintainer}()},
\code{\link{desc_del_author}()},
\code{\link{desc_del_role}()},
\code{\link{desc_get_authors}()},
\code{\link{desc_get_author}()},
\code{\link{desc_get_maintainer}()},
\code{\link{desc_set_authors}()}
}
\concept{Authors@R}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_clear_urls}
\alias{desc_clear_urls}
\title{Remove all URLs from the URL field of DESCRIPTION}
\usage{
desc_clear_urls(file = ".", normalize = FALSE)
}
\arguments{
\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
Remove all URLs from the URL field of DESCRIPTION
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_del_dep}
\alias{desc_del_dep}
\title{Remove a package dependency from DESCRIPTION}
\usage{
desc_del_dep(
  package,
  type = c("all", desc::dep_types),
  file = ".",
  normalize = FALSE
)
}
\arguments{
\item{package}{Package dependency to remove.}

\item{type}{Dependency type to remove. Sometimes a package is depended
on via multiple dependency types, e.g. \code{LinkingTo} and
\code{Imports}. Defaults to all types.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
Remove a package dependency from DESCRIPTION
}
\seealso{
Other dependencies: 
\code{\link{desc_del_deps}()},
\code{\link{desc_get_deps}()},
\code{\link{desc_has_dep}()},
\code{\link{desc_set_deps}()},
\code{\link{desc_set_dep}()}
}
\concept{dependencies}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_get}
\alias{desc_get}
\title{Get a field from a DESCRIPTION file}
\usage{
desc_get(keys, file = ".")
}
\arguments{
\item{keys}{Character vector of fields to get.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}
}
\value{
Character vector, values of the specified keys.
Non-existing keys return \code{NA}.
}
\description{
Get a field from a DESCRIPTION file
}
\seealso{
Other simple queries: 
\code{\link{desc_del}()},
\code{\link{desc_fields}()},
\code{\link{desc_get_field}()},
\code{\link{desc_has_fields}()},
\code{\link{desc_set}()}
}
\concept{simple queries}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_has_fields}
\alias{desc_has_fields}
\title{Check if some fields are present in a DESCRIPTION file}
\usage{
desc_has_fields(keys, file = ".")
}
\arguments{
\item{keys}{Character vector of keys to check.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}
}
\value{
Logical vector.
}
\description{
Check if some fields are present in a DESCRIPTION file
}
\seealso{
Other simple queries: 
\code{\link{desc_del}()},
\code{\link{desc_fields}()},
\code{\link{desc_get_field}()},
\code{\link{desc_get}()},
\code{\link{desc_set}()}
}
\concept{simple queries}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_add_remotes}
\alias{desc_add_remotes}
\title{Add locations in the Remotes field in DESCRIPTION}
\usage{
desc_add_remotes(remotes, file = ".", normalize = FALSE)
}
\arguments{
\item{remotes}{Character vector of remote locations to add.
Duplicate locations are eliminated. Note that existing locations
are not updated, so if you want to \emph{change} a remote location
of a package, you need to delete the old location first and then add
the new one.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
Add locations in the Remotes field in DESCRIPTION
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_set_dep}
\alias{desc_set_dep}
\title{Add a package dependency to a DESCRIPTION file}
\usage{
desc_set_dep(
  package,
  type = desc::dep_types,
  version = "*",
  file = ".",
  normalize = FALSE
)
}
\arguments{
\item{package}{Package to depend on.}

\item{type}{Dependency type.}

\item{version}{Version to depend on, for versioned dependencies.}

\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}

\item{normalize}{Whether to "normalize" (reorder and reformat) the fields when writing back
the result. See \code{\link[=desc_normalize]{desc_normalize()}}.}
}
\description{
Add a package dependency to a DESCRIPTION file
}
\seealso{
Other dependencies: 
\code{\link{desc_del_deps}()},
\code{\link{desc_del_dep}()},
\code{\link{desc_get_deps}()},
\code{\link{desc_has_dep}()},
\code{\link{desc_set_deps}()}
}
\concept{dependencies}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-oo-api.R
\name{desc_reformat_fields}
\alias{desc_reformat_fields}
\title{Reformat fields in a DESCRIPTION file}
\usage{
desc_reformat_fields(file = ".")
}
\arguments{
\item{file}{DESCRIPTION file to use. By default the DESCRIPTION
file of the current package (i.e. the package the working directory
is part of) is used.}
}
\description{
Reformat the fields in DESCRIPTION in a standard way.
}
\seealso{
Other repair functions: 
\code{\link{desc_normalize}()},
\code{\link{desc_reorder_fields}()}
}
\concept{repair functions}
